You can read online version of this file
English: http://code.google.com/p/conemu-maximus5/wiki/Whats_New?wl=en
Russian: http://code.google.com/p/conemu-maximus5/wiki/Whats_New?wl=ru
SVN: http://conemu-maximus5.googlecode.com/svn/trunk/ConEmu/Release/ConEmu/WhatsNew-ConEmu.txt

Please, vote for ConEmu
http://code.google.com/p/conemu-maximus5/wiki/Awards

*****************
«ExtendedConsole.dll» and «ExtendedConsole64.dll» now in ConEmu subfolder! Delete old files from old locations, if you are not using installer.
*****************


2012.12.25
[!] GuiMacro engine upgraded to avoid ambiguity. Now there are C-Strings and Verbatim-Strings.
    C-Strings: allows backslash-escape sequences, for example print("\ecd /d \"C:\\Users\"\n")
    Verbatim-Strings: allows using backslashes without escapes, for example print(@"cd /d ""C:\Users""")
[%] Due to a bug(?) in MS DOM saving GuiMacro with (Esc), for example print("\eexit\n"),
    was caused erasing of ConEmu.xml file contents.
[*] Group «Multi console» moved from «Tabs» page to «Appearance» page.
[+] New option «Show buttons (toolbar) in tab bar» on «Appearance» page.
[%] Issue 849: Transparency breaks on startup when «Hide caption» is on.
[*] Debug build. Menu item «Dump used memory blocks» in «Debug» submenu.
[*] Some internal changes.
[%] Some Attach from Far Plugin bugfixes.
[+] «App distinct» updated with new Cursor controls.
[+] Shift+Arrows may start selection (new option on «Mark & Paste» and «App distinct» pages).
    Shift+Left/Right starts text selection, Shift+Up/Down starts block selection.


2012.12.16
[+] Issue 846: New predefined color palette <Solarized>.
[%] Sometimes console was not resized after maximizing ConEmu window. TechInfo: because of larget font size in *real console*. Auto-reducing automatically when possible.
[%] Sometimes close console confirmation «Press Enter or Esc to close console» was bypassed.
[+] Cursor setting page was redesigned. Inactive cursor may be fully configured now. To be continued, some combinations not works yet.
[*] New settings page "Task bar". Some controls from "Appearance" page are here now.
[+] New option "Auto hide ConEmu after last console close". Must be used together with "Leave ConEmu after last console close".
[+] New ConEmu.exe switches:
    /MinTSA - almost like combination of "/Min /TSA" but implies "Leave ..." and "Auto hide after last console close".
    /SetDefTerm - forces installation of ConEmu as default terminal. May be useful with "/MinTSA /Detached".
[+] Now you can turn on "Register on OS startup" for "Default terminal" feature. "Integration" page.


2012.12.11
[+] Issue 824: Ctrl+BackSpace deletes word leftward to the cursor. Ignored in Far Manager. Hotkey is configurable.
    ATM takes care of «Change prompt with Left Click» third state.
[+] Issue 707: ConEmu Inside: WinXP: Trying to show «Tip pane» automatically and close it after ConEmu exits.
[+] Issue 838: New cursor type «Block». With «Color» checked ConEmu draws «empty» rectangle around cell under cursor.
[%] Issue 842: Far 3 build 3000: [string "if APanel.Left Keys("Tab") end"]:1: 'then' expected near 'Keys'.
[%] Some resize bugfixes.


2012.12.06
[*] Timeout for downloading files (Auto-Update) increased to 180 seconds.
[%] Issue 743: Sometimes Auto-Update fails via proxy.
[*] Refactoring of menus processing.
[+] Shell style Drag&Drop allows drops into inactive panes (split-screen).
    To be more exact pane will be activated on drag-over.
[%] Sometimes «Quake-style slide down» shows window without sliding.
[+] New file in ConEmu folder "TypeBuildErrors.cmd". This may be used for colorization errors and warnings in the compiler outputs.
[*] Some more information with "/log2".
[%] Issue 834: Too large FPS while using Far 2 truemod.
[*] Redesign of «Mark & Paste» settings page.


2012.11.28
[*] Some changes in console server & ExtendedConsole.dll.
[+] «Default terminal» - more flexible:
    * active config name used;
    * close confirmation configurable;
    * don't inject hooks configurable;
    * take care about started with debugging;
    * still available after GUI was closed;
    * "-new_console:z" may be used when you need to force real console instead of replacing as «default terminal».
[%] Issue 828: Auto-hidden taskbar and maximized ConEmu without Caption.


2012.11.25
[%] GCC warnings and errors.
[+] Empty passwords are allowed when «Run as user» (if they are allowed by local policy of course).
[+] When «Run as user» trying to use %USERPROFILE% instead of "System32".


2012.11.24
[!] Experimental! ConEmu may set up itself as default terminal for console applications.
    Warning! This feature may raise false alarms in some antiviral programs!
    Warning! Autoupdate with 7z package may fails if this feature is enabled!
    Settings -> Integration -> Force ConEmu...
    Note! In the current build active ConEmu window required for processing interception.
    TechInfo: When enabling this feature ConEmu calls CreateRemoteThread for injecting
    ConEmuHk.dll into selected processes (explorer.exe by default). This allows to
    intercept CreateProcess WinAPI function and replace it with ConEmu.exe...
    There is new ConEmu.exe switch "/nodefterm" - don't start initialization procedure.
[%] Issue 825: ANSI X3.64 sequences don't works with Gow ls.
[%] Issue 819: Regressions in hooks (build 121028).
[*] Options «Skip click on activation» applies to the click on the inactive split-pane.
[%] Issue 667: (May be fixed) ConEmu has incorrect Z-order in 'Vista Switcher'.
[%] Issue 827: Can't disable «Sleep in background».


2012.11.21
[+] Settings -> Keys & Macro. Checkbox «Hide unassigned» temporarily hides from list actions and macros without hotkeys.
[%] Issue 700: WinXP, Default history buffers count too small.


2012.11.19
[%] Bugfix. 10 sec delay when starting Quake-style or "/single" ConEmu.
[*] Apps+Tab and Apps+Shift+Tab switches between visible split-panes.
[+] New item in tab popup menu: Terminate -> Active group. Also available from System menu -> Active console.
[+] New hotkey (unassigned by default) for close of active group.


2012.11.18
[+] For debug purposes. User may define environment variable "ConEmuReportExe".
    ConEmuHk (when it is injected in the process with defined name) will show message box.
    It is right moment to take memory dump of this infiltrated process.
    For example (for cmd.exe command prompt):
    set ConEmuReportExe=sh.exe
    "C:\Program Files (x86)\Git\bin\sh.exe" --login -i
[%] Issue 811: Unable to change Highlight & goto shortcut.
[%] When «Don't close ConEmu on last console close» is on it was impossible to close empty ConEmu window.
[*] Split key macros (default as Ctrl+Shift+O & Ctrl+Shift+E) works now like «Duplicate root...» menu item.
[+] Settings page «Status bar» redesigned: two listboxes (available and selected) instead of checkboxes.
[%] Issue 814: макрос на переход по "гиперссылке" на ошибки компиляции в Far3 build 2949.
[+] New switch: "-new_console:t:tabname". Allows rename new created tab.
[+] GuiMacro: Tab(10,1) and Tab(10,-1) cycle switches visible split-panes.
[%] Issue 818: More DBCS console bugfixes.


2012.11.09
[+] Fast access to «Keys & Macro» (hotkeys) settings page. Win+Alt+K or SystemMenu -> Help -> Hotkeys.
[+] New hotkeys: Win+Alt+Del - close active tab, Win+F4 - close all tabs (same as «Cross» click).
[%] When closing tab from Win7 taskbar thumbnail - closing confirmation was not appears onscreen.
[+] New menu item «Duplicate root...» in tab menu. It tries to create new tab with root process and same directory/environment. Hotkey available but not assigned by default.


2012.11.08
[*] Settings: Group of controls «Automatic attach of cmd ...» moved to «ComSpec» page.
[+] New environment variables: "ConEmuDrawHWND" and "ConEmuBackHWND".
[+] HWND environment variables ("ConEmuHWND", "ConEmuDrawHWND", "ConEmuBackHWND") are processed
    when creating new console. For example, you may start gvim from cmd running in ConEmu:
	gvim --windowid !ConEmuBackHWND! -new_console:sH


2012.11.06
[+] New ConEmuC command: Export environment variables to parent processes.
    Syntax (case insensitive):
    ConEmuC /export[=CON|ALL] [Var1 [Var2 [...]]]
    VarN may contains one trailing/middle asterisk (sort of filemask support).
    /export - export to all processes of current console and ConEmu GUI
    /export=CON - export to all processes of current console only
    /export=ALL - export to all processes of opened tabs and ConEmu GUI
    * Note! This is experimental, «Inject ConEmuHk» required to set variables,
      some shells may ignores environment changes because of their features.
    * Shells comments: Far Manager & TCC/LE - OK; cmd - fails partially (required to run
      smth from active cmd, for example "cmd /k exit", to «apply» changes);
      bash - fails completely (seems, it does not support outside changing of env.vars).
[*] When «Hide caption» and «Frame width» >= resizable frame width - resizable frame used.


2012.11.04
[%] Issue 786: Failed to input Chinese in PuTTY.
[%] Resize bugfix: when maximizing scrolling window (e.g. "dir c:\ /s") «viewport» enlarges after delay.


2012.11.01
[+] Searching in full console (not only visible area). Checkbox «Freeze console» must be turned on. To be continued...
[%] Sometimes DosBox do not starts from Far command prompt (doom.exe -warp 10).
[+] Background: you may set «solid color». Just type in «Path» field ColorRef value
    (e.g. «#300A24» without quotas) instead of background picture file. Supported formats are:
    «#RRGGBB» (hex), «0xBBGGRR» (hex), «xBBGGRR» (hex), «RRR,GGG,BBB» (dec), «RRR GGG BBB» (dec).
[+] New predefined color scheme: <Ubuntu>. If you need purple background, set background color to #300A24 on «Main» page.
[*] Decided to change default hotkey for «Minimize/Restore» - it's now Ctrl+~.
[%] Issue 795: Reducing window size on Hide/Restore.


2012.10.29
[+] New option: Settings -> Status bar -> System colors.
[!] Issue 791: Rollback changes in «Run As Administrator».
[*] Issue 700: Forcing ConEmu's console to larger history buffer count.
    Small count causes «Up arrow don't work in prompt» for long console trees,
    for example: cmd -> Far -> ConEmuC -> cmd -> vim -> cmd -> ...
    Forcing values in HKEY_CURRENT_USER\Console\ConEmu:
    History buffer size - min=16, default=50; Count - min=16, default=32.
[+] In the Tasks popup menu (Win+N or down arrow near to [+]) you may RClick on the task and
    get submenu with task contents. You may click task command to start particular command.
[%] Issue 794: Names of renamed tabs should appear on taskbar.


2012.10.28
[!] Issue 526: Optimization of «Inject ConEmuHk». Hope on great speedup and no new bugs.
[*] Changed «Run As Administrator» startup style to avoid flickering of real console.
[%] Fixed default Far Manager macros for Lua (Far 3 build 2851).
[%] Sometimes "-new_console" was removed with excess spaces.
[+] *nix like «sudo» command. Batch file "%ConEmuBaseDir%\csudo.cmd".
    When checkbox «Add %ConEmuBaseDir% to %PATH%» is On («ComSpec» page),
    you may just type csudo in non-elevated prompt, for example:
    csudo dism /online /enable-feature /featurename:NetFX3 /All /Source:D:\sources\sxs /LimitAccess
[%] Some fixes in closing ConEmu window.


2012.10.22
[+] New default hotkeys: Ctrl+RClick - system menu, Shift+RClick - active tab menu.
[+] New GuiMacro.
    Menu(<Type>) - pop up System (Type=0) or Tab (Type=1) menu.
[+] Now you may use LButton, RButton, MButton in «Keys & Macro».
    Note. When you use Alt+Btn for Menu() - release Alt before Btn to avoid menu cancelling.
[+] Added default support of GIT-bash directory structure, read ConEmuFolders#MinGW_structure for details.
[%] Hiew32 fails to paste more than 1 char at once.


2012.10.20
[%] Filter had not works as expected on «Keys & Macro» page.
[*] Minor changes in ConEmu initialization process.
[*] Create new console dialog, field «Another user». Preferring build-in Administrator,
    another user from Administrators group, or just another user.
[%] Recreating console as another user did not works.
[+] Issue 767: «Tabs» page, if «Multiple consoles in one ConEmu window» is off
    then creating new tasks in new ConEmu window by default.
[+] New ConEmu.exe command line switch:
    /Palette <Name> - Choose named color palette.
[%] Issue 764: Enable same FG/BG color when BG color is background image.
[%] Issue 777: Resizing only works right from corners when «Pad size» is set.


2012.10.18
[*] Removing GCC warnings.
[+] Tasks page: New button «Active tabs» will add all current tabs into selected task.
[+] Button «No» in close confirmation dialog. It will close active console only.
[%] Confirmation dialog was not shown when single console was opened.
[*] Don't show «Press Enter or Esc to close console» after killing root process.
[%] Issue 774: ConEmu window size breaks when moved across monitors.
[%] Issue 775: Failed to update Windows 7 Jump list when no tasks are left in the list.


2012.10.16
[!] ConEmu on Reddit! http://redd.it/11k5oy Please, vote ;)
[*] Internal resize changes.
[%] Issue 736: ConEmu crashes on saving a task when creating the new one.
[%] Pasting CygWin paths fails.
[%] Fixes in «Extend foreground color with background».
[%] User palettes was not saved with «Save settings» button.
[*] Apps+Insert - paste file pathname from cliboard, converted to CygWin style.
[*] App distinct: When there is no explicit settings for current application - root application settings applied.


2012.10.15
[+] Option «Use Clink in prompt» supports loading of clink version 0.2 (recommended).
    There is no need to set up «clink autorun» when this option is checked.
[%] Issue 763: Maximizing puts ConEmu on the second monitor.
[+] Issue 764: Enable same FG/BG color when BG color is background image.


2012.10.14
[*] Far 3 build 2851 supported. Builds from 2799 to 2850 (inclusively) not supported.
[%] Incorrect startup position when maximized and hide caption.
[*] AnsiColors16.ans changed, AnsiColors16t.ans created.
[%] Some resize bugfixes.
[*] Minor changes in Settings dialog.
[+] New ConEmu.exe command line switches (some exists already but not described).
	/Reset - Don't load settings from registry/xml.
	/UpdateJumpList - Update Windows 7 taskbar jump list.
	/LoadCfgFile <file> - Use specified xml file as configuration storage.
	/SaveCfgFile <file> - Save configuration to the specified xml file.
	/Exit - Don't create ConEmu window, exit after actions.
[%] Issue 760: Shield overlay icon appears only on tab-change on Taskbar.
[+] New option: «Appearance» -> «Show Shield overlay (Win7 or higher)».


2012.10.09
[%] Changes of numbers on «Appearance» page was ignored.
[*] Far Manager: when "far /w" and mouse over visible scrollbar - mouse wheel scrolls console.


2012.10.08
[*] Changes in «Sleep in background».
[*] Some more AI in «Press Enter or Esc to close console» (successfull ReadLn takes into account).
[%] Changes of «Pad size» was ignored.
[%] Bugfix: Restart as Administrator fails.


2012.10.04
[%] BugFix. "%ConEmuDir%" does not works for elevated consoles.
[%] BugFix. Maximize fails on WinXP.


2012.10.02
[!] Far 3 build 2848 supported.
[%] Two elevated in task.
[%] DBCS bugfixes (default font in real console).
[*] More information in logs.


2012.09.30
[+] GuiMacro: Paste(8) - paste path from clipboard converted to CygWin style.
[*] When started with "/logN" switch and program folder is write-protected, log files will be created on Desktop\ConEmuLogs.
[%] Bugfix: "/single" switch.


2012.09.26
[%] Issue 727: Shortcut opens multiple instances.
[%] Issue 724: Internal window resize changes (continuation).
[*] When can't create font (specified font not found in system) defaulting to monospace fonts.
[+] Ctrl+Shift+D, Ctrl+Shift+F - select and paste to console path to a folder or a file.


2012.09.25
[%] Issue 721: Window is not resizable in Normal mode with caption hidden.


2012.09.24
[!] Internal window resize changes (continuation).
[!] ConEmuHk compiled with "/DYNAMICBASE".
[*] Switch "/single" takes care of the path, from existing ConEmu instance was started.
[*] For «Quake style» switch "/single" implied.


2012.09.23
[!] Internal window resize changes.
[*] Touchscreen. Ignore SPI_GETWHEELSCROLLLINES.
[+] IME. Composition window placed inside ConEmu.
[%] RClick & Far 3 & "Far /w" does not select panel items.
[*] Minor changes in splitter`s painting.
[%] Issue 689: Progress stuck at 100% in powershell.
[+] New switch: "ConEmu.exe /reset" starts without loading settings (a'la fresh config).
[+] New option on «Show» page: «Don't show ConEmu window on Taskbar».
[+] New option on «Caption» page: «Always show numbers [n/m]».
[+] New option on «Tabs» page: «Tabs on bottom».
[+] Issue 716: GuiMacro: SetOption("QuakeAutoHide",Value). Where Value: 2 - switch autohide, 1 - enable, 0 - disable.
[+] Issue 717: New global hotkey for «Restore (bring to front)». Unassigned by default.


2012.09.16
[!] Settings dialog redesigned. New pages created. Some options renamed.
[%] Regression fixed. Can't activate alternative mode for tab #1.
[%] Alternative buffer of "far /w" was not scrollable.


2012.09.13
[!] I'm bored to tell «Read Disclaimer #2». Option «Inject ConEmuHk» is off for now by default.
[*] Some more diagnostic info on failed to start root command (shell).
[*] Some default hotkeys are moved from Macros to User area, not to occupy Macros cells.
[+] GuiMacro.
    Paste(4[,<Title>]) - choose file and paste full pathname
    Paste(5[,<Title>]) - choose folder and paste full path
[+] New switches in "-new_console".
    "-new_console:o" - don't enable 'Long console output' when starting command from Far Manager.
    "-new_console:i" - don't inject ConEmuHk into starting process.
[%] ConEmu hungs on exit, when F-Secure is installed.
[%] Attach does not catch console windows (regression of 120909).
[%] Hyperlinks detector fixes.
[%] In some cases (e.g. "far /x"), split console (Ctrl+Shift+O/E) starts program via "cmd.exe" as root console app.


2012.09.09
[+] Settings -> Tasks: more intuitive configuration for Tasks edit box, new buttons.
    "Add Tab" - opens standard dialog with "Save" button, which append new line to Tasks edit box.
    "Add startup dir" - simplifying insertion of "-new_console:d:<dir>" with GUI dialog.
    "Add file path" - inserts path to any file (GUI dialog too).
[+] Settings -> ComSpec: «Support UNC paths in cmd.exe». The beginning. Checkbox turn on "DisableUNCCheck".
[+] GCC Build updated. ConEmu, ConEmuC, ConEmuCD, ConEmuHk. 32-bit versions only was tested in GCC.
[+] MinGW. ConEmu files MAY be stored in MinGW compatible locations:
    $MINGW_ROOT/bin/
      ConEmu.exe, ConEmu64.exe
    $MINGW_ROOT/libexec/conemu/
      ConEmuC.exe, ConEmuHk.dll and others
      ConEmu.xml - contains some defaults for MinGW environment
    $MINGW_ROOT/share/conemu/
      WhatsNew-ConEmu.txt and others
[!] AutoUpdate is disabled in MinGW mode.
[*] Minor changes in command line parser.
[%] Selection ended unexpectedly when Modifier for selection start was set and 
[%] Some GUI windows was ignored by Attach.


2012.09.04
[%] When «Auto tabs» is on, creating new console shrinked ConEmu size.
[%] SplitScreen, dialog fixes.


2012.09.03
[+] SplitScreen options in «Create new console» dialog.


2012.09.02
[%] Fixed regression of «Auto show scrollbar».
[%] Issue 696: «Frame width» does not works (with «Hide caption always»).
[%] Some excess and wrong console resizes removed on window state change.
[%] Successive show/hide tab bar descrease window height.
[+] Installer creates "ConEmu.exe" and "ConEmu64.exe" in AppPaths (HKLM).


2012.08.30
[*] Internal changes in child windows.
[%] Some fixes for DBCS.
[*] GuiMacro. Changes in Shell function. All following examples runs "cmd" in new tab:
    «Shell("new_console","cmd")» or «Shell("","cmd")» or «Shell("","","cmd")».
    Memorial. Other verbs, like «Shell("open","cmd")» runs "cmd" outside of ConEmu window.
[*] Safe Far close. From current build, this option may be used for «Unsafe» console closing.
    Type "#Close(1,1)" (without quotas) in Safe Far close macro field
    and turn on checkbox. Now, click on the cross-button in ConEmu title provokes
    «Terminate active process» in all opened consoles, regardless of «Far» it is or not.
    Warning! Use on your own responsibility, this method may damage console applications data!
[+] Far Manager & TabletPC. Tap on clock+1row (upper-right corner) show/hide panels.
[+] DoubleClick on TabBar free area acts as click on [+] button.


2012.08.26
[+] GuiMacro.
    * Print(["<Text>"])
      - Alias for Paste(2,"<Text>")
    * Rename(<Type>,["<Title>"])
      - Rename tab (Type=0) or console title (Type=1)
    * Close(<What>[,<Flags>])
      - close current console (0), without confirmation (0,1),
      - terminate active process (1), without confirmation (1,1),
      - close ConEmu window (2)
[*] Internal changes in child windows.
[%] When «Show & store current window size and position» is off, size and pos was not displayed on «Size & Pos» page.
[%] CmdAutoAttach failed, if ConEmu.exe not installed.
[+] «Show was hidden warning» option on «Features» page. «On» by default. May be turned «Off» for use with some desktop switchers (Dexpot e.g.).
[%] Issue 674: Tab macro function going to console doesn't handle 1-based offsets properly.
[%] После показа/скрытия TabBar (3-е состояние флажка) или StatusBar менялась высота окна ConEmu.
[+] <Twilight> and <Zenburn> color palettes.


2012.08.06
[%] Bugfixes and regressions of SplitScreen.
[%] В настройке не сохранялась высота консоли менее 9 строк.
[%] Issue 668: "-new_console:d:C:\Program Files (x86)" fails.
[*] GuiMacro.
    Close(<What>[,<Flags>])
      close current console (0), without confirmation (0,1),
      terminate active process (1), without confirmation (1,1)
    Shell. You may omit both <File> and <Parms>. This means «Duplicate tab».
      Shell("new_console:sV") - create same tab, split current tab to bottom;
      Shell("new_console:sH") - create same tab, split current tab to right.


2012.08.03
[!] Bugfixes and regressions of SplitScreen. Now you can create more than two splits.
[*] Some changes in «Long console output» (plugin required in Far Manager).
[*] Minimal console size now is 4 cols 2 lines.


2012.08.02
[!] Experimental: -new_console:s[<SplitTab>T][<Percents>](H|V). Examples.
    "cmd -new_console:s" - split current tab, new tab and old (current) tab become 50% width of current tab.
    "cmd -new_console:s50H" - same as "cmd -new_console:s".
    "cmd -new_console:sV" - split current tab, create new tab to the bottom.
    "cmd -new_console:s3T30H" - split 3-d tab, create new tab to the right with 30% width.
[%] Regression, Build 120727a: xterm-256 was broken.
[%] Issue 651: 7-zip/WinRar was not elevated, when updating in "Program Files".
[+] Опция «Add %ConEmuBaseDir% to %PATH%» на вкладке «ComSpec». По умолчанию включена.


2012.07.27b
[*] В поле «Command» на вкладке «Integration» можно использовать ключи для ConEmu.exe. Например: "/single /cmd powershell.exe".
[*] Minor hooks optimization.
[%] Issue 651: Sometimes, ConEmu choose incorrect update method (msi instead 7z and vice versa). Cause of previously saved value "Update.DownloadSetup".


2012.07.27
[%] Issue 643: Windows from powershell/.net does not appears on screen.
[+] Issue 652: New predefined palette <Solarized Light>.
[%] Speedup of ecompl Far Manager plugin.
[+] В окне настроек в полях цветов теперь допустим ввод следующих форматов: «#RRGGBB» (hex), «0xBBGGRR» (hex), «xBBGGRR» (hex), «RRR,GGG,BBB» (dec), «RRR GGG BBB» (dec).
[+] Для неактивного окна минимальное значение «прозрачности» установлено в 0. Т.е. теперь при потере фокуса окно может «исчезать» с экрана.


2012.07.26
[+] Создана группа рассылки: http://groups.google.com/group/conemu_ml. Welcome!


2012.07.22a
[%] Issue 649: 120722 does not restore window position.


2012.07.22
[%] Issue 348: Maximize errors with Hide caption.
[+] Issue 641: Show current console title in the status bar. 
[+] Issue 645: PowerShell cmdlet Write-Progress detection.
[%] Issue 646: ConEmu eats dead keys.
[%] Issue 647: Mouse wheel does not respect Control Panel settings.
[%] Issue 648: Правки детектора прогресса в консоли.
[%] В альтернативном буфере скролл стрелками срабатывал дважды на одно нажатие.
[*] Status bar appearance. Options «Vertical separators» and «Horizontal separator».
[*] Статус при старте консоли отображается только в строке статуса (если она включена).
[%] Правка «Sleep in background».
[*] Правка журналирования клавиатуры (ConEmu.exe /log).


2012.07.19
[+] Issue 645: PowerShell cmdlet Write-Progress detection.
    0..100 | foreach {Write-Progress Test Progress -PercentComplete $_; sleep -m 100}
[+] Смена «на лету» цвета текста и всплывающих окон в консоли (cmd, powershell, и т.п.)
    Смена цвета всплывающих окон поддерживается в Vista и выше. Для Win2k и WinXP применяется только при старте новой консоли.
    При смене цвета всплывающих окон может мелькать окно RealConsole.


2012.07.17
[*] Do not run clink in background threads.
[%] В некоторых случаях ConEmu мог падать при инициализации Far Manager.
[+] Пункт «Console information» в меню плагина ConEmu для Far Manager.


2012.07.16
[!] Настройка размера и положения вынесена на отдельную вкладку 'Size & Pos'.
    Настройка 'Long console output' перенесена на вкладку 'Size & Pos'.
    Настройка 'Cmd output codepage' перенесена на вкладку 'ComSpec'.
[+] Добавлена настройка 'Show & store current window size and position'.
    По умолчанию включена. При отключении флажка значения в полях X/Y/Width/Height
    не обновляются автоматически (показываются значения сохраненные пользователем).
[+] Кнопка 'Apply' в режиме 'Normal' не меняла текущее положение окна (X/Y).
[%] Issue 638: bincmp fails.
[%] После Apps+F и открытия диалога выскакивало контекстное меню.
[+] Добавлена палитра <PowerShell>.
[+] ConEmu Inside: Windows 2000 and Windows 2003 supported.
[%] Опять работаем в Windows 2000. Режим Alternative mode attach в Windows 2000 не доступен.
[+] В альтернативном буфере (Win+A) кнопки PgUp/PgDn/Up/Down скроллируют окно (не нужно держать Ctrl).
[+] На вкладке «Features» добавлен флажок «Use Clink in prompt». Clink - bash style completion.
    Качать здесь версию 0.1.1: http://clink.googlecode.com
    Распаковывать сюда: %ConEmuBaseDir%\clink
    Учтите, что архив clink содержит подпапки. Файлы clink_dll_x86.dll и clink_dll_x64.dll
    должны лежать в папке ConEmu\clink.
    Опция экспериментальная, может быть изменена или удалена в следующих версиях ;)


2012.07.11
[*] Far Manager. Не включать длинный буфер при поиске в архивах через MultiArc.
[+] StatusBar. Добавлена колонка «[+]» - меню создания новой консоли. Правый клик на «[+]» и на «ActiveCon/TotalCon» отображает меню активного таба.
[%] DblClick по иконке в заголовке ConEmu не закрывал окно.
[*] Правки в Injects.
[%] Issue 639: /cmd can't find far.cmd or far.bat without the extension.
[+] ConEmu Inside. Если ConEmu уже открыт, то повторный вызов пункта меню открывает новую консоль (вкладку) в открытом окне.


2012.07.10
[+] Reorder tabs. Новые хоткеи. Win+Alt+Left/Win+Alt+Right сдвинуть таб (точнее все табы консоли) влево/вправо.
[%] Issue 637: ConEmu recursively runs itself in an endless loop.
[%] Ошибка при "Download path" = "C:\".
[%] Changes in hooks.


2012.07.09
[*] Minimize/Restore учитывает флажок «Always on top».
[*] Уточнение «Copy on LButton up».
[*] New hotkey: Minimize/Restore (alternative).


2012.07.08
[+] GuiMacro: теперь можно позвать через ANSI коды. Пример в файле «IsConEmu.cmd».
[+] Вкладка «Keys & Macro»: В поле редактирования GuiMacro можно использовать \e (ESC) и \a (BELL).
[%] Cmd_Autorun.cmd fixed.
[+] ConEmuC switches. "/IsConEmu", "/IsTerm", "/IsAnsi". ErrorLevel 1 - ON, ErrorLevel 2 - OFF.
[%] Issue 633: Cannot specifiy environment variables for startup dir.
[*] Mark & Copy.
    Уточнение DoubleClick, TripleClick.
    Ctrl+C/Ctrl+Ins при наличии выделения выполняют копирование и завершают режим выделения.
[+] Issue 634: Опция «End selection on typing». 3-е состояние - завершить без копирования.
[%] Во время выделения текста не работали хоткеи (типа Win+Alt+P).
[*] Issue 635: На вкладке «Mark & Paste» показываем хинт, если модификаторы Text/Block/Prompt совпадают.
[%] Issue 631: Italic drawing bug.
[%] Issue 593: Minimize/Restore hotkey fix. Now activating ConEmu if not focused.
[+] ConEmu Inside: Добавлена поддержка Windows XP. В проводнике должна быть показана панель «Полезный совет».
[+] Доработана вкладка «Integration».
    Группы «ConEmu Inside» и «ConEmu Here» отвечают за регистрацию/удаление пунктов контекстного
    меню проводника для дисков/папок/файлов. Выпадающие списки «Menu item» показывют текущие
    пункты меню (то что сейчас зарегистрировано в реестре).
    Любой пункт можно просмотреть (выбрав его в списке) и отредактировать (нажав кнопку «Register»).
    Группа «Automatic attach of cmd...» позволяет установить (или просмотреть текущую) команду,
    выполняемую процессором (cmd и tcc) при старте. Это позволяет автоматически подцепить запущенный
    cmd/tcc в новую вкладку ConEmu.


2012.07.05
[!] Settings tree redesigned.
[%] Issue 630: «Snap to desktop edges» and multi-monitor layout.
[+] ConEmuC: "/ATTACH /CONPID=<pid> /GHWND=NEW" - Alternative nonintrusive attach of existing console to the NEW instance of ConEmu.exe.
[%] Issue 623: Continue...


2012.07.04
[%] FindEditor/FindViewer/FindFarWindow возвращал "NotFound".
[%] На вкладке Debug создавались «пустые» строки даже при «Shell activity» = «Disabled».
[*] Issue 623: Continue...
[%] Issue 629: Crash on saving color palette.
[+] Alternative nonintrusive attach mode for console windows.


2012.07.03
[+] Now DoubleClick (for «words») and TripleClick (for «lines») both works for text selection.
[+] Расширены ANSI коды (ESC ] 9 ; ...) - http://code.google.com/p/conemu-maximus5/wiki/AnsiEscapeCodes#ConEmu_specific_OSC.
[*] Issue 623: Checking...


2012.07.02
[+] Drag window by any point of client area (configurable modifier, Ctrl+Alt by default).
[+] «Features» -> «Snap to desktop edges».
[%] Issue 626: /dir arg is ignored for startup task.
[+] «Colors» -> Text/Back. The beginning.


2012.07.01
[+] Для облегчения отладки и сообщений об ошибках.
    Создать mini-dump: ConEmuC.exe /DEBUGPID=<PID> /MINI
    Создать full-dump: ConEmuC.exe /DEBUGPID=<PID> /FULL
    О соответствии битности беспокоиться не нужно, все сделает сам ConEmuC.exe.
    Также, добавлен пункт в системном меню ConEmu: Debug -> Active process memory dump.
[+] Tasks: /DIR "<dir>" учитывается при запуске вкладки в уже открытом ConEmu.
[+] Также, рабочую папку можно указать с помощью параметров "-new_console:d[:<dir>]" и "-cur_console:d[:<dir>]".
[*] Немного AI в 'Change prompt text cursor position with Left Click' - не пытаться вывести курсор за пределы строки.
[+] Issue 575: Confirm or abort setting ConEmu OnTop from external program.


2012.06.30
[+] Page 'Transparency', 'Use separate value'.
[%] После закрытия консоли (не последней) на статусной строке не обновлялось поле 'ActiveCon/TotalCount'.
[*] ConEmu inside mode.
    Синхронизация текущей папки: Explorer -> ConEmu. На статусной строке добавлена кликабельная колонка 'Sync'.
    Адаптировано для Vista.
[+] More ANSI examples. RenameTab.cmd, SetConTitle.cmd, SetProgress.cmd.
[+] GuiMacro: Progress(<Type>[,<Value>])
	Set progress state on taskbar and ConEmu title.
	 Type=0: remove progress.
	 Type=1: set progress value to <Value> (0-100).
	 Type=2: set error state in progress.
[+] На ярлык ConEmu (или сам ConEmu.exe в проводнике) можно набросить один или несколько ярлыков программ.
    Каждая запустится в своей вкладке.
    Исключение - если в в настройке ConEmu "Startup" -> "Command line" указан "far.exe". В этом
    случае строка запуска "подклеивается" к "far.exe".
[+] При быстром закрытии ConEmu "крестиком" в консоли успевало мелькнуть "Press Enter or Esc to close console...".
[+] Issue 575: Confirm or abort setting ConEmu OnTop from external program.
[%] Issue 624: Menu was not available in Notepad++ with SourceCookifier plugin.


2012.06.26
[*] ConEmu inside mode.
    AutoResize.
    "As Administrator" supported: use "-cur_console:a" or hold Shift when selecting menu item.
    For debug purposes: "/insidewnd <HWND>" & "/insidepid <PID>".
    ConEmu_Inside.reg file updated.
[+] Right click on leftmost part of status bar pop up system menu (useful in 'ConEmu inside' mode).
[*] Minor fix in Close Far editor/viewer confirmation.


2012.06.25
[+] Новая опция 'Min cursor size (pix)' на вкладках 'Text cursor' & 'App distinct'.
[%] Issue 619: В не которых случаях возникал Assertion после закрытия Far Manager.
[*] Немного поправим 'Detect text line ends', 'Trim trailing spaces', 'Bash margin'.
[+] Новый ключик для ConEmu.exe - "/inside". Пример использования в "ConEmu\Addons\ConEmu_Inside.reg".
    Смысл - создать панель в проводнике и запустить в ней, например, powershell.
    Пока «на поиграться», вроде работает в Windows 7 и Windows 8, в других системах не проверял.
    Перед вызовом контекстного меню в проводнике нужно либо увеличить высоту нижней области (Windows 7),
    либо показать панель информации/просмотра (Windows 7 & 8).


2012.06.24
[*] На вкладке 'Mark & Paste' опция 'Auto copy' переименована в 'Copy on LButton up'. По умолчанию включена.
[%] Не сохранялось значение флажка 'Highlight and goto' и пути 'External editor'.
[*] Isue 587, Issue 605: При Paste не показывать сообщение об отсутствии текста в буфере обмена.
[+] Настройка времени появления/скрытия полосы прокрутки.
[+] Еще про Quake: настройка 'окантовки' вокруг консоли 'Pad size (pix)', работает только при включенном 'Try to center'.
[+] 'App distinct' settings page redesigned.
[*] Теперь могут быть изменены комбинации: Apps+Space, Alt+F9, Alt+Enter, Alt+Space, Ctrl+Up, Ctrl+Down, Ctrl+PgUp, Ctrl+PgDn и PicView.SlideShow.
[*] Соответственно, убраны флажки из 'Send to console': Alt+F9, Alt+Enter, Alt+Space.
[%] Win+Down не увеличивал размер консоли (опция «Win+Arrows - resize window»).
[%] Issue 606: На Windows XP не появлялось сообщение (тултип) об ошибках в области нотификаций (TSA).
[*] Настройки текстового курсора перенесены на новую отдельную вкладку 'Text cursor'.
[+] Issue 612: Option to change cursor size ('Fixed cursor size' & '(5-100) %').
[%] Issue 608: Проблемы с telnet.
[*] cmd/powershell/tcc: Параметр "-new_console" (для запуска консольных приложений в новом табе) теперь можно использовать в prompt без "ConEmuC.exe".
    Например, в cmd prompt можно ввести: powershell -new_console
[%] Исправлен Detach GUI приложений.
[+] Issue 607: 'Mark & Paste' and 'App distinct' -> 'Detect text line ends', 'Bash margin', 'Trim trailing spaces', 'EOL'.
[+] 'Mark & Paste' and 'App distinct' -> 'Change prompt text cursor position with Left Click'.


2012.06.18
[+] Issue 582: Позиционирование текстового курсора кликом мышки в prompt (cmd, powershell, tcc/le, ...)


2012.06.17a
[%] Задержка при активации ConEmu с открытым Far 3.
[%] В Putty не проходили события от колеса мышки.
[%] В 120617 поломался аттач GUI приложений.


2012.06.17
[+] 'Quake style slide down' third state - auto hide on lose focus.
[%] Не перехватывать фокус при запуске, если запускаемся с ключом "/min".
[+] Issue 599: 'Auto copy' on 'Mark & Paste' - copy selected text immediately on left mouse button up (when selecting with mouse).
[%] Issue 599, Issue 570: Small lags removed, when pastings long text from clipboard.
[+] 'Main' settings page redesigned.
[+] Chinese improvments.
[*] Some Wine related fixes, but still not working ;)
[*] При невозможности зарегистрировать глобальный хоткей (Minimize/Restore) выдается сообщение в области уведомлений.
[*] Умолчание для Minimize/Restore - Win+Shift+C.


2012.06.14
[+] Для фоновой картинки добавлены опции DownLeft и DownRight.
[%] Issue 577: Chinese font display error on Chinese Win XP.
[%] Issue 587: Right click gives an error box.


2012.06.13
[%] При удалении задачи, назначенной в Startup, ConEmu переставал запускаться.
[%] 120612: При выполнении команды с "-new_console" ConEmu минимизировался.
[+] Меню таба (Rename tab) и Apps+R - переименовать активный таб. Для Far - пока можно переименовать только «Панели».
[+] Для фоновой картинки добавлена опция UpRight.
[%] Issue 590: Изменена обработка Ctrl+C/Ctrl+Break.
[*] Some Quake style improvements.


2012.06.12
[+] В поставку добавлен пример «ColorPrompt.cmd». Запустите его в cmd.exe или tcc.exe
    для смены цвета текста command prompt на желтый.
[+] Новые аргументы для ConEmu.exe - /ShowHide и /ShowHideTSA.
    Если ConEmu не запущено - запускает (с возможно указанным /cmd ...),
    если окно ConEmu уже открыто - сворачивает его или прячет в TSA.
    Действие похоже на глобально регистрируемый хоткей (Win+C), но этот хоткей не работает,
    если ConEmu не был запущен. А с ключами - можно настроить ярлык на рабочем столе.
[+] Аргумент ConEmu.exe: /dir "Folder". Аналог Working folder, задаваемый в свойствах ярлыка.
[+] Параметр «Quake style slide down» на вкладке «Features».
    Пример настройки в «ConEmu\ConEmu_Tilda.xml».
    Если вы хотите что-то типа этого
    http://tech-bytes.co.uk/2008/05/23/a-quake-style-console-for-your-gnome-desktop/
    переименуйте «ConEmu_Tilde.xml» в «ConEmu.xml»,
    при загрузке компьютера запустите !ConEmu с ключом /min,
    и вы получите «выезжающую» консоль по тильде.
[%] Issue 576: Trap when updating Jump Lists/Task while history is empty.
[%] Не работал Copy из альтернативной консоли (Win+A).
[%] Issue 584: App distinct color palette not working.
[%] Issue 576: ConEmu.exe /updatejumplist.
[%] When Maximized, check/uncheck «Hide caption always» losed caption.
[+] GuiMacro.
    Paste(2[,"<Text>"]) - paste all lines, without confirmations
    Paste(3[,"<Text>"]) - paste first line, without confirmations
    Task(Index) - start task with 1-based index
    Task("Name") - start task with specified name
[+] В диалоге настроек для GuiMacro (вкладка Keys) работают "\\", "\r", "\n", "\t".
    Теперь можно задать что-то вроде «Paste(2,"exit\n")» для выхода из cmd.exe


2012.06.09
[%] Коррекция Injects для Windows 8 RC.
[+] Issue 571: В диалоге подтверждения создания консоли добавлен флажок «New window».
    Если указывается «Another user», то под выбранным аккаунтом запускается сам ConEmu.exe.
    При желании, можно назначить отдельный хоткей для открытия диалога с включенным флажком.
[%] В некоторых случаях по краям консоли оставался мусор.
[*] Уточнение снятия скриншотов (режимы Maximized/Fullscreen).
[%] Не работал Attach GUI приложений.
[%] При перемещении мышкой бегунка полосы прокрутки - не обновлялось положение курсора.


2012.06.08
[+] Добавлена страничка: http://code.google.com/p/conemu-maximus5/wiki/RoadMap
[*] Уточнение подтверждения закрытия консоли.
[+] GuiMacro: WindowFullscreen, WindowMaximize, WindowMode, Status.
[+] Keys: Always on Top, Show/hide status bar (Apps+S), Show/hide tab bar (Apps+T), About (Win+Alt+A).
[+] About: В диалог добавлены вкладки с информацией по параметрам ConEmuC, -new_console и GuiMacro.
[+] На вкладке «Mark & Paste» добавлено ком.строка запуска внешнего редактора, значение по умолчанию: far.exe /e%1:%2 "%3"
[*] Уточнение снятия скриншотов (Win+H). Добавлен Win+Shift+H - скриншот экрана.
[%] Issue 570: Pasting into iPython (in fact, any console app except Far) does not work as expected.
[%] Issue 558: Some more color anomalies.


2012.06.04
[%] Error «Can't free hooks in module ...» в ConEmuHk.dll
[%] Issue 557: Assertion в RealBuffer.cpp
[%] Issue 568: При первом вызове 'View console output' (в плагине Far) вьювер переключался в dump-режим
[%] В некоторых случаях после завершения консольной команды в Far возникал exception


2012.06.03
[!] Internal interprocess communication changes.
[*] Status bar. Добавлена колонка 'ConEmu GUI PID'.
[%] Issue 566: Hotkey <<None>> is not unique.
[+] На вкладке 'Tasks' окна 'Settings' добавлено поле 'ConEmu arguments for Jump list'.
    Здесь можно указать доп.параметры для запуска с панели задач (Tasks, Jump list).
    Например: /icon "cmd.exe"


2012.06.02
[!] Internal interprocess communication changes.
[+] Windows 7 и выше. Поддержка Jump list, в секцию 'Tasks' ConEmu может добавить свои 'Predefined tasks' и команды из истории.
    Наполнение Jump list занимает некоторое время, поэтому на вкладке 'Tasks' добавлена кнопка 'Update Now!'.
[+] ConEmu.exe: параметр /title "Template". В заголовке окна будет отображаться фиксированный текст, а не заголовок активной консоли. В "Template" можно использовать переменные окружения.
[+] Диалог 'Create new console': в системном меню добавлен пункт 'Reset command history...'.
[+] Win+H: Make screenshot of active ConEmu window.
[+] Tabs: Раздельные шаблоны для панелей (Far) и других консольных приложений.
[+] Tabs: Для консольных приложений (кроме Far) можно настроить список слов, исключаемых из заголовка. Надоел префикс 'Administrator:' при запуске консоли 'под админом' в Win7.
[*] Убираем задержки закрытия ConEmu.
[%] В некоторых случаях не появлялись Shell-диалоги (при запуске файлов, выборе пунктов контекстного EMenu).
[*] Minor change in (isMonitorConsoleLang == 2).
[*] На Status bar тоже действует 'Fade when inactive'.
[%] В историю не попадала команда, указанная через '/cmd' при запуске ConEmu.exe.
[%] Issue 561: В некоторых случаях ConEmuHk64.dll вызывала падение консольного приложения.
[%] Issue 564: События мыши не посылались в консоль при отключенном флажке 'Inject ConEmuHk'.
[*] Изменения подтверждения закрытия табов. При закрытии ConEmu 'крестиком' запрос отображается один раз (на все консоли).


2012.05.27a
[%] Не сохранялись изменения режима окна (Normal/Maximized/Full screen), если перед 'Save settings' не была нажата 'Apply'.
[%] Некорректные подсказки для пунктов меню настройки Status bar.


2012.05.27
[*] В системном меню и меню для таба отображаются текущие горячие клавиши.
[%] Мышиные события не попадали в консольные приложения (кроме Far) при включенной прокрутке.
[+] 'Settings' -> 'Features' -> 'Mouse options' -> 'Enable mouse'. По умолчанию включено.
    Можно отключить - запретить посылку в консоль событий от мышки. При этом остается возможность
    использовать мышь для пометки и вставки текста. Опция живет уже давно, но в интерфейсе отсутствовала.
[+] Добавлена новая опция прозрачности - ColorKey. Но для Far все-таки удобнее использовать 'UserScreen transparency'.
[+] Win+G - новый хоткей для пункта системного меню 'Attach...'.
[+] Status Bar. По умолчанию включен. Настройка шрифта, цветов и колонок (любой набор из доступных 20-и)
    в 'Settings' -> 'Status bar'. Отключить/включить колонки можно также из контекстного меню строки статуса,
    открывающегося правой кнопкой мышки. Описание колонок отображается при наведении на них мышки.
    Некоторые колонки обрабатывают left click:
    * поля 'CAPS'/'NUM'/'SCRL' - переключение.
    * поле 'Active VCon' - меню выбора консоли (аналогично меню с тулбара).
    * поле 'Transparency' - меню настройки прозрачности (100%..40%, UserScreen, ColorKey); при
      наведении мышки на пункты меню 90%..40% - прозрачность главного окна сразу изменяется.


2012.05.24a
[!] ConEmuC.exe/ConEmuC64.exe sets console text attributes to 7 on startup.
[+] 'Settings' -> 'Mark & Paste' -> 'Freeze console before selection'.
[+] 'Find test' -> 'Freeze console'.
[%] Lags in ConEmu plugin.


2012.05.23a
[%] Issue 554: Исправлена обработка ^[#G (ANSI X3.64).


2012.05.23
[*] Из системного меню убран пункт 'Auto scroll'. Если нужно поставить консоль 'на паузу' - Win+A (альтернативный буфер).
[+] Ctrl+Win+Alt+Enter - принудительная активация ConEmu в FullScreen. Как и Win+C, настраиваемый хоткей срабатывает из любого приложения.
[+] Win+Shift+Del - Terminate активного процесса текущей консоли.
[+] Добавлена переменная окружения "ConEmuANSI". Принимает значения "ON" или "OFF".
[%] Issue 554: Ошибки позиционирования курсора и вывода текста (ANSI X3.64).
[%] Issue 553: Откат прокрутки консоли.


2012.05.22
[+] Новая опция 'ANSI X3.64 / 256color' на вкладке 'Features'. Описание будет здесь:
    http://code.google.com/p/conemu-maximus5/wiki/AnsiEscapeCodes
    Адресуется консоль целиком (с прокруткой), но Xterm 256color влияет только на 'рабочую'
    область (нижняя часть консоли, если есть прокрутка).
    Чтобы ANSI работало - должен быть включен 'Inject ConEmuHk'.
    Если кажется, что 256 color не работает - включить флажок 'Colorer TrueMod support', проверить
    выключен ли буфер/прокрутка (например "256colors2.pl -cur_console:h0"), или прокрутить консоль
    в самый низ ("echo [9999;1H").
    Два примера: `ConEmu\Addons\AnsiColors16.ans` и `ConEmu\Addons\AnsiColors256.ans`.
[+] Win+A - альтернативный буфер, кнопка на тулбаре - черный квадратик.
    При выполнении в фаре - показывает вывод последней команды.
    Иначе - замораживает текущее состояние всех консоли (весь буфер, с прокруткой).
    Закрыть альтернативную консоль - повторным Win+A или Esc.
[*] Win+S - включение/отключение прокрутки (BufferHeight). Игнорируется в Win7. Кнопка на тулбаре - вертикальные стрелки.
[+] Win+N - Show create new console popup menu.
[%] Issue 551: Updater, Команда распаковки формировалась неправильно при использовании переменных окружения.
[+] Новые ключи ConEmu.exe
    /min - запустить свернутым;
    /tsa - сворачивать в TSA (чтобы свернуть в TSA при запуске используйте вместе с /min);
    /icon "<file>" - откуда брать иконку, <file> может быть exe, dll или ico;
    /noupdate - отключить автоматическую проверку обновления при старте.
[*] Обновлен диалог 'About'.
[%] Исключение при уменьшении размера шрифта в Maximized режиме.
[+] Добавлены три системных палитры: Standard VGA, Terminal.app, xterm.
[%] Правки в Injects.
[%] Диалог Fast configuration отображался размернутым на весь экран, если ConEmu был запущен с ярлыка, в свойствах которого указано Maximized.
[%] Исправлена некорректная отрисовка при включении флажка 'Auto' на вкладке 'Main' в Maximized режиме.
[%] Minor changes in ConEmuC.exe.


2012.05.20
[*] ConEmu is mentioned in Wikipedia: http://en.wikipedia.org/wiki/Comparison_of_file_managers#cite_ref-20


2012.05.15
[%] В предыдущей сборке отвалилась загрузка 'App distinct'.
[*] Максимальное количество поддерживаемых консолей увеличено до 30-и (дальше кнопки лень рисовать).
[*] На тулбаре отображается 'кнопка' только для активной консоли, а не для всех открытых (как раньше).
    При клике на кнопку - отображается меню выбора запущенных консолей/табов.
[*] Активация с клавиатуры - цифрами.
    Win+F11 и Win+F12 больше не занимаются активацией консолей.
    Если консолей меньше 11-и, все как раньше.
    Если больше - то допускаются однокнопочные и двухкнопочные активации. Например:
    «Win(down) 1 5» - активирует 15-ю консоль;
    «Win(down) 1 Win(up)» - активирует 1-ю консоль.
[%] Еще раз 'Sleep in background' bugfix. 
[%] Issue 541: В режиме эскизов некорректно выделяются файлы правой кнопкой мыши.


2012.05.14
[%] Issue 543, Issue 544: Правим баги несчастливой версии :)
[%] Issue 56: При драге поверх окна ConEmu больше не забирается фокус.
[+] Drag&Drop: При дропе файлов в ком.строку Far - отображается контекстное меню (Paste/Goto/Edit/View).
[*] Drag&Drop: Internal changes in overlay image.


2012.05.13
[*] 'Ignore console cursor size' вместо неработавшей 'Ignore telnet cursor size'. Также добавлена в 'App distinct'.
[%] Не работала опция 'Send Alt+Space to console' (вкладка 'Keys').
[%] В диалоге создания новой консоли при запуске группы (Tasks) игнорировался флажок 'Run as adminstrator'.
[+] Issue 532: Опция 'Show TSA balloon' (влияет только на автоматический режим проверки).
[*] Issue 537: Проверяем опцию WinRar: [HKCU\Software\WinRAR\Extraction\Profile] "UnpToSubfolders"
[%] Issue 538: Неверные иконки в Thumbnails/Tiles в корне архивов.
[%] Issue 539: Некорректная отрисовка Thumbnails/Tiles поверх панели QView (Ctrl+Q) или Info (Ctrl+L).
[+] Разрешен Shell Drop файлов в редактор и диалоги. Drop, естественно, в виде вставки текста (имен/путей перетаскиваемых файлов).
[%] Еще раз 'Sleep in background' bugfix. 
[*] Настройка 'Command line' переехала на новую вкладку 'Startup' окна 'Settings'.
[*] В меню (кнопка [+] на тулбаре) добавлены пункты 'New console dialog' и 'Setup tasks'.


2012.05.10
[%] ConEmu internal paste locks clipboard.
[*] Пример макроса: ConEmu\Far1_reg\TabList.reg
[%] AnsiCon вызывал падение в cmd/tcc.


2012.05.09a
[%] Issue 534: ConEmuSetup: Строка с путем по умолчанию для 64 битной версии выводится сразу после 32 битной.
[+] Поиск текста в консоли. Hotkey Apps+F или Edit -> Find text.
[%] Telnet and 'Sleep in background' bugfix.


2012.05.08
[!] Issue 65: Для корректной работы приложений, использующих SetConsoleActiveScreenBuffer (telnet.exe и т.п.) требуется включить флажок «Inject ConEmuHk».
[!] Чтобы в корне не маячили и не мешали фару при работе вне ConEmu - ExtendedConsole пененесен в подпапку.
[!] Полностью переделана обработка HotKeys.
    * Понятия «HostKey» больше нет.
    * Для всех (почти) клавиш можно назначить собственный модификатор.
    * Исключение - системные комбинации, активация консоли по номеру (общий модификатор) и управление размером окна (общий модификатор).
    * Теперь можно использовать «клавиши» WheelUp, WheelDown, WheelLeft, WheelRight (колесо мышки).
[+] Теперь можно настроить до 32-х GUI Macro, привязав их к HotKeys.
    По умолчанию, CtrlWheelUp/CtrlWheelDown меняет размер шрифта.
[%] В префиксе "ConEmu:run:" теперь можно использовать переменные окружения.
    Например, для файлов "*.cpp,*.hpp" настроить такую ассоциацию (e.g. AltF4):
    ConEmu:Run:"%FARHOME%\Tools\Notepad++\notepad++.exe" -new_console "!\!.!"
[+] Опциональное подтверждение закрытия консоли из ConEmu (Features -> Confirm close console).
[+] Portable: Рядом с ConEmu.exe можно положить файлы MsXml3.dll и MsXml3r.dll чтобы не возникало
    проблем с xml-конфигурацией в Live сборках и в Win2k. Регистрировать MsXml3.dll не нужно.
    Рекомендуется брать файлы MsXml3.dll и MsXml3r.dll из Windows XP.
[*] Немного доработано пересоздание консоли.
[*] Не срабатывал Shift для пунктов меню 'Restart', 'Restart as', 'New console'.
[*] Меню (системное или для таба) всегда всплывает при RClick на табах.
[+] GUI Apps in tabs: теперь работает пункт меню 'Attach...'
[+] GUI Macro: Tab(<Cmd>[,<Parm>])
    <Cmd>=0 - show/hide tabs
    <Cmd>=1 - commit lazy changes
    <Cmd>=2 - switch next (eq. CtrlTab)
    <Cmd>=3 - switch prev (eq. CtrlShiftTab)
    <Cmd>=4 - switch tab direct (no recent mode), Parm=(1,-1)
    <Cmd>=5 - switch tab recent, Parm=(1,-1)
    <Cmd>=6 - switch console direct (no recent mode), Parm=(1,-1)
    <Cmd>=7 - activate console by number, Parm=(1-based console index)
    <Cmd>=8 - show tabs list menu (indiffirent Far/Not Far)
[+] GUI Macro: Paste(<Cmd>[,"<Text>"])
    <Cmd>=0 - paste all lines, <Cmd>=1 - paste first line
    When <Text> is omitted - paste from Windows clipboard, otherwise - paste specified text.
[+] Keyboard: 'Show opened tabs list (does not work in Far - use macro instead)'. Default - F12.
[+] ConEmu plugin: команда в меню плагина - 'Show all tabs list', макрос 'ConEmu.TabList.fml'
[%] Issue 530: Ошибка в цветах Thumbnails/Tiles при включенном «Optional marking character».
[*] Вкладка настроек 'Text selection' переименована в 'Mark & Paste'.
[+] Для консольных приложений (кроме Far) ConEmu теперь может самостоятельно обрабатывать
    вставку текста из буфера обмена. По умолчанию, Ctrl+V вставляет первую строку содержимого
    буфера, а Shift+Ins вставляет текст полностью (генерируя нажатия <Enter> для перевода строк).
    Можно настроить подтверждение вставки многострочного текста (при вставке нескольких строк
    из буфера в ком.строку cmd.exe нажатия <Enter> могут привести к нежелательному исполнению команд).
    Можно настроить подтверждение вставки длинного текста (по умолчанию 200 символов).
[+] На вкладках 'Mark & Paste' и 'App distinct' добавлена настройка вставки из буфера обмена.
[*] В 64-битных OS при запуске в новой вкладке "cmd" учитывается настройка битности желаемого ComSpec.
[*] Меню таба отображается по Apps+Space (раньше было Win+Apps).


2012.04.22
[*] Issue 527: Правим ошибки в детекторе панелей.
[%] Глюк размера при старте, если 'Hide caption' и режим 'Maximized' в ярлыке.
[*] При нажатии кнопки 'Apply' в окне настроек в полях размера окна появлялись старые значения.
[*] Не работали кнопки +/-/Up/Down на вкладке 'App distinct'.


2012.04.21
[!] Внимание. Изменения в использовании командных процессоров.
[*] В настройку добавлена вкладка 'ComSpec'. Туда перенесны настройки 'Long console output'.
[*] На вкладке 'ComSpec' добавлена настройка используемого командного процессора.
    По умолчанию настроен автоматический выбор между tcc.exe (если установлен) и cmd.exe.
    Также есть возможность принудительного задания 'битности' командного процессора в 64-битных OS.
    По умолчанию битность процессора совпадает с битностью OS.
[*] Опция 'Leave on close' вынесена в интерфейс на вкладку 'Tabs'.


2012.04.18
[%] Гиперссылка на редактор/строку не работала из консоли с прокруткой.
[*] Some speed up of command execution.


2012.04.17
[*] Issue 511: Теперь bdf-шрифты можно использовать и для рамок.
[%] Issue 523: Невозможность начать пометку текста из меню при прокрученном вверх буфере.


2012.04.16
[+] Некоторые настройки (палитра, Cursor, Extend Fonts) можно
    настраивать раздельно по имени приложения и признаку Elevated.
    Настройка на странице 'App distinct' окна 'Settings'.
    Приложения сохраняются в настройке (reg/xml) в подключе "Apps".


2012.04.14
[%] При открытии диалога настроек не включался флажок 'Long console output'.
[%] Ошибка в возврате Plugin.Call("4b675d80-1d4a-4ea9-8436-fdc23f2fc14b","...") для Far3.
[%] После Far3 build 2576 поломались макросы использующие $Text. В частности, отвалился 'длинный правый клик'.
[%] GUI Apps in tabs: "Notepad" in Win-W don't works.
[%] Убрана небольшая задержка переключения табов (редактор/вьювер) через интерфейс ConEmu.
[%] Issue 516: При минимизации кликом по таскбару не отключались Win-Number.
[%] Issue 518: Если Far 'не отвечал', то при попытке обращения к нему (переключение табов, и т.п.) ConEmu на некоторое время зависал.
[%] Issue 521: Пропадание табов редактора/вьера.
[*] Issue 248: Добавлена возможность сохранять/загружать пользовательские палитры цветов.
    В палитру входят 32 цвета (16+16) и настройки 'Extend foreground colors'.
    Именованые палитры сохраняются в настройке (reg/xml) в подключе "Colors".
[*] Issue 445: Добавлена возможность создавать пользовательские 'Задачи'/'Tasks'.
    Задача - это алиас для запуска одного или более приложений в новых вкладках ConEmu.
    Их можно использовать (на примере задачи {Shells}):
    * при запуске, указав в свойствах ярлыка: "ConEmu.exe /cmd {Shells}"
    * указав {Shells} в поле 'Command line' страницы 'Main' окна 'Settings'
    * при создании новой консоли через интерфейс ConEmu (`+` на тулбаре, список в Recreate-диалоге)
    * из командной строки cmd.exe: "%ConEmuBaseDir%\ConEmuC.exe" /c {Shells} -new_console
    * из командной строки far.exe: conemu:run:{Shells} -new_console
    Настройка на странице 'Tasks' окна 'Settings'.
    Задачи сохраняются в настройке (reg/xml) в подключе "Tasks".
[*] Minor fix in debug switch "/detached".
[*] Vista+: При детаче в консоли устанавливается приемлемый для пользователя размер шрифта.


2012.04.08
[*] ConEmu was mentioned on http://jpsoft.com/blogs/2012/04/windows-console-replacements-part-6-take-command-and-conemu/


2012.04.01
[*] Settings->Far Manager->KeyBar RClick: при подсветке пункта меню на кейбаре отображается выполняемое действие.
[*] Issue 514: Доработана опция 'Extend foreground colors with background'.
    Работает для любого приложения, а не только для Far Manager.
    Например, для Far Manager, в качестве 'заменяемого цвета фона' можно выбрать
    цвет панелей (синий по умолчанию), тогда для Far получится как бы своя собственная
    палитра цветов. Или наоборот, можно настроить цвета для внешнего редактора (Vim),
    выбрав в качестве цвета расширения его цвет фона.
    Для Far Manager имеет смысл только для веток 1.7x и 2.x. Для ветки 3.x
    любые TrueColor цвета можно настроить через интерфейс Far Manager.
[*] Issue 319: Hyperlinks. Разрешено для любого приложения (не только в Far).
    Но для открытия редактора (LClick по ошибке из консоли с cmd.exe) Far должен быть запущен.
    При наведении меняется курсор мышки.


2012.03.27
[*] Far3: после выполнения макроса ShiftEnter курсор прыгал к ".."
[*] Hyperlink detector (e-mails).
[*] Issue 505: Reattach fixed.
[*] Settings->Far Manager->KeyBar RClick: Правый клик по кейбару отображает меню модификаторов.
    Т.е. щелкнув правой кнопкой по "7Search" в редакторе откроется всплывающее меню, в котором
    можно выбрать любой F7 с модификатором, например Ctrl-F7.
    Примечание. При выборе пункта меню в консоль посылается именно нажатие, т.е. если на Ctrl-F7
    висит макрос - будет выполнен макрос.


2012.03.26
[!] Far3 build 2573.
[*] Еще раз табы для модальных окон (Far3).


2012.03.25
[!] Текущая версия НЕ совместима с Far3 build 2567 и выше (пока).
[*] Еще раз табы для модальных окон (Far3).
[*] Issue 507: В некоторых случаях при запуске консольных приложений не отключались расширенные атрибуты символов (color/italic/...).
[*] Issue 509: В некоторых случаях (смена режима дисплея) в консоли мог самопроизвольно включаться режим прокрутки.
[*] Issue 510: Отключен AI приводивший к невозможности сохранить заданную пользователем высоту шрифта (сохранялась высота, с которой был создан реальный шрифт).
[*] Issue 511: Rudimentary BDF support (from thecybershadow).
    // from Maximus: выкинул тормознутый std, скорость загрузки bdf-шрифтов увеличилась вдвое.
[*] Не работали жесты в release сборке.
[*] Touchpad & Touchscreen: после двойного тапа в консоль мог проваливаться 'лишний' LBtnClick.
[*] Добавлен макрос Editor.MsRClick.fml - удобен для работы в редакторе и диалогах  на Touchpad & Touchscreen.
[*] В режимах 'Hide caption...' & Maximized 'светилась' рамка окна.


2012.03.15
[!] Far3 build 2546.
[*] Исправлено отображение табов для Far3.
[*] Продолжение 'гиперссылок'. Теперь обрабатываются и URL & e-mail (открытие через ShellExecute).
[*] Issue 499: В архив 7z добавлена 64битная версия GUI, соответственно снято ограничение на обновление 64битной версии только инсталлятором.


2012.03.14
[!] Far3 build 2545, рекомендуется bis-сборка.
[*] Еще раз детектор 'гиперссылок' на ошибки компиляции (добавлена поддержка Delphi/FPC).


2012.03.04
[*] Немного поправлен детектор 'гиперссылок' на ошибки компиляции.
[*] Убираем OutputDebugString.


2012.02.27
[%] Правки межпроцессного взаимодействия.
[%] Ошибка в умолчаниях шаблонов табов для вьювера и редактора с изменениями.
[*] Vista и выше. При невозможности изменить размер консоли из-за пределов по размеру консольного шрифта,
    ConEmu пытается увеличить/уменьшить размер шрифта в консоли. Для пользователя это 'прозрачно', шрифт
    в окне ConEmu не меняется.
[*] Windows 7 и выше. Поддержка тачскринов и жестов.
    Длинный тап - аналог длинного RClick, открытие EMenu.
    Перетаскивание одним пальцем - аналог перетаскивания с нажатой левой кнопкой мышки (например, для Drag&Drop).
    Тап двумя пальцами - аналог короткого RClick, выделение файла. Позиция - центр между пальцами.
    Нажатие и тап (опустить первый палец, тап вторым пальцем, отпустить первый палец) - аналог короткого RClick, выделение файла. Позиция - первый палец.
    Поворот (опустить первый палец, крутить вторым пальцем вокруг первого, отпустить первый палец) - переключение табов, по часовой стрелке - CtrlTab, против часовой стрелки - CtrlShiftTab. Активация таба - после отпускания первого пальца.
    Прокрутка (опустить два пальца, двигать их вверх/вниз, отпустить пальцы) - аналог прокрутки колесом мышки (инверсно).
    Зум (опустить два пальца, сблизить/раздвинуть, отпустить пальцы) - изменить размер шрифта в ConEmu.
[*] Issue 493: При включении табов размер консоли не меняется - увеличивается высота окна ConEmu.
[*] Issue 494: Hotkeys for starts text and block selection from keyboard.
[*] Issue 495: Option for send 'Alt-F9' to console.
[%] Issue 496: Edit -> Mark text doesn't start selection sometimes.
[%] Опять работаем в Win2k.


2012.02.15
[!] Experimental: Внутренние изменения межпроцессного взаимодействия.
[*] Installer. Подхватывается путь установки Far 3.x, в том числе и для компонентов 'Far Manager plugins' и 'Far3 ExtendedConsole'.
[*] Правки в injects.
[%] Issue 296: Исправлена работа в режиме HideCaption & Maximized.
[+] Префикс плагина "ConEmu:run:" теперь поддерживает и "-new_console" для убирания мерцания панелей.
[*] Доработаны макросы для Far3.
[*] В заголовке таба с консольным выводом (макрос Far на CtrlO) отображается 'Console output' вместо имени временного файла.
[+] Для 'Resize panels by mouse' добавлен флажок 'use both panel edges'.
[%] Issue 491: ConEmu changes window size on F3 or F4 in Far.
[+] Win+Apps - active tab popup menu.
[*] Продолжение GUI-приложений во вкладках.


2012.02.05
[*] EMenu по правому клику (опция 'RightClick 4 EMenu') всегда отображается в позиции курсора мыши.
[%] Откат поддержки injects в UPX модулях.


2012.02.04
[%] Issue 485: Проблема при запуске с включенным Desktop mode.
[%] Issue 489: Не работает dism (правки в injects).


2012.02.03
[*] Продолжение GUI-приложений во вкладках.
    Теперь при запуске консольной утилиты/команды из GUI-приложения во вкладке -
    утилита/команда стартует в новой вкладке ConEmu.
[%] Issue 486: После запуска новой вкладки в фоне - не обновлялись кнопки на тулбаре.
[%] Правки в запускаторе.
[*] Правки в injects.


2012.02.01
[*] AutoUpdate. Сообщение о невозможности обновления 64битной версии GUI показываем только при ручном вызове.
[%] Не работал Terminate (из меню) для активного процесса.
[%] Issue 484: Не восстанавливается иконка в трее после краха проводника.
[*] В меню для активной консоли (таба) вместо 'Terminate' отображается 'Terminate->Console' и 'Terminate->Active process'.


2012.01.29a
[%] Issue 479: Tiles/Thumbnails не обновлялись в Far 2.x при открытом QSearch.
[%] Issue 482: RightClick и EMenu на границе панели.


2012.01.29
[*] Продолжение GUI приложений во вкладках. Теперь и VLC.
[*] Настройки выделения текста и скрытия заголовка перенесены из в доп.диалогов в окно 'Settings'.
[*] Far 3 build 2426 (не работал ConEmu Panel Views).
[%] Issue 481: ConEmu.120118 — ошибка переключения табов кликами.


2012.01.18
[+] Issue 337: Attach не-фаровских консолей: System menu -> Attach to... Проверялось в Windows 7.
    ТехИнфо. Для аттача необходимо загрузить в выбранный процесс модуль ConEmuHk.dll (ConEmuHk64.dll),
    что выполняется посредством CreateRemoteThread. В принципе, некоторые антивирусы могут ругаться
    при попытке использования этой функции. Вызывается CreateRemoteThread из ConEmuC.exe (ConEmuC64.exe).
[%] Issue 480: Answering "Detach console" with "no" still detaches console.
[%] В 120115 для Far 3.x отвалился правый клик на keybar.
[+] Консольным программа разрешено 'рисовать' в DC ConEmu функцией StretchDIBits (Far плагины ImageView и PicViewAdv).
    ТехИнфо. Из отрисовки в ConEmu исключается прямоугольник, указанный в последнем вызове StretchDIBits.
    Его отрисовка восстанавливается при изменении размеров окна или при изменении текста в консоли в этом прямоугольнике.
[*] Еще немного по пропорциональным шрифтам.


2012.01.15a
[+] Параметр "-cur_console[:n]" можно указать после "ConEmu.exe /cmd" чтобы отключить 'Press Enter or Esc to close console'.
    Пример для UserMenu в Far 3.x
    macro:post $If (Apanel.Folder || Apanel.Plugin && !!(APanel.OPIFlags & 0x20)) msgbox("Warning!!","Panel or current item type disallows Hiew execution",0) $Else print(@"conemu.exe /config hiew /cmd C:\Utils\Files\Hiew32\hiew32.exe -cur_console:n ") CtrlF Enter $End
    Открывает файл под курсором в hiew, запущенном в новом экземпляре ConEmu.

2012.01.15
[%] Detach GUI окон.
[%] Правки детектора панелей.
[+] Отладочная опция: System menu -> Debug -> Load screen dump.
[+] Windows 7: Overlay icon 'Shield' on taskbar for elevated tabs.
[*] Far 3 build 2381: Исправим безобразие с RightClick :) при включенных 'Right selection fix' и 'RightClick 4 EMenu'.
[*] При ошибках запуска корневой команды ConEmuC.exe отображает текущую директорию (Can't create process, ErrCode, Current directory, Command to be executed).
[%] Issue 477: 'Ломка' шрифта в диалоговых окнах.
[%] Issue 478: Отображение рамок с растровыми шрифтами при отключенном 'Fix Far borders'.


2012.01.10
[*] Зарегистрирован аккаунт в твиттере :) http://twitter.com/ConEmuMaximus5
[*] Автообновление: описано в FAQ-ConEmu.txt
[%] Автообновление: ошибки скачивания 'version.ini' отображаются только при вызове из меню 'Help' -> 'Check for updates'.
[*] Подтверждение перед Detach.
[*] В 'Settings' -> 'Tabs' добавлена настройка шрифта табов.
[*] Внутренние изменения. Окна VirtualConsoleClassBack и VirtualConsoleClassScroll более не используются.
[%] Не работало отключение флажка 'Long console output'.
[+] При запуске команд из Far Manager можно использовать параметр "-cur_console:h[N]". "h[N]" аналогичен параметру в "-new_console" но команда будет запущена в текущей а не новой консоли.
[+] Issue 474: ConEmu not accepting mouse wheel input when mouse coords are negative.
[+] Issue 476: New checkbox 'Settings'->'Tabs'->'Far windows'.


2012.01.05.1
[*] Issue 295: Улучшена отрисовка диалогов при использовании пропорциональных шрифтов.
[*] AutoUpdate. Перед запуском обновления (после закрытия окна ConEmu) выполняется проверка отсутствия других запущенных экземпляров ConEmu.


2012.01.05
[%] Issue 461: В некоторых случаях ConEmu падал при закрытии GUI приложения во вкладке.
[%] Issue 469: YAC (Yet Another Completion) doesn't work. Для GetConsoleWindow (возвращающего окно отрисовки) GetClassName перехватывается и возвращает "ConsoleWindowClass".
[%] Issue 472: Падение при выборе меню дисков (alt+F1).
[%] При отрисовке TrueColor через ExtendedConsole.dll сбивался цвет фона пробельных символов при совпадении с 'цветом текста'.
[*] Все HotKeys теперь можно задать на вкладке 'Keys' окна настроек. Настройка клавиш с вкладки 'Tabs' убрана. На вкладке 'Tabs' добавлен флажок '«Host-key»+Number iterates Far windows'.


2012.01.02
[*] На главной странице проекта ( http://code.google.com/p/conemu-maximus5/ ) добавлена кнопочка '+1'. Щелкните, кому не жалко :) Ну, и тут ( http://sourceforge.net/projects/conemu/ ) тоже.
[*] Far3 build 2311 (build 2343 supported).
[+] Issue 102: AutoUpdate. Умеем обновляться как через инсталлятор, так и через 7z-архив. Для обновления через архив - нужен архиватор (7z или WinRar).
[+] При запуске в новой конфигурации вместо нескольких диалогов отображается один общий диалог 'быстрой настройки'.
[%] Параметр '-new_console' не запускал во вкладке GUI приложения.
[*] В системное меню добавлены пункты 'Visit home page' и 'Report a bug' (Win+Alt+Space или клик по иконке в заголовке ConEmu).
[*] Еще немного FAQ-ConEmu.txt
[%] Issue 465, Issue 466: Правки в ConEmuHk.
[*] Часть настроек с вкладки 'Features' перенесена в новую 'Far Manager'.
[*] На вкладке настроек 'Far Manager' добавлены поля для макросов. Вернуть макрос 'по умолчанию' можно очистив поле макроса.
[%] Issue 468: System's 'Copy File' window (by Ctrl+V) appears behind ConEmu.
[+] При запуске ConEmu.exe выполняется проверка наличия необходимых файлов (ConEmuC.exe и т.п.)


2012.01.01
[*] Same as build 120102. May be used for AutoUpdate testing.


2011.12.20
[*] Улучшен детектор прогресса в консоли.
[+] GuiMacro. Новая функция: Shell("<Verb>","<File>"[,"<Parms>"[,"<Dir>"[,<ShowCmd>]]])
    Verb - "open", "print", и т.п. или специальный "new_console"
    Примеры (для диалога ConEmu GUI Macro):
      shell("open","cmd","/c dir c:\ -new_console:b")
    Примеры (для макросов Far 3.x):
      callplugin("4b675d80-1d4a-4ea9-8436-fdc23f2fc14b","shell(\"open\",\""+env("FARHOME")+"\\Encyclopedia\\FarEncyclopedia.ru.chm\")")
      callplugin("4b675d80-1d4a-4ea9-8436-fdc23f2fc14b","shell(\"new_console\",\""+env("FARHOME")+"\\far.exe\")")
[+] На вкладке 'Debug' окна настроек добавлена возможность журналирования выполняемых команд.
[%] Некорректно вырезался '-new_console' при наличии кавычки после параметра.


2011.12.12
[*] Продолжение GUI приложений во вкладках.
[%] ConEmu64 & Far x86: при выходе из Far могло появляться сообщение 'Press Enter or Esc to close console'.
[%] Issue 462: ConEmu 111206 & right click.
[%] Issue 461: При максимизации внутренняя консоль не максимизируется.
[+] Расширены возможности запуска новой консоли: -new_console[:bh[N]caru[:user:pwd]]
    b - Create background tab
    h<height> - пример, h0 - отключить буфер, h9999 - включить буфер в 9999 строк
    n - отключить 'Press Enter or Esc to close console'
    c - принудительно включить 'Press Enter or Esc to close console'
    a - RunAs shell verb (as admin on Vista+, login/password in Win2k and WinXP)
    r - Run as restricted user
    u - ConEmu choose user dialog
    u:<user>:<pwd> - specify user/pwd in args, MUST BE LAST OPTION


2011.12.06
[*] Продолжение GUI приложений во вкладках.
[*] Sources: класс CRealConsole разделен на два объекта.
[*] Правки в запускаторе.
[*] Исходники ConEmu проверены анализатором PVS-Studio.
[+] При включении 'Shell and processes' в логе отображается содержимое bat/cmd/tmp файлов длинной менее 32K. Можно использовать для отлова ошибок параметров компиляции/линковки программ.
[+] Не мигаем курсором если Far занят (выполняет длинный макрос, ищет по сети, грузит файлы и т.п.)
[%] Issue 459: обработка клавиши Win.


2011.11.20
[*] Изменен внешний вид диалога настроек.
[%] Небольшие правки обработки кликов по миниатюрам панели задач Windows 7.
[%] Исправлен Alt-Tab, Alt-Tab для Win2k/WinXP при включенном Tabs->'Show on taskbar'.
[%] Исправлена подсказка к флажку Tabs->'Active only'.
[*] x86 и x64 исталляторы объеденены в одном файле: ConEmuSetup.??????.exe.


2011.11.17
[%] В Far3 не работало переключение окон при открытом QView.
[%] Продолжение подготовки к переходу на новые табы (исправлены появившиеся в 111110 ошибки)
    * поломалась зарисовка полей вокруг консоли.
    * Issue 456: в некоторых случаях не обновлялся или не отрисовывался заголовок окна.
    * Issue 455: возможно, исправлена ошибка отрисовки при переключении в другое приложение.
[!] Изменен адрес загрузки ConEmuHk.dll/ConEmuHk64.dll.
[*] Sources: класс настроек разделен на два объекта.


2011.11.10
[%] Issue 449: Resizing tabs with mouse in 'panel view' (thumbs/tiles) does not work.
[%] Issue 451: падение при загрузке background из png.
[+] Settings->Tabs->'Show on taskbar' - отображение на панели задач всех запущенных консолей.
    Если флажок в 3-м состоянии - консоли отображаются только в Vista и выше.
    В Windows 7 добавлена поддержка Aero thumbnails & peeks.
[%] msi: не запоминался путь, заданный для ExtendedConsole.
[*] Начало подготовки к переходу на новые табы.
[+] В диалоге настроек добавлены кнопки 'Reset' (сброс к настройкам по умолчанию) и 'Reload' (перезагрузить из xml/reg).
[*] Правки в запускаторе.


2011.11.01
[%] В 111019 поломался TrueMod в Far2.
[*] Продолжение GUI приложений во вкладках.


2011.10.31
[+] Issue 443: Jpeg and PNG in Background image.
[%] Issue 319: Поломался переход в редактор по клику для 'test.c(50): error: ...'


2011.10.27
[%] Issue 440: Игнорировалось наличие плагина ConEmu.x64.dll если Far.exe был переименован.
[%] Issue 441: ConEmu 2011.10.19 - сломался QView + PictureVew2.
[*] Диалог создания/пересоздания консоли.
    'Команда по умолчанию' - то, что запускается при старте ConEmu (например "C:\Far\Far.exe").
    'Текущая команда' - то, что запущено в текущей консоли  (например "C:\Far\Far64.exe /w").
    При создании новой консоли в диалоге отображается 'Команда по умолчанию', 'Текущая команда'
    добавляется в историю (выпадающий список) следующим пунктом. Таким образом, поведение ConEmu
    при отображении диалога теперь соответствует 'тихому' созданию новой консоли ([ ] Create confirmation).
    При пересоздании активной консоли в диалоге отображается 'Текущая команда', а 'Команда по умолчанию'
    добавляется в историю (выпадающий список) следующим пунктом.
[*] Для некоторых пунктов меню (таба и системного) начали всплывать подсказки.
[*] Вернул slideshow для PictureView2 (кнопка Pause, интервал '-' и '+' на _основной_ клавиатуре).
[*] Продолжение GUI приложений во вкладках.


2011.10.26
[%] Issue 438: Far мог падать при попытке настройки палитры TrueColor (ExtendedConsole64.dll) в режиме "Far /w".
[%] В 111019 поломался плагин ConEmu Panel Views.
[*] При включенном флажке 'Save window size and position on exit' сохряняем один раз, перед закрытием консолей.
[*] Разработчикам Far-плагинов. ConEmu.dll: HWND WINAPI GetFarHWND2(int anConEmuOnly)
	anConEmuOnly
		2 - вернуть главное окно ConEmu
		1 - вернуть окно отрисовки
		0 - если в ConEmu - вернуть окно отрисовки, иначе - вернуть окно консоли
[*] Еще немного FAQ-ConEmu.txt


2011.10.24
[%] В 111023 поломался диалог 'Recreate console'.
[*] Продолжение GUI приложений во вкладках.


2011.10.23
[%] Ресайз окна «HostKey»+стрелки не работал, если «HostKey» был переопределен (не Win).
[%] При включенном флажке '«User screen» transparency' часть картинки (PicView/MMView) могла оставаться невидимой.
[%] Issue 423: При просмотре картинок (PicView и т.п.) временно отключается альфа-прозрачность.
[%] Макросы в Far могли не выполняться, пока мышкой не дернешь над консолью.
[%] ConEmu падал, если все консольные процессы завершались пока было открыто окно 'Recreate console'.
[*] Обновлен FAQ-ConEmu.txt


2011.10.19
[!] Большие внутренние изменения. Для каждой виртуальной консоли создается свое окно отрисовки.
    * Функция GetConsoleWindow перехватвается, и возвращает окно отрисовки ConEmu.
    * Если плагинам/программам реально требуется дескриптор окна консоли - ConEmuHk.dll: GetConEmuHWND(2).
    * Функции GetParent, GetWindow, GetAncestor перехватываются, и для окна отрисовки подставляют результат главного окна ConEmu.
    * Враппер для старых версий PicView/MMView больше не нужен.
[%] Issue 393: Запуск второго экземпляра Far внутри ConEmu под высокой нагрузкой.
[%] Issue 431: Падение при закрытии окна настройки плагина 'ConEmu Background'.
[%] Issue 434: Опять работаем в Windows 2000.
[%] При 'RightClick 4 context menu' в Far 1.7x гасились панели.
[%] С какой-то сборки отвалился Drop в командную строку.
[%] При отсутствии файла ConEmuCD.dll/ConEmuCD64.dll в консоль выводились 'иероглифы' вместо текста ошибки при попытке выполнения команд.
[%] В некоторых случаях после старта консоли 'Run as admin' не инициализировалась консоль (не отображалось содержимое).
[+] Теперь во вкладке ConEmu можно запускать некоторые графические приложения: Putty, Notepad, TC ;) При этом кнопка 'буферного режима' скрывает/отображает окно приложения.
[+] В окне 'Settings' добавлена вкладка 'Keys' на которой показаны все работающие в ConEmu кнопкосочетания. Туда же перемещены настройки 'Host-key' и 'Send Alt+Enter', 'Send Alt+Space'.
[+] Добавлена возможность перехвата некоторых системных кнопкосочетаний (AltEsc, AltTab, CtrlEsc, PrntScrn). Настройка на вкладке 'Keys'. Альтернативно поддержан Far плагин XKeys.
[+] На вкладке 'Keys' добавлен флажок 'Win+Arrows' разрешающий ресайз окна ConEmu стрелками на клавиатуре.
[*] Уменьшен объем (и соответственно время) передаваемых данных при отрисовке фона плагинами. Использовать старый PanelColorer не рекомендуется.
[*] Оптимизация детектора диалогов.
[*] Небольшое изменение скрытия 'автоматической' полосы прокрутки. Если курсор мыши вне окна консоли - скрытие не выполняется, во избежание мелькания полосы прокрутки при вялотекущих процессах в консоли.
[*] При Close/Recreate консоли сразу отключается Background, установленный плагинами.
[*] Системное меню и меню таба.
    * Меню приведены к единому виду.
    * Добавлен пункт "Attach to...", позволяющий подцепиться к приложению или консоли (не закончено).
    * В системное меню добавлено субменю 'Active console', содержащее пункты 'Close', 'Detach', и т.д.
    * ... добавлено субменю 'Console list', отображающее список открытых консолей.
[*] Описана структура и параметры в файле 'Background.xml'.
    * Добавлена возможность задания цветов картинок и полосы свободного места.
    * ... задания размера полосы свободного места.
    * ... задания разных цветов панелей в зависимости от буквы диска.
[*] FindFirstChangeNotification для проверки изменений в Background.xml (плагин ConEmu Background).
[*] Сообщение о невозможности активации таба отображается под центром таба. Также не пытаемся активировать табы, если они заблокированы диалогом.


2011.09.26
[+] Пункт меню 'Terminate' и кнопка 'Terminate' в 'Recreate dialog' отображает подтверждение с выбором: закрыть консоль 'крестиком' или убить активный процесс (TerminateProcess).
[*] Упрощена настройка Background. В поле 'Replace color indexes' можно указать '*', тогда будет краситься только фон панелей Far manager.
[*] Far3 build 2204.


2011.09.25
[%] Плагины 'ConEmu Background' и плагин 'ConEmu Underlines' не работали в Far 1.7x.
[+] Настройка плагина 'ConEmu Background'. Можно задать полный путь к xml файлу, например "%FARHOME%\Background.xml".


2011.09.24
[%] Issue 158: ConEmu PanelViews в некоторых случаях конфликтовал с плагином PanelTabs (не реагировал на клавиатуру и мышь).
[+] Опция "MainTimerInactiveElapse" - периодичность обновления неактивной консоли.
[+] Плагин 'ConEmu Underlines' теперь умеет подсвечивать панели черезстрочными полосами.
[+] Добавлен новый плагин 'ConEmu Background' аналог неподдерживаемого PanelColorer.


2011.09.19
[%] Issue 427: После AltEnter, AltEnter некорректно сохранялся текущий размер окна при выходе.
[%] Issue 429: Win-W won't works in Windows 8.
[+] Issue 425: Выделение слов двойным кликом, как в обычной консоли.
[*] Теперь можно выделять текст в фаровском CtrlO из редактора. Есть, конечно, AltIns, но тем не менее.
[+] Добавлена авторегистрация шрифтов в *.otf файлах.
[+] Issue 319: Из консоли фара можно открывать как ссылки ошибки компиляторов (вроде ConEmu.cpp(1999): error: xxx).


2011.09.14
[%] DosBox не запускался, если ConEmu установлен в 'Program Files' (путь к DosBox содержал пробелы).
[%] После нескольких вызовов окна настроек в списке шрифтов задваивались шрифты вида '[Raster Fonts 8x12]'.
[*] Issue 426: Режим 'Auto' для правой и средней кнопок мыши, копирование - если выделен текст, иначе - вставка.
[*] Minor changes in hookset (32<->64bit).
[*] ExtendedConsole: немного улучшено отображение цветов в RealConsole.
[*] Far3 build 2194.


2011.09.03
[*] Far3 build 2184.
[%] Изменения в модуле ConEmuHk.
[%] Плагин 'ConEmu Underlines' валил Far.


2011.08.26
[*] Far3 build 2174.


2011.08.24
[%] В некоторых случаях, при отображении меню (RightClick 4 context menu) гасились панели.
[*] Far3 build 2159.
[+] Issue 422: Настройка 'DisableMouse'. Через реестр/xml можно отключить посылку мышиных событий в консоль. Некоторые опции ('Resize panels by mouse', 'Select text with mouse', и т.п.) отключаются отдельно.


2011.08.11
[*] Изменено отображение непечатных (combining) символов: accents, tildas, dot above, xFEFF и т.п. Обычно эти символы при печати располагаются над предыдущей буквой. Однако, для 'консольной ясности' теперь они отображаются в своем знакоместе.


2011.08.09
[%] Поправлено определение координат панелей для многострочной и отключенной области статуса.
[*] Доработан 'RightClick for context menu'. Курсор на файл ставится под кликом сразу (при начале длинного клика).
[+] Issue 420: Option 'Win-Tab' on Tabs page for tab switching in Windows 7.


2011.08.08
[%] Падение в некоторых случаях (например при очистке корзины через EMenu).
[%] Не работал Fade для расширенных (24bit) цветов.
[*] ExtendedConsole: отображение в диалоге Bold/Italic/Underline; включение флажка '4bit' сразу показывает измененный цвет.


2011.08.07
[%] После Attach (например из плагина) окно консоли не скрывалось.
[%] Issue 418: Не работал макрос FAR_AutoAttach.reg в Far2.
[+] В меню 'Debug' (системное или контекстное меню таба) добавлен пункт 'Debug active process'.


2011.08.05
[%] Отрисовка TrueMod в 'far /w'.
[%] Умеем восстанавливать разрушенное другими программами системное меню.
[%] Issue 387, Issue 397: Диагностика ошибок - отсутствие необходимых 'ConEmuC.exe' или 'ConEmuC64.exe'.
[%] Issue 414: Поломался аттач после детача по CtrlAltTab.
[*] Issue 416: Настройка "DownShowHiddenMessage". Иконка из TSA автоматически убирается, если окно опять стало видимым.
[%] Issue 417: Исправлен глюк Far плагина 'Color Picker'.


2011.07.31
[*] Небольшая доработка TrueMod support.


2011.07.21
[%] В версии 110720 в некоторых случаях Far аварийно завершался.


2011.07.20
[!] Плагины не будут работать в Far3 выше 2102.
[%] Не работал перехват WinAPI в плагинах, загруженых через Far3wrap.
[+] В Thumbnails & Tiles учитывается многострочная статусная область панелей.
[+] Добавлен файл ConEmu\Far3_reg\Thumbnails_KeyBar.xml


2011.07.12
[%] Полный путь в заголовках табов редакторов/вьюверов.
[*] При удерживании модификатора выделения текста (настройка 'Select text with mouse') движение мышки не пересылается в консоль.
[+] В системное меню добавлен пункт 'Bring here' - подвинуть окно ConEmu в левый верхний угол текущего монитора (если вдруг окно уехало за пределы видимости).


2011.07.06
[%] Issue 411: Ошибки Drag&Drop в коммандную строку.
[%] В плагине не выполнялся пункт 'Start ConEmu debug'.
[*] Расширены возможности встроенного дебаггера ('Start ConEmu debug' из плагина, или 'Debug log (GUI)' из системного меню ConEmu).
    * При нажатии CtrlBreak в окне дебаггера предлагается создать minidump.
    * В заголовке дебаггера отображается PID отлаживаемого процесса.
[*] Доработки для Far3 build 2082.
[*] В сообщении 'ConEmu received old version packet' отображается полный путь процесса или модуля, приславшего пакет некорректной версии.
[*] В шаблонах заголовков табов (Tab templates) можно использовать макроподстановки: %s - заголовок консоли, %i - номер окна в Far (0-based), %p - PID активного процесса в консоли, %c - номер консоли (1-based).
[*] Если какая-то другая программа скрыла окно ConEmu - в TSA отображается иконка и всплывающее сообщение об этом безобразии.


2011.06.29
[%] Issue 409: "Far.exe /e newfile" из ConEmu: Exception при выходе. Требуется версия Far 2.1 bis12 или выше.
[*] При вызове консольных приложений на экране могли мелькать цветные артефакты (при использовании расширения шрифтов/цветов).
[*] Far3 build 2078.


2011.06.16
[%] Issue 403, Issue 404: При 'Far /w' в фар не передавались нажатия мышки и некоторые клавиатурные сочетания (CtrlUp, CtrlDown, и т.п.).
[%] Issue 402: После окончания выполнения консольной команды в некоторых случаях некорректно отрисовывались панели.


2011.06.10
[%] Issue 374: при запуске DOS-приложений (ntvdm.exe) выскакивает MessageBox.
[%] В некоторых случаях при запуске DOS-приложений (ntvdm.exe) схлопывался размер окна ConEmu.
[%] В некоторых случаях при выходе из Far или запуске консольных команд ConEmu.exe мог аварийно завершаться.
[%] Issue 382: в поле 'Another user' диалога создания новой консоли нельзя было ввести имя в формате 'domain\user'. В поле разрешена горизонтальная прокрутка.
[%] В некоторых случаях окно ConEmu не закрывалось после завершения консольных процессов.
[%] Issue 384: Не отключался флажок 'Install keyboard hooks'.
[%] Issue 400: Правки в запускаторе.
[*] Far3 build 2027.
[+] Drop в любую вкладку, а не только в Far, например в cmd.exe. При Drop в не-Far-консоль вставляются полные имена перетаскиваемых файлов.
[*] Запуск консоли с флагом SEE_MASK_NOASYNC.
[*] Пункт 'Terminate' меню таба и кнопка 'Terminate' (диалог пересоздания консоли Win-W) игнорируют флажок 'Safe Far close'.


2011.03.08a
[+] GuiMacro. Новая функция: FontSetName("FontFaceName"[,FontHeight[,FontWidth]]).


2011.03.08
[%] Issue 297: Desktop mode и несколько мониторов.
[*] Issue 332: Fixed/Cascade и подобные настройки не запрещаются в Maximized.
[*] Плагины готовы к Far3 build 1900.
[*] Добавлен msi для x64. Набор файлов тот же что и в msi x86, но только x64 версия может устанавливаться в 64битный 'Program Files'.


2011.03.06
[%] Правки в запускаторе.
[%] Не работал ввод через IME. Пока что ввод остается в отдельном плавающем окне, но результат попадает в консоль. Поскольку FAR игнорит нажатия с VK=0, иероглифы посылаются как VK=VK_PROCESSKEY.
[%] Issue 373: падение при запуске 'wmic'.
[!] Экспериментально. Для планируемой поддержки возможности горизонтальной прокрутки ConEmu отрисовывает только видимую область RealConsole.
[*] Разрешено сохранение опции 'Use ConEmuHk injects'. По умолчанию - включена.
[*] Два новых файла в поставке (ConEmuCD.dll и ConEmuCD64.dll). В них вынесен код сервера консоли, чтобы разгрузить ConEmuHk.dll/ConEmuHk64.dll.
[+] Интеграция с DosBox. Теперь можно запускать старые Dos-приложения в 64-битных ОС прямо из Far или батников.
    DosBox брать здесь: http://www.dosbox.com
    DirectLink: http://sourceforge.net/projects/dosbox/files/dosbox/0.74/DOSBox0.74-win32-installer.exe/download
    Ставить сюда: %ConEmuBaseDir%\DosBox
    Создать (или переименовать) файл конфигурации: %ConEmuBaseDir%\DosBox\DosBox.conf
    Дописать в конец файла команды монтирования дисков, смысл в том, что при запуске приложений
    в DosBox из ConEmu пути должны совпадать. Если на вашем NTFS диске отключены короткие имена
    Dos-приложение может и не запуститься. Для возможности запуска Dos-приложений из батников
    требуется включение флажка 'Use ConEmuHk injects'.
    Внимание: Диск Z: в DosBox зарезервирован под эмулятор.
[*] Через системное меню ConEmu можно было вызвать несколько экземпляров диалога свойств RealConsole. При закрытии одного из них валился conhost. /исправлено уже давно/
[*] 'Extend foreground colors...' и 'Extend fonts' работают только для Far.


2011.02.27
[*] Documentation (http://code.google.com/p/conemu-maximus5/wiki/ConEmu) updated. Anybody read it?
[%] Правки в запускаторе.
[*] Добавлена опция 'Use ConEmuHk injects'. В release сборке пока отключена.
[*] При включении лога 'Shell and processes' (вкладка Debug) отображаются LoadLibrary & FreeLibrary.


2011.02.25
[%] Правки в запускаторе.
[+] "ConEmuC.exe /GUIMACRO <macro command>". Возвращает errorlevel==0 и %ConEmuMacroResult% в случае успеха.
    Пример: "%ConEmuBaseDir%\ConEmuC.exe" /GUIMACRO WindowMinimize


2011.02.24
[%] В 110223 поломалось отображение длинного вывода последней команды в Far1.
[*] Немного макросов в папке Far3_reg.


2011.02.23
[*] Настройка на вкладке 'Debug' - что журналировать. Закрытие окна настроек == выбор 'Disabled'.
[*] Плагины готовы к Far3 build 1889.
[*] По возможности при выполнении команд пропускаем cmd.exe (например, при выполнении команды 'netsh').


2011.02.18
[!] Хуки системных функций теперь устанавливаются не через плагин, а через ConEmuHk.dll (что позволит обрабатывать не только far.exe, но и любой процесс, запущенный в этой консоли). В результате вылечен Issue 60, на подходе Issue 65 и портабельный реестр. Часть кода по «внедрению» взята из Console2.
[!] Переменная окружения "ComSpec" более не переопределяется, а переменная "ComSpecC" теперь не создается.
[!] Настройки конфигурации без имени (нет ключа "/config «name»" в параметрах ConEmu.exe) хранятся в "Software\ConEmu\.Vanilla". Если ключ "Software\ConEmu\.Vanilla" ранее отсутствовал - он создается копированием из "Software\ConEmu".
[!] В тестовом режиме - поддержка Far3.
[!] Изменения записи событий в консольный буфер ввода (ждем чистого буфера только для мышиных кнопок).
[!] В диалог настроек добавлена вкладка 'Debug'. Если она открыта - в ней отображается журнал запускаемых в консоли процессов.
[%] Issue 60: зависание chcp на некоторых системах.
[%] Issue 364: Visual Studio post build events.
[%] При отключенной "[ ] Show column titles" не стартовал D&D.
[%] Panel Views. Не ловились изменения цвета последнего элемента панели.
[*] Отказ от WinEvents в сервере (ConEmuC.exe).
[*] На вкладке Info показывает размер и видимость курсора.
[*] Некоторые изменения умолчательных настроек.
    Включено выделение мышкой (LShift - Text, LAlt - Block). RClick в BufferMode выполняет Paste.
    Darkening = 255, Replace color indexes = '#1'.
[*] Если на экране есть выделение (Text/Block) то RClick всегда делает Copy. (Не имеет отношения к Far's Grabber - AltIns).
[*] Реструктуризация макросов Far в поставке (папки Far1_reg, Far2_reg, Far2_fml).
[*] Добавлен макрос для Far1 - изменение размера шрифта в ConEmu колесом мышки.
[*] Для включения портабельности настроек *ConEmu* достаточно создать _пустой_ файл 'ConEmu.xml' рядом с ConEmuC.exe или с ConEmu.exe.
[*] В меню по стрелке у кнопки '+' на toolbar отображаются укороченные строки запуска, чтобы меню не было слишком широким. При наведении курсора мышки на укороченный пункт меню - всплывает подсказка с полной строкой запуска.
[*] Issue 288: В меню окна (правый клик по заголовку окна) добавлен пункт 'New console...', при удерживании Shift отображается диалог подтверждения, даже если флажок 'Create confirmation' отключен.
[*] Проверка значения "FullScreen" в ключе [HKEY_CURRENT_USER\Console] для Vista и выше.


2011.01.26
[*] По умолчанию hotkey 'Win-Del' не устанавливается. Включается через реестр или xml-файл.
[+] GUI-макросы.
    FontSetSize(Relative,N)
     - изменить размер шрифта в ConEmu
       Relative==0: N - желаемая высота шрифта
       Relative==1: N (+-1, +-2) - увеличить/уменьшить шрифт
       Возвращает - "OK" или "InvalidArg"
    IsRealVisible
     - Проверка, видима ли RealConsole, "Yes"/"No"
    IsConsoleActive
     - Проверка, активна ли RealConsole, "Yes"/"No"
[+] В реестре или xml можно настроить "ConInMode" - флажки 'QuickEdit Mode'/'Insert mode' в свойствах RealConsole при старте.


2011.01.24
[*] Откат 'far /w' по умолчанию.
[+] Настраиваемый hotkey (Win-X) для запуска новой консоли "cmd.exe".
[+] Настраиваемый hotkey (Win-Del) для закрытия текущей консоли без подтверждения.
[+] Опция ("Multi.AutoCreate") Win-Number создает новую консоль, если номер свободен.
[+] Опция ("Multi.Iterate") Win-Number перебирает табы активной консоли.
[+] Опция ("Multi.LeaveOnClose") не закрывать окно ConEmu после закрытия всех консолей.


2011.01.23
[%] В x86 версии не запускались приложения из C:\Windows\Sysnative.
[%] 'Text selection' не копировал текст, если начало выделения было правее/выше конца выделения.
[%] В последних версиях Far 2 (при запуске без ключа /w) отвалилось включение длинного вывода программ.
[*] В архивы (7z) предыдущих версий случайно попал ConEmu64.exe. Для желающих, 64битная версия GUI доступна в msi.
[*] При запуске ConEmu без параметров Far 2 по умолчанию запускается с ключом /w.
[+] Положено начало 'GUI-макросам'. Смысл в том, чтобы дать фару 'порулить' параметрами ConEmu.
    Пример вызова через callplugin (Far 2):
    $if (callplugin(0x43454D55,"IsConEmu()")!=0 && env("ConEmuMacroResult")=="Yes") MsgBox("Macro", "Far started under ConEmu") $end
    В Far 1 (врочем, как и в Far 2) для исполнения GUI-макроса (и просмотра его результата) можно использвать меню плагина.
    Пока что поддерживаются следующие функции:
    IsConEmu()
     - возвращает "Yes" если Far прицеплен к ConEmu
    FindEditor("<FullEditFileName>"), FindViewer("<FullViewerFileName>"), FindFarWindow(<WindowType>,"<WindowTitle>")
     - возвращает "Found:<номер консоли>", "Blocked", или "NotFound"
    WindowMinimize() или WindowMinimize(1)
     - свернуть окно (если "1" - то в TSA)
    MsgBox("<Text>","<Title>",<ButtonType>)
     - показать GUI MessageBox, вернуть нажатую кнопку ("Ok", "Cancel", "Retry", и т.п.), ButtonType == Windows SDK.



2011.01.18
[%] В меню по стрелке у кнопки '+' на toolbar первый пункт мог быть пустым.
[+] Удерживая Shift при выборе пункта меню (стрелка у кнопки '+') открываем диалог параметров новой консоли.
[+] Issue 355: Что-то вроде общего пространства редакторов/вьюверов. Пример в 'ConEmu.Addons\ConEmu.Editor.fml'.


2011.01.17
[%] Issue 347: Странность показа данных на закладках. 
[%] Не выполнялся батник: ver|find "6."
[*] 'Press Enter to close console' -> 'Press Enter or Esc to close console'.
[+] Стрелка у кнопки '+' на toolbar показывает меню из последних 16 запущенных команд, для быстрого запуска новой консоли.


2011.01.15
[%] Issue 350: Click right button on close icon don't work while caption is hidden.
[%] Issue 351: В Windows XP после обновления Far до версии 2.0 build 1783 перестал работать вывод консольных команд.
[%] Issue 353: Не работал Detach в FAR (CtrlAltTab).
[%] Issue 354: "mycmd ." точка не передается команде.
[*] Issue 349: При желании, в 64-битных ОС можно использовать 64-битный ConEmuC64.
[+] Тестируем первую версию msi-инсталлятора.


2011.01.03
[%] Issue 346: не работает запуск с комстроки.


2010.12.30
[*] Небольшие правки.


2010.12.25
[%] Issue 345: Падение ConEmu.exe в некоторых случаях при просмотре файлов, содержащих '&' в имени папки/файла.


2010.12.24
[%] Issue 340: При включенном ScrGadgets не работали RClick, D&D, и пр.
[%] Issue 343: Блокировались табы после ошибки поиска в редакторе.
[+] 3-е состояние флажка 'Always show scrollbar'.


2010.12.17
[*] Меню для таба.
[*] Некоторые изменения background-api.


2010.12.15
[%] ConEmu.exe мог падать при работе background-плагинов.
[%] Attach из плагина не работал, если ConEmu.exe не лежал рядом с ConEmuC.exe.


2010.12.14
[%] Can't open console data file mapping. ConEmuFarMapping.xxxx
[*] Не работал аттач из консоли, запущенной под администратором.
[+] Usability of buffer scrollbar. Прокрутка автоматически всплывает при изменении позиции в консоли. При слежении за курсором мышки всплытие и скрытие производится с задержкой.


2010.12.12
[%] В Win2k даже при наличии Far-плагина при закрытии консоли возникало 'Root process was alive less than 10 sec'.
[%] Правки /ATTACH.
[%] В некоторых случаях, при включении прокрутки (Long console output), консоль прокручивалась до самого низа.
[%] Drag-n-Drop: При дропе из некоторых источников копировался только первый файл.
[+] Drag-n-Drop: Поддержка дропа из 'устройств' папок и в папки с длинными путями.
[*] При сильной загрузке процессора ConEmu мог завершиться на этапе старта после появления в консоли сообщения 'Process was not attached to console. Is it GUI?'.
[+] Для удобства аттача свободных консолей в поставку включен файл 'Attach.cmd'.
[*] Уточнения API для 'background' плагинов. Обновлен 'Panel colorer' (исправленные исходники доступны на svn).


2010.12.07
[%] Issue 334: Правки 'Attach to ConEmu' из плагина.
[+] Issue 318: Расширена настройка действий правой и средней кнопки мышки для работы с буфером обмена. Например, на правую кнопку мышки можно назначить Paste для 'режима с прокруткой' (cmd), или всегда, при нажатом LShift. Напомню, что 'far /w' не считается 'режимом с прокруткой'.
[+] Issue 283: 'Always show scrollbar' option.
[+] Issue 333: При отключенной 'Always show scrollbar' полоса всплывает при наведении мышки только если НЕ нажаты Ctrl или Alt или Shift или левая кнопка мышки.


2010.11.29
[%] Issue 327: 'Syncho events are pending!' по F10.
[%] Issue 324: 'mh_ConEmuCInput not found'.


2010.11.28
[%] Far2 падал при попытке выгрузки плагина (http://bugs.farmanager.com/view.php?id=1604).
[*] 'Tray' переименован в 'TSA' (Taskbar Status Area).
[+] Добавлен флажок 'Always show TSA icon'.


2010.11.25
[%] Issue 298: HG & Araxis (detached comspec).
[%] Issue 321: PanelView, некорректный скроллинг при выделении элементов панели.
[%] Issue 322: Если Far был запущен без ConEmu.exe, то при наличии плагина ConEmu.dll происходило падение при открытии редактора/вьювера.


2010.11.20
[%] PanelView. Не работал в 'far /w'.
[%] Issue 317, 308: В некоторых случаях терялся PID процесса FAR с плагином ConEmu.
[%] При сильной загрузке процессора в Win7 нажатие Win+Number могло проваливаться в Explorer.
[%] Issue 316: Ненужное сообщение об ошибке записи в xml, при отсутствии прав на изменение файла.
[%] Таб не переключался в другую консоль, если активируемое окно фара заблокировано диалогом.
[*] Новая реструктуризация.
    64-битные версии ConEmu.exe & ConEmuC.exe более не поставляются за ненадобностью.
    ConEmu.exe помещен в корень дистрибутива, ConEmuC.exe и прочие файлы в папку ConEmu.
    При желании (чтобы не 'захламлять' папку фара) ConEmu.exe можно также переместить в папку ConEmu.
    Плагины для Far как и ранее лежат в папке 'Plugins'.
    Файл ConEmu.xml и шрифты могут лежать как рядом с ConEmu.exe, так и в папке ConEmu (рядом с ConEmuC.exe).
    Старые файлы рекомендуется удалить самостоятельно.
[+] Переменная окружения 'ConEmuBaseDir', содержит папку с файлами ConEmuC.exe, ConEmuHk.dll, и т.п.


2010.11.08
[%] Issue 308: В некоторых случаях терялся PID процесса FAR с плагином ConEmu. В результате мог отваливаться D&D и прочее.
[%] Issue 312: Мусор по краям консоли в Maximized & FullScreen при включенном центрировании.
[+] Issue 313: Global hotkey may be used for minimize/restore of ConEmu window (Win+C by default). Кнопку ('C' по умолчанию) можно настроить через параметр 'MinimizeRestore', модификатор соответствует HostKey (кроме Apps и без различия правый/левый). Глобальный хоткей работает только в первом запущенном экземпляре ConEmu, и только если он уже не зарегистрирован для какого-либо другого приложения. После закрытия первого запущенного экземпляра ConEmu хоткей 'наследуется' другим экземпляром.
[+] Авторегистрация шрифтов выполняется не только для *.ttf файлов в папке программы, но и в текущей (current directory).
[+] В 'ConEmu Underlines' добавлен флажок 'Hilight plugin panels'. (Плагин предназначен для демонстрации возможностей API)
[+] В корне дистрибутива помещен небольшой 'starter' с именем 'ConEmu.exe'. Предназначен для более удобного запуска Far Manager-а в ConEmu. Этот файлик просто выполняет запуск ConEmu\ConEmu.exe с теми же аргументами.
[+] 'RighClick 4 context menu'. При третьем состоянии, в течении 'длинного правого клика' отображается Throbber вокруг курсора. Когда кружок замыкается - после отпускания правой кнопки мышки будет показано EMenu.
[*] Telnet detector changed. Теперь переменная 'TERM' игнорируется.
[*] Blues16.bmp & Greys16.bmp from ccaidd.


2010.11.01
[*] PanelView. Асинхронная загрузка иконок и превьюшек.
[%] Исправлены некоторые баги перезапуска консоли.


2010.10.22
[%] Issue 311: Падение Far 1.7x при переключении табов.
[%] Правки 'ConEmu Underlines'. Включение/отключение и смена цвета налету, без закрытия диалога настройки.


2010.10.21
[%] Issue 306: Не работало переключение раскладок Ильи Бирмана.
[+] Системное меню всплывает по Win+Alt+Space.
[+] Перейти в 'полноэкранный' режим можно также по Ctrl+Win+Enter.
[+] Win+Alt+P открывает диалог настроек ConEmu.
[+] В поставку добавлен плагин 'ConEmu Underlines'. Смысл - разлиновать рабочую область панелей Far Manger. Плагин можно включить через F11 (или AltShiftF9 в панелях) в FAR и выбрать желаемый цвет линий. В настройках GUI должен быть включен флажок 'Allow Plugins' в группе 'Background Image'. Активация фичи отключает отображение файла 'Background Image'. Если вместо ожидаемой картинки отображается черный фон - вероятно движок 'Darkening' установлен в 0. Передвиньте его вправо.


2010.10.20
[%] В последних сборках на некоторых машинах мог отвалиться D&D.
[*] Расширенное логирование раскладок клавиатуры.


2010.10.19
[%] Issue 299: При включении '/log' ConEmuC падал при выходе.
[+] Добавлен флажок "Send Alt+Space to console".
[*] Доработки Background API.


2010.10.17
[!] Реструктуризация поставки ConEmu. Исполняемые файлы, WhatsNew, Addons, Settings и пр. перемещены в подпапку "ConEmu". Сделано для удобства распаковки в папку Far Manager (чтобы не мешать файлы). Удалите старые файлы ConEmu!
[!] Обе версии ConEmu (x86 & x64) теперь поствляются в одном архиве (добавлены файлы ConEmu64.exe, ConEmuC64.exe, ConEmuHk64.dll).
[%] WinXP. Консоли не переключались по RWin+Number.
[%] Ошибочное отображения в табе заголовка соседней консоли во время создания новой консоли.
[%] PanelView. При попытке запуска плагина возникала ошибка "-1" в Far x86 & ConEmu x64.
[%] Issue 218: Побеждено мелькание кейбара при ресайзе окна.
[%] Не всегда правильно работало переключение раскладок и слежение за раскладкой в консоли (Win7x64).
[*] PanelView. Изменена реакция на PgUp/PgDn в режиме Tiles.
[+] int WINAPI SyncExecute(SyncExecuteCallback_t CallBack, LONG_PTR lParam);
[*] При запуске без параметров ConEmu пытается искать FAR: a) в папке с ConEmu.exe; b) в текущей директории; c) на уровень вверх от ConEmu.exe. Если Far.exe не найден - запускается cmd.
[+] Если другие плагины Far экспортируют функцию "void WINAPI OnConEmuLoaded(struct ConEmuLoadedArg* pConEmuInfo);"
    то ConEmu.dll вызовет ее после инициализации плагина ConEmu или после аттача к ConEmu GUI.


2010.09.19
[%] При минимизированном conemu не пропадал зеленый градусник на панели задач.
[%] Не обновлялся заголовок таба вьювера при смене файла через Gray+/Gray-.
[%] CtrlBreak не прерывал 'зависшие' макросы в Far.
[%] В некоторых случаях на Windows XP при запуске могла мелькать RealConsole.
[%] Issue 274: Окно RealConsole больше не двигается в процессе работы. Флажок 'Lock real console pos' убран за ненадобностью.
[*] Для корректного отображения EMenu (во всех его режимах) перехватываются функции GetWindowRect и ScreenToClient.
[*] Issue 280: Навигация в режиме тумбнейлов.
[+] PanelViews теперь доступен и в Far1.


2010.09.06
[%] Фон, заданный плагином отображался не только в Far.


2010.09.04
[%] Issue 290: Exception triggered in CRealConsole::MonitorThread.
[*] Background image: картинка затемняется в соответсвии с "Fade contents when inactive".
[*] Background image: флажок 'Allow plugins' в третьем состоянии разрешает отрисовку фона плагинами только в панелях.


2010.09.03
[%] В консоли не детектился 'одноциферный' прогресс операции.
[%] При отключенном 'Fix FAR borders' не всегда срабатывал 'Enhance progressbars and scrollbars'.
[+] CECMD_SETBACKGROUND.
[+] Background image: автоматическое перечитывание измененной картинки.
[+] Background image: режимы Stretch & Tile. Для примера использования 'Tile' добавлен файл 'ConEmu.Addons\Lines*.bmp' для высоты шрифта 16 и 18. Для 'Lines*.bmp' рекомендуется оставить в 'Replace color indexes' только цвет панелей ('#1' в стандартной цветовой схеме фара).
[+] Background image: в окне настройки разрешено редактирование поля 'Replace color indexes'.
[*] Обработка невозможности создания шрифтов.
[*] Enhance progressbars: В некоторых случаях на "темных" мониторах 25% серый не отличался от черного. Добавлен параметр "PartBrushBlack", правка только через реестр/xml.


2010.08.14
[*] Закрытие фара макросом (SafeFarClose) выполняется только если фар подает признаки жизни.
[*] Issue 281: затычка для PgUp/PgDn.


2010.08.04
[%] Поправлено движение мышки при нажатых кнопках (надеюсь изничтожено неожиданное закрытие диалогов по RBtnUp).
[%] Far начинал реагировать на 'No zone check' только после перещелкивания флажка.
[+] Достало виндовое окошко 'End program', поэтому все-таки добавлен флажок 'Safe Far Close'. По умолчанию включен. Если включить - при закрытии ConEmu крестиком в плагин Far'а посылается макрос:
    "@$while (Dialog||Editor||Viewer||Menu||Disks||MainMenu||UserMenu||Other||Help) $if (Editor) ShiftF10 $else Esc $end $end  Esc  $if (Shell) F10 $if (Dialog) Enter $end $Exit $end  F10".
    Макрос можно настроить (реестр/xml), параметр "SafeFarCloseMacro".
    Внимание! Если перед закрытием окна в Far открыты редакторы - они могут быть сохранены в режиме сохранения изменений.
[*] Некоторые изменения в установке хуков (плагин).


2010.07.04
[%] Issue 29: Сбивался ClearType при переключении режима дисплея.
[%] Issue 275: Любителям консоли шириной 341 символ.
[+] Добавлена визуальная настройка шрифта для RealConsole. Запускается с вкладки 'Features', кнопочка рядом с 'Show real console'.
[+] Перед запуском консоли ConEmu проверяет корректность шрифта указанного в настройке для RealConsole. Если шрифт не установлен в системе, не является юникодным (*.ttf), или не зарегистрирован в реестре - отображается диалог настройки шрифта.
[+] Добавлен флажок 'Lock real console pos'. При его включении невидимая реальная коноль не двигается (не 'убегает' от курсора мыши).
[*] В ConEmu Panel Views добавлен самостоятельный модуль ico (иконки в gdi+ больше не отдаются).


2010.06.28
[%] Продолжение '%comspec% /K'.
[%] Размер после возвращения из консольных приложений.


2010.06.27
[%] Продолжение 'far /w'. Некорректный ресайз окна при переключении вкладок.
[%] Issue 211: Уменьшена прожорливость неактивных консолей.
[%] Issue 264: переключение между вкладками после AltF9 / AltEnter.
[%] Issue 266: AutoTabs при /w.
[%] Issue 267: Сбивалось разрешение после возвращения из досовского приложения.
[%] Issue 268: по окончании копирования (и т.п.) оставался красный прогресс на таскбаре.
[%] Issue 269: Игнорировался ключ /K: '%comspec% /K'.
[+] В 'PanelViews' в режиме Tiles теперь для PE файлов (*.exe, *.dll, и пр.) отображается версия, битность и флаги Far1/Far2, .Net и Upx.
[+] Добавлена новая настройка - флажок 'No zone check', по умолчанию отключен. Влияет на выполнение фаром *.exe файлов. Same as appeared in Far 2 build 771 and disappeared after 1464.
[*] Автоскрытие полосы прокрутки при уезжании курсора мышки за пределы окна.


2010.06.11
[%] Issue 257: Background Image при 3м состоянии опции Monospace.
[%] Не всегда корректно определялось наличие PanelTabs.
[%] Issue 254: Fix Alt on AltTab теперь и для AltF9.
[%] 'Can't send console event (pipe)' больше не показывается.
[%] Issue 261: Заглушка при выполнении HttpSendRequest.
[*] Дополнительное логирование RClick (ConEmu.exe /log).


2010.06.10
[%] Падение при закрытии Far x64 при загруженном ConEmuTh.dll.
[*] Еще немного 'far /w': контекстное меню по правой кнопке, драг правой кнопкой.
[*] Плагин ConEmu.dll в списке плагинов теперь отображается просто как 'ConEmu'. Макросы для Far 1.7x переделаны на 'menu.select'.
[?] Issue 261: в поиске...


2010.06.09
[%] При запуске консольных приложений по ShiftEnter (-new_console) не включался режим буфера.
[%] Не устанавливалась ConEmuArgs.
[%] После показа не пряталась админская консоль в Win7.
[%] Убран еще один пережиток ConsoleCharWidth.
[%] При выполнении консольных команд дублировался CtrlC (^C).
[%] Can't send console event (pipe).
[%] Issue 259: Не происходила отрисовка при отключенных табах.


2010.06.08
[%] Поломался драг при постоянном верхнем меню.
[%] Не работали PanelViews при постоянном верхнем меню.


2010.06.06
[%] Issue 246: Если не удалось установить флаг 'AlwaysOnTop' для RealConsole - после CtrlWinAltSpace фокус не будет возвращаться в ConEmu.
[%] При закрытии модального редактора/вьювера не обновлялись табы.
[%] Issue 244: В некоторых случаях ошибочно разрешался переход на другие табы.
[%] Issue 249: Унификация переменных окружения (ConEmuDir, ConEmuArgs, ConEmuHWND).
[%] Mouse cursor shape.
[%] Активация редактора/вьювера при наличии QSearch в панелях.
[*] Упрощен способ получения списка окон (табы).


2010.05.31
[%] Во время множественного запуска консольных программ (i.e. компиляция проекта) ConEmu блокировался.
[!] Изменен алгоритм обновления табов Tabs.
[%] После смены окна средствами Фар - слетел стек последних открытых.


2010.05.30
[%] Отвалилась установка BufferHeight на время выполнения из Far (без /w) консольных команд.
[%] В некоторых случаях колесо мышки не проходило в консоль.
[%] Поправлен 'Hourglass if not responding'.
[%] После 'Jump to' в 'Multimedia Viewer' переставала работать клавиатура.
[+] Option 'Save window size and position on exit'.


2010.05.26
[%] Измененный список процессов консоли не приходил в GUI до любого изменения содержимого консоли.
[%] Keyboard fixes for dead charachers.
[*] Доработки PanelViews.
[*] Drag&Drop. Разрешено создание ярлыков при драге более одного файла. Side effect: теперь можно дропать в FooBar2000 standard interface.
[+] Поддержка Far2 /w.


2010.05.20
[*] PanelViews. Mouse is working now. Small restriction: when clicked item is not visible on real panel - plugin executes macro "panel.setposidx(...)" instead of left or right click.
[%] Minor D&D bugfixes.
[%] Не работал 'Edit/View console output'.


2010.05.18
[%] Strange charachers.
[*] Доработки PanelViews.


2010.05.18
[%] Поломалась палитра для 'Fade contents…'.
[%] Drawing performance issues.
[!] Изменен способ передачи содержимого консоли в GUI - опять пайпы. FileMapping с информацией о консоли (CESERVER_REQ_CONINFO_HDR) создается.
[*] Поддержка новых макросных индикаторов FAR2.
[*] Некоторое улучшение обработки закрытия консоли в режиме 'Press Enter to close console…'.
[+] В диалоге плагина 'Unicode CharMap' блок символов отображается соответствующим шрифтом. Опция 'Extend Unicode CharMap' включена по умолчанию.
[*] Доработки PanelViews. Автоповорот превьюшек по EXIF. Подсказки в настройках.


2010.05.05
[%] Issue 197: Неясное поведение HideCaption.
[%] Issue 229: Не переключается опция 'Block inactive cursor'.
[*] Доработки PanelViews.


2010.04.29
[%] Не скрывался PictureView на Win7, при переходе по вкладкам, когда консоль и ConEmu были запущены под разными пользователями.
[%] В некоторых случаях при запуске новой консоли под администратором в Win7 возникала ошибка: Can't open ConEmuC process! Attach is impossible!
[*] В окне 'About' показывается битность приложения.
[*] Доработки PanelViews.


2010.04.28
[%] В некоторых случаях после запуска 16бит приложений ConEmu не закрывался (из-за процесса ntvdm.exe).
[!] Во избежание некоторых казусов - мышиные события не посылаются в консоль, когда в ней есть прокрутка.
[*] RightClick на табе при удерживаемом Control = MiddleClick: сразу выполняется Close для фара или поднимается диалог пересоздания консоли.
[+] Опция 'Sleep in background' - снижать частоту опроса и отрисовки когда ConEmu не в фокусе.
[+] Issue 217: В настройке в выпадающих списках моноширные шрифты подсвечиваются жирным.
[*] Мышиный курсор над клиентской частью окна меняется только когда окно ConEmu в фокусе.
[*] Во время работы Telnet.exe игнорируется размер консольного курсора.
[*] Имя параметра 'ConsoleCharWidth' заменено на 'ConsoleFontWidth' (как и было ранее указано в reg файле).
[+] Для удобства, имя пользователя и пароль теперь можно ввести в окне подтверждения создания новой консоли. Флажок 'Run as' (или 'Run as administrator' в Vista и выше) по прежнему работает самостоятельно.
[*] Добавлена настройка позволяющая отключить флэшинг иконки на панели задач и рамки окна (для фара и для остальных приложений раздельно). Третье состояние флажков - мигать только иконкой, не трогая рамку окна.
[+] Thumbnails and Tiles - FAR2 only. Плагин, позволяющий в Far Manager менять вид панелей - отображение иконок, превьюшек, и прочего. В качестве бонуса - просмотр 'на лету' иконок и картинок в плагине ImpEx. Все размеры и цвета настраиваются на вкладке 'Views' настроек ConEmu.


2010.04.04
[%] Issue 197: Некорректно включался 'Hide caption' в уже развернутом окне.
[*] Обновлен макрос ShiftEnter для панелей.
[*] D&D мог не работать в WinPE.
[*] Оптимизирована передача ввода в консоль (обработка пачек сообщений).
[*] Ready for Thumbnails.


2010.03.27
[%] Не работало обратное переключение консолей (по умолчанию Win+Shift+Q).
[*] Перетрях диалога настроек. Добавлена новая вкладка 'Tabs'. На ней теперь настройки хоткеев, мультиконсоли и табов.
[*] «Host-key»+Number можно отключить.
[*] Разрешен D&D на с активной на активную панель в режиме создания ярлыка.
[+] RClick на табе или кнопке с номером консоли на тулбаре вызывает контекстное меню.
[+] В контекстном меню (таб/тулбар) созданы пункты 'Save' и 'Save all' для сохранения открытых редакторов FAR в активной(!) консоли. Макрос для 'Save all' можно настроить, для 'Save' выполняется макрос 'F2'.
[+] В контекстном меню (таб/тулбар) создан пункт 'Detach' - показать RealConsole и отцепиться от нее (если это единственная консоль - ConEmu будет закрыт).


2010.03.24
[!] Обновлен сертификат! В старом был неправильно указан 'ComEmu'.
[%] В консоль не проходила комбинация AltShiftEnter.
[%] D&D ошибочно активировался, если помимо указанного (или вообще отсутствующего) модификатора - удерживались и другие. Например для драга ЛКМ модификатор вообще не был указан, но драг начинался при удерживаемом Alt.
[*] Изменен способ передачи ввода в консоль (теперь пересылается только через pipe).
[*] В неактивных консолях снижается частота опроса.


2010.03.20
[*] ConEmuHk.dll (обработка Win-Number) загружается только в ОС Vista и выше. У пользователя однократно запрашивается разрешение на установку хука (дабы не было вопросов 'Почему всплыл антивирус').
[+] Доработано выделение/вставка текста консоли.
    * Выделение теперь может быть 'блочным' (как в обычной консоли) или 'текстовым' (как в текстовых редакторах).
    * В меню окна добавлены пункты 'Mark block' и 'Mark text'.
    * Добавлена настройка клавиш мышки и модификаторов. Теперь можно указать когда разрешено выделение мышкой:
      только при наличии прокрутки (Buffer only, по умолчанию), или всегда (Always).
      Можно указать модификатор (Alt, Shift, ...) для обоих типов выделения (Block & Text).
      Можно выбрать действия для правой и средней кнопки мышки (Copy/Paste).
      Можно настроить цвет фона и текста для выделения.
    * Снято ограничение на флажок 'Mouse' в FAR (его можно оставлять включенным).
    Note. Paste выполняется средствами консоли.
    Note. Копирование выполняется 'с экрана', то есть с выделением в редакторе FAR не имеет ничего общего.


2010.03.18
[+] Issue 69: Добавлена поддержка выделения/копирования текста мышкой (аналог консольного 'QuickEdit mode').
    Если этим хочется пользоваться в FAR2 (AltIns по какой-то причине не устраивает) - необходимо
    отключить флажок 'Mouse' в настройке FAR 'Interface settings'.
[*] На вкладке 'Info' появился новый счетчик.


2010.03.09
[%] Issue 206: Win-Number вызывал Start menu, если Win отпускался перед Number.
[*] Documentation was started as Wiki (http://code.google.com/p/conemu-maximus5/w/list). Comments and additions are accepted.


Maximus5 - 2010.03.08
[+] Обработка Win-Number в Windows7. При отсутствии ConEmuHk.dll эти комбинации обрабатываются ОС.


Maximus5 - 2010.03.06
[%] Падение, если командный файл запуска консолей не содержал перевода строки.
[%] Issue 203: Уточнения в 'Press Enter to close console'.
[+] DblClick на правой/левой рамке окна растягивает окно по горизонтали, а на верхней/нижней - по вертикали.


Maximus5 - 2010.03.04
[%] Issue 198: Redraw in FAR1.
[%] Issue 199: Не отключался Fade-effect.
[%] Issue 201, Issue 202: Ошибочно включался режим прокрутки после аттача консоли к ConEmu.
[%] При включенном 'Transparent «User screen»' или отключенном 'Monospace' в некоторых случаях падали с переполнением стека.
[*] Minor resize optimization.


Maximus5 - 2010.02.23
[%] Issue 196: ConEmu вызывал ошибки отрисовки в FAR.
[*] Форматированный вывод настроек в XML (для новых ключей и значений).


Maximus5 - 2010.02.22
[%] При DblClick по заголовку окна устанавливался некорректный размер консоли.
[%] Issue 189: На некоторых машинах после Detach в FAR (CtrlAltTab) происходила перезагрузка.
[%] Issue 190: ConEmu20100213, выгрузка плагина ConEmu.
[*] Issue 195: Fade effect и Download Master.
[%] Убрана небольшая задержка при старте ConEmu.
[%] После запуска 'ConEmu.exe /bufferheight 0 /cmd ...' не работала кнопка перехода в буферный режим.
[%] Контекстное меню не всплывало если правый клик приходил как RDblClick (он всегда уходил в консоль как RClick).
[*] Флажок 'Auto' запрещен при выборе фиксированного размера растрового шрифта.
[*] На вкладку 'Colors' добавлена настройка 'Block inactive cursor' (курсор в виде пустого прямоугольника, когда консоль неактивна).
[+] Добавлена визуальная настройка Fade-effect (затенение содержимого консоли когда ConEmu не в фокусе). Теперь можно как затенять, так и осветлять содержимое консоли.
[*] Добавлена задержка скрытия рамки в режиме 'Hide caption always'. В диалог настройки добавлена возможность задания ширины рамки и длительности задержек.
[*] При ресайзе проверяем максимально допустимый размер real-консоли.
[*] Немного ускорена передача клавиатурного и мышиного ввода в консоль.
[+] Возможность настроить 'Host-клавишу' для горячих клавиш мультиконсоли. Ранее были жестко выбраны правый или левый Win.
    Теперь можно выбрать Win, Apps, и [правый|левый|любой] Shift/Ctrl/Alt. Можно выбрать комбинацию до 3-х модификаторов.
    Включение в диалоге настройки 'Hotkey settings' обоих флажка модификатора (например LCtrl & RCtrl) означает 'любой'.
    Не рекомендуется использовать Apps в сочетании с другими модификаторами - Apps провалится в консоль.
[*] Доработана прозрачность «User screen». Место под приподнятыми панелями считается прозрачным. CtrlAltShift показывает «User screen» (временно отменяет прозрачность).
[*] В поставку добавлен файл 'ConEmu.Addons\CallPlugin.txt'. В нем перечислены возможные коды команд callplugin (макросы FAR2).
[*] Доработан ресайз панелей мышкой. В FAR2 можно перед началом ресайза высоты зажать Shift, тогда будет меняться высота правой или левой панели (той, по рамке которой щелкнули).
[+] Issue 160: Разрешен драг элемента '..'. При этом перетаскивается текущая папка (не ее содержимое!).
    Внимание: допустимость такого драга НЕ проверяется и остается на совести пользователя.
    При дропе на соседнюю панель предварительно выполняется макрос:
    $If (APanel.SelCount==0 && APanel.Current=="..") CtrlPgUp $End


Maximus5 - 2010.02.13
[%] Поправлена работа в многомониторных конфигурациях (каскад и FullScreen).
[%] Issue 182: При запуске в многомониторных конфигурациях стартует с урезанной шириной.
[%] Issue 183: EMenu появлялось только после движения мышки.
[%] Issue 185: После максимизации окна в заголовоке окна отключаются темы.
[%] Issue 186: Не работал Maximized режим запуска ConEmu при старте.
[%] В некоторых случаях сразу после запуска уменьшался размер окна (ошибка установки мелкого шрифта в real-console).
[*] Когда ConEmu не в фокусе - курсор (если он видим в консоли) отображается прямоугольником.
[+] Fade-effect содержимого консоли когда ConEmu не в фокусе.
[*] Доработано проявляение скрытой рамки с заголовком. Задержку можно настроить.
[*] В Desktop режиме отключены Cascade & FullScreen.
[*] Щелчок правой кнопкой по рамке больше не сворачивает в трей. Только щелчок по крестику.


Maximus5 - 2010.02.11
[%] В 100208 поломался драг - всегда выполнялся Move вместо Copy.
[*] При перетаскивании из корзины учитывается флажок 'Copy by default' (файл из корзины не удаляется).
[*] Изменен способ активации плагина (теперь FAR1 & FAR2 работают одинаково).
[+] 'Always on top' в настройке и системном меню.
[*] Улучшена работа при наличии нескольких мониторов.
[*] Переделано скрытие заголовка 'Hide caption always'. Теперь заголовок скрывается вместе с рамкой, но
    при наведении мышки на скрытый заголовок/рамку - они появляются. Вокруг видимой части остается
    видимой тонкая (1 пиксел) часть рамки. Ширина настраивается "HideCaptionAlwaysFrame".
[+] Желающие иметь FAR на рабочем столе могут поиграться с новой версией. 
    Включать флажок 'Desktop mode'. При желании - настроить стартовый размер и положение.
[+] В тестовом режиме появилась 'прозрачность панелей'. Пока тормознуто и будет переделано.
    Смысл в том, чтобы при скрытии одной или двух панелей вместо них отображался рабочий стол,
    но сохранялась возможность посмотреть «User screen» приподняв край панелей (той же мышкой, например:).
    Включать флажок 'Transparent «User screen» while panel(s) is turned off'.
    По умолчанию установлен цвет 'ColorKey' - '1 1 1', чтобы обычный черный консоли не пропадал как прозрачный.
    Сейчас фича заточена на: плагин ConEmu, черный фон «User screen»; [ ] Always show menu bar; [x] Show key bar.
    При скрытии панели первая ячейка консоли в первой строке не скрывается, чтобы панели можно было
    легко вернуть мышкой.


Maximus5 - 2010.02.08
[%] Issue 176: files dragged from archives has zero size.
[+] В файле настроек xml можно использовать тип long (например <value name="ToolbarAddSpace" type="long" data="24"/>).
[+] При полностью скрытом заголовке окно можно таскать за свободное место бара.
[+] В интерфейс вынесены настройки TrueColorer, ExtendFonts, bgImageColors.
[+] Добавлен Drop из Windows Recycle Bin.
[*] Кнопки на тулбаре стали чуть поменьше.


Maximus5 - 2010.02.07
[%] В некоторых случаях ресайз панелей конфликтовал с плагином PanelTabs.
[%] Issue 174: ConEmu.Maximus5.100206a Баг с отображением панели.
[*] Некоторый перетрях страницы настроек.
[+] В 'Features' добавлен флажок 'Resize panels by mouse'. 3-е состояние можно использовать когда на Ctrl+Left/Right/Up/Down висят макросы. В этом случае изменение размеров происходит после отпускания кнопки мышки.
[+] Issue 164: добавлен флажок 'Hide caption always'. Таскать окошко можно за верхнюю грань рамки.


Maximus5 - 2010.02.06
[%] Не запускалось: conemu /cmd "C:\Program Files\FAR\far.exe".
[%] Issue 172: 	ConEmu10020304: проблема с правым кликом на PanelTabs.
[+] Теперь мышкой можно менять высоту и ширину панелей. При наведении курсора на левый край правой панели или низ правой/левой панели - курсор меняется на сплиттер. Размер панелей меняется банальной отсылкой в консоль Ctrl+Left/Right/Up/Down. Если вы их перемакросили - cрабатывать будут ваши макросы, а не смена размера. DblClick - выравнивает панели. Отключить можно настройкой "DragPanel".
[*] Флажок 'Force monospace' заменен на 3-е состояние флажка 'Monospace'.
[*] Проверка значения "LoadConIme" выполняется только в Vista. В Windows7 проверка больше не производится.
[*] Теперь при нажатии 'Save settings' в диалоге настроек сохраняются все настройки, а не только те, которые можно менять через интерфейс. Сделано для возможности полного переноса настроек в XML из реестра.


Maximus5 - 2010.02.04
[%] Не работал Restart консоли.
[%] Что-то не то было с активацией плагина в FAR 1.7x. Вроде починил...


Maximus5 - 2010.02.03
[%] Issue 167: ConEmu100129: конфликт маленького BackGround Image и colorer.
[%] Issue 168: null pointer exception when there is no taskbar
[%] Issue 170: в некоторых случаях не определялся момент завершения операции.
[%] Стили шрифта (ExtendFonts & FarColorer truemod) работали только при включенном 'Fix Far Borders'.
[*] ConEmuC. Если выполняется 'пустая команда' (ассоциация '@' в фар, и т.п.), то cmd.exe не запускается, высота буфера консоли не меняется.
[*] Minor changes in console resize.
[*] Minor changes in %ComSpec% /c.


Maximus5 - 2010.02.01
[+] Поддержка стиля 'Underline' в FarColorer truemod.


Maximus5 - 2010.01.29
[%] Поломалась смена шрифта 'на лету'.
[%] Плагин принудительно отображал скрытое окно FAR при запуске в Console2.
[%] Ошибочно включался Drag их некоторых меню (плагинов).
[*] Улучшения при детаче: создание нового буфера True-Colorer, по завершении выполнения команды в отключенной консоли отображается 'Press Enter to close console', восстанавливаются табы.
[*] Internal. Некоторые изменения в механизме перехвата функций.
[+] FarColorer truemod. Поддержка новой версии и стилей шрифта (bold/italic/bold&italic).


Maximus5 - 2010.01.25
[+] Улучшена отрисовка курсивом.
[+] FarColorer truemod ready.
[+] После детача FAR (CtrlAltTab) плагин автоматически цепляет созданное окно в новую вкладку ConEmu.


Maximus5 - 2010.01.21
[%] Зависание при переключении в консоль, в которой висит 'Press Enter to close console...'.
[%] Issue 161: Тормоза при AutoTabs.
[%] Issue 159: Can't determine a value of 'LoadConIme'...
[+] Во время запуска ConEmu или создания консоли в первой строке консоли отображается текущий статус.
[+] Issue 73: Добавлен флажок 'Hide caption when maximized'. При его включении, максимизированный режим (AltF9) отличается от FullScreen только видимостью панели задач.
[+] Issue 142: В настройку шрифта добавлен флажок 'Auto'. При включении и ресайзе окна - меняется размер шрифта, а размер консоли в символах остается неизменным.
[*] Скорректирован список размеров растровых шрифтов (теперь отображаются все установленные, с высотой не менее 8).


Maximus5 - 2010.01.16
[!] ConEmu теперь может работать в 'портабельном' режиме. Для включения 'портабельности' переименуйте файл 'ConEmu_Sample.xml' в 'ConEmu.xml'. Переименовывать можно после загрузки ConEmu, в этом случае в XML можно сохранить настройки, загруженные из реестра.
[%] Правки инициализации на 'чистых' настройках.
[%] Поправлена GCC сборка (xml в GCC не поддерживается).
[%] При невозможности создать требуемый шрифт (заданный в настройке шрифт отсутствует в системе) отображается сообщение об ошибке, а для шрифта рамок используется 'Lucida Console'.
[%] Issue 90: В некоторых случаях терялось положение левого верхнего угла окна.
[%] Немного поправлена прокрутка ползунком.
[%] В некоторых случаях в FullScreen не скрывалась панель задач.


Maximus5 - 2010.01.13
[%] Issue 156: Поломалось сохранение строковых параметров.


Maximus5 - 2010.01.12
[%] Issue 154: Моргание заголовка окна.
[%] Issue 155: Не отключалась опция "Enhance progressbars and scrollbars".
[%] Утечки при D&D.
[+] Одновременное использование шрифта Normal/Bold/Italic. Жирность/курсивность управляется цветом фона. Настраивается через реестр ("ExtendFonts", "ExtendFontBoldIdx", "ExtendFontItalicIdx", "ExtendFontNormalIdx").


Maximus5 - 2010.01.10
[%] Issue 151: Моргание иконки "Администратора" в закладке.
[%] Some fixes in ConEmuC.


Maximus5 - 2010.01.09
[%] Исправлена отрисовка нац.символов OEM-ными шрифтами.
[%] Issue 149: 091229.x64 - ConEmuC висит 10 секунд по Ctrl+Enter.
[+] Улучшена работа с пропорциональными шрифтами. Ширина, указываемая у флажка 'Force Monospace' теперь учитывается даже при его отключении.
[*] Оптимизация отрисовки.
[*] Для любителей консольных растровых шрифтов в списке основных шрифтов дополнительно отображаются предопределенные "[Raster Fonts 8x9]", и т.п. Warning! При их выборе можно забыть о юникодных символах.


Maximus5 - 2009.12.29
[!] Опция 'Extend visualizer' погибла.
[+] Главное окно ConEmu можно делать прозрачным (настройка на вкладке 'Colors'). При включении прозрачности отрисовка несколько замедляется.
[%] Экран "замерзал", если программа (telnet, VBinDiff, "clr:") создавала свой консольный буфер. В Windows7 пока не работает.


Maximus5 - 2009.12.26
[!] Переделан способ передачи содержимого консоли в GUI.
[%] В некоторых случаях цветовые атрибуты отображались с задержкой.
[%] Исправлены некоторые проблемы запускатора (COMSPEC).
[%] Флажок 'Monospace' (не путать с 'Force monospace') работал неправильно.
[+] Прозрачная поддержка консольных алиасов для cmd.exe/conemuc.exe.
[+] Если FAR чем-то сильно занят (не опрашивается клавиатура) включается курсор с часиками (если курсор находится в рабочей области окна). Опцию можно отключить (флажок "Hourglass") или настроить время задержки (реестр, "FarHourglassDelay").
[+] Debug: для запуска консольных команд в обход ComSpec можно использовать префикс: "conemu:run:<xxx yyy ...>"
[*] "…" в заголовке таба строго в конце.
[*] Поддержка панелей различной высоты.
[+] Настройка ("bgImageColors") для указания цветов фона, замещаемых на "Background image".
[*] Все PE-файлы теперь подписаны, сертификат можно загрузить здесь: http://conemu-maximus5.googlecode.com/files/ConEmu.cer.7z


Maximus5 - 2009.12.06
[%] Ctrl+Wheel - листание страницами в BufferHeight
[%] Не работало колесо в некоторых моделях мышек (короткие скроллы и прочее).
[%] Признак администратора не отображался, если сам conemu.exe был запущен "От имени...".
[*] Вместо суффикса " (Admin)" в табе отображается значок "Щит". Суффикс и значок можно настроить через реестр.
[*] Уменьшена задержка перед началом D&D.
[*] Поддержка изменений заголовка FAR2 (не работали RClic, drag, ...).
[*] Устранена некоторая задержка при выходе из FAR через F10.


Maximus5 - 2009.12.01
[%] Не учитывался макрос, задаваемый в "RightClickMacro2".


Maximus5 - 2009.11.28
[%] Лечим разнообразные наведенные глюки версии 07.
[%] В некоторых случаях при закрытии ошибочно отображалось предупреждение о наличии несохраненных редакторов.
[%] В некоторых случаях при запуске cmd в новой консоли не включался режим прокрутки.
[*] В папке 'Plugins\ConEmu' теперь выкладываются обе версии плагина (x64 и x86) для упрощения установки и использования.
[*] Ускорена работа "RClick4ContextMenu", снято требование к кнопке Apps или настройке макроса.
    Возможность настройки макроса осталась, но за ненадобностью переименована в "RightClickMacro2".
    (Для информации) Макрос по умолчанию теперь такой:
    $If (!CmdLine.Empty) %Flg_Cmd=1; %CmdCurPos=CmdLine.ItemCount-CmdLine.CurPos+1; %CmdVal=CmdLine.Value; Esc $Else %Flg_Cmd=0; $End $Text "rclk_gui:" Enter $If (%Flg_Cmd==1) $Text %CmdVal %Flg_Cmd=0; %Num=%CmdCurPos; $While (%Num!=0) %Num=%Num-1; CtrlS $End $End
[+] Добавлена возможность одновременного запуска нескольких консолей.
    Пример: conemu.exe /cmd @startfile.txt
    В файле каждая строка соответсвует запускаемой команде.
    Допустимо указание в строке параметра /BufferHeight.
    Если в начале строки стоит ">" - эта консоль будет активной после завершения запуска.
    Если в начале строки стоит "*" - эта консоль будет запущена под администратором.
    Пример файла startfile.txt (лидирующие пробелы и табуляции игнорируются):
		>E:\Source\FARUnicode\trunk\unicode_far\Debug.32.vc\far.exe
		*/BufferHeight 400 cmd
		/BufferHeight 1000 powershell
[+] FAR2 only. Добавлена экспериментальная фича - ASCII сортировка в FAR (в основном для файлов). Вроде работает, но используйте на свой страх и риск ;) Смысл в том, что при сравнении символов ASCII \x01..\x7F используется простое сравнение (регистрозависимо или независимо).
[+] Добавлен флажок "Fix Alt on AltTab". По умолчанию - отключен.
[*] В FAR2 больше не используется hotkey плагина. Собственно в FAR2 и макросы F14/CtrlF14/AltF14/ShiftF14 больше не нужны.
[+] В макросе ShiftEnter учитывается диалог быстрого поиска в панелях.
[*] Смена способа отрисовки окна (дочернее окно в котором ранее шла отрисовка теперь невидимое). Больше не должно быть задержек при появлении/пропадании табов.
[+] Теперь можно включать и выключать режим "BufferHeight" на лету. Для смены нажмите кнопку режима на toolbar'е. Отображается подтверждение.
[*] Опция 'GUI progress bars' погибла, вместо нее добавлена 'Enhance progressbars and scrollbars' (ранее соответствующая 3-му состоянию флажка 'Fix FAR borders').


Maximus5 - 2009.11.07
[%] В некоторых случаях после завершения консольных команд не восстанавливалась высота консоли (оставалась прокрутка).
[+] Параметр "FarSyncSize" в настройках.


Maximus5 - 2009.11.04
[%] В некоторых случаях графическое EMenu могло всплывать под ConEmu.
[*] При правом щелчке по табу не относящемуся к FAR (cmd, powershell, и т.п.) отображается диалог с кнопками Restart/Terminate/Cancel.
[+] Добавлено распознавание прогресса (процентов выполнения) в текущей строке текста консоли (chkdsk, wget, и т.п.)
[+] Обновлено распознавание прогресса в заголовке для плагина 7-zip alt.


Maximus5 - 2009.11.02

[%] /BufferHeight.
[+] AI в ком.строке. Если набрасывать файл (папку) на ярлык ConEmu - то переданное прилепляется к строке запуска по умолчанию. Точнее, это происходит в том случае, если первый аргумент начинается НЕ с '/'.


Maximus5 - 2009.10.31

[%] Не работал параметр запуска '/BufferHeight'.
[%] Лечим ресайз для режима с прокруткой.
[%] В некоторых случаях при листании шрифтов в настройках сбивался Charset.
[%] Некорректное создание OEM шрифтов.
[%] Правки ресайза при автотабах.
[*] На вкладке настроек поле 'Charset' динамически обновляется при смене шрифта.
[*] Добавлен 'ответ' в FAQ на счет растровых шрифтов консоли.


Maximus5 - 2009.10.24

[%] При AltTab AltTab в консоль проваливался 'чистый' Tab. Теперь в консоль, при активном FAR, посылается AltTab во избежания срабатывания макросов, повешенных на Alt (RAlt).


Maximus5 - 2009.10.16

[%] Задержка 10 секунд при запуске 16битных приложений, сбивался размер окна.


Maximus5 - 2009.10.13

[%] Не работал символ "c" в запущеном cmd.exe


Maximus5 - 2009.10.01

[%] Ошибочно включался Drag, если выделенных элементов на панели не было и текущий элемент - '..'.
[%] При выполнении консольных команд дублировался Ctrl-C (^C^C).
[%] Некорректное отображение символов с кодами ASCII < 32.
[%] Не обновлялась подсказка у иконки в трее.
[%] Утечка хэндлов во второй копии ConEmu.
[%] Падение при перетаскивании мышки в заголовок окна.
[*] По умолчанию Affinity не меняется.
[*] В FAR2 размер консоли изменяется через Synchro. Соответственно несколько меняется поведение при автотабах.


Maximus5 - 2009.09.23

[+] Поддержка изменений Multimedia Viewer.


Maximus5 - 2009.09.22

[%] Исправлена ошибка переключения раскладки (зеленый индикатор RusLat).
[+] В заголовке консоли/табе/индикаторе отображаются проценты выполнения некоторых консольных программ (nerocmd).


Maximus5 - 2009.09.19

[%] В заголовке окна, при отключенных табах, не обновлялось количество консолей "[n/n]".
[%] При 'закрытии' таба правым щелчком мышки FAR2 не отрисовывал диалоги подтверждения пока не дернешь мышкой.
[*] При отключенных табах 'Recent mode' игнорируется. Окна переключаются последовательно.
[+] Теперь можно настроить шрифт табов (пример в Settings-ConEmu.reg). Например, для корректного отображения иероглифов нужно выбрать шрифт типа 'Arial Unicode MS'.


Maximus5 - 2009.09.15

[%] Могли злобно виснуть (или падать?) при попытке ресайза.
[*] В FAR2 активация плагина переведена на ACTL_SYNCHRO. Теперь в макросе для EMenu можно использовать перфикс '@'.
    Текстовое EMenu теперь всегда активируется по центру экрана 
    (Side effect - при нажатии клавиатуры скрытая реальная консоль сдвигается в сторону от мышки).
    В текущей версии рекомендуются такие настройки EMenu: 
    Apps - показывает текстовое меню (автоматически отображается по центру окна).
    Для мыши - макрос вида "RightClickMacro2"="@F11 e Enter Enter" в настройках ConEmu.


Maximus5 - 2009.09.13

[%] При выполнении консольных команд в закладке отображался заголовок панели вместо выполняемой команды (при наличии редактора/вьювера).
[%] В FAR2 не работал макрос CtrlShiftT.
[%] Некорректная обработка слишком быстрых изменений. В частности, прокрутка вьювера левой кнопкой мышки приводила к безостановочному скроллингу.
[%] Правки некорректной высоты буфера консоли при старте (пока только FAR).
[*] На время выполнения консольных команд прячутся все закладки редакторов/вьюверов текущей консоли.
[*] ConEmuC в режиме подмены %ComSpec% теперь передает в FAR код возврата запущенной программы.
[+] Информация о реальных размерах созданных шрифтов на вкладке 'Info' настроек.
[+] Если в макросе (пока это только RightClickMacro2 и TabCloseMacro) первый символ '@' и после него не пробел - макрос выполняется с флагом KSFLAGS_DISABLEOUTPUT. В FAR2 эффекта пока не имеет.
[+] На вкладке 'Features' диалога 'Settings' добавлен выпадающий список высот для 16-битных приложений.
[+] На вкладке 'Features' диалога 'Settings' добавлена возможность принудительного (или автоматического) указания режима вывода для cmd.exe (ключи /U и /A командного процессора). При выборе Automatic в FAR2 активируется Unicode вывод, а в FAR1.7x - OEM.
[+] Улучшена работа ключа /single. В FAQ добавлен вопрос про одновременный запуск двух вкладок.
[+] Для удобства в файлы CtrlO.reg и CtrlO_View.reg добавлен макрос CtrlShiftO гасящий/показывающий панели (стандартное поведение FAR по CtrlO).
[+] В диалог создания новой консоли добавлена история команд.


Maximus5 - 2009.09.09

[%] В меню плагина под Far 1.7x отображался мусор.
[%] Не работали дополнительные языковые раскладки (например US-Dvorak).
[%] Чиним баг с открытием новой консоли с некорректным размером.
[%] Убраны ошибки отрисовки, в случае когда шрифт рамок был шире основного шрифта.
[*] ConEmuC теперь передает в %ComSpec% ключик '/U'.
[*] Упрощен выбор цветовых схем (вкладка 'Colors' в диалоге настроек). Если есть чем поделиться с общественностью - присылайте настройки :)
[*] При завершении консоли активной становится предыдущая активная.
[+] Перед закрытием ConEmu (щелчком по крестику в заголовке окна) отображается предупреждение при наличии несохраненных редакторов или незавершенных процессов (копирования и пр.).


Maximus5 - 2009.09.06

[%] Окно не разворачивалось, если было свернуто из полноэкранного режима.
[%] В FAR2 отвалились макрос CtrlO (нужно обновить reg-файл из поставки).
[%] В FAR 1.7x при закрытии последнего редактора/вьювера в табах вместо панели отображался уже закрытый редактор/вьювер (появилось в 2009.08.18).
[%] При запуске 'Run as administrator' в Win7 реальная консоль оставалась видимой, а CtrlWinAltSpace для нее не работал.
[%] При закрытии неактивной консоли не обновлялся список табов.
[%] В Win7 не работало закрытие консолей по крестику, если консоль была запущена 'Run as administrator'.
[*] В процессе FAR'а запрещено менять переменную ComSpec (во избежание, плагин FarCall ее уже нарушал).
[+] Для консолей запущенных 'Run as administrator' в заголовке (ConEmu) и табах отображется суффикс. Можно настроить через реестр ("AdminTitleSuffix"). По умолчанию - " (Admin)".
[+] Версия для 64-битных ОС. Если в 64-битной ОС используется 32-битный фар - плагин для него нужно брать из 32-битной сборки ConEmu.
[+] На странице 'Colors' диалога настроек добавлена возможность выбрать одну из 'умолчательных' цветовых схем.


Maximus5 - 2009.08.29

[%] В некоторых случаях (ShiftEnter на far.exe) не отключалось требование 'Press Enter to close console...' при быстром выходе из FAR.
[*] Некоторые изменение в общении с плагином/сервером.


Maximus5 - 2009.08.18

[%] Не работало автоскрытие табов при открытии модального редактора в FAR 1.7x.
[%] В некоторых случаях оставались 'левые' табы (часто проявлялось при открытии модальных редакторов).


Maximus5 - 2009.08.17

[%] В некоторых случаях признак модификации редактора (*) в табе изменялся не сразу.
[*] Отложенное обновление табов выполняется только в третьем состоянии флажка 'Enable Tabs'.


Maximus5 - 2009.08.14

[+] В диалоге (пере)запуска консоли (Win-W или Win-~) добавлена возможность указать текущую директорию для нового процесса.
[*] При выполнении макросов табы в ConEmu обновляются отложенно, по завершению макроса.
[%] В некоторых случаях, после завершения 16битной программы сбивался размер консоли.
[%] В некоторых случаях после нормального запуска FAR (например, через ShellExecute) не отключалось требование 'Press Enter to close console...' при быстром выходе из FAR.
[%] D&D. Иконки и имена перетаскиваемых файлов не отображались при быстром вытаскивании наружу.
[%] D&D. Положение курсора над оверлеем при длинных именах файла.


Maximus5 - 2009.08.10

[%] Утечка ресурсов (Pipes\ConEmuGuiXXX) в ConEmuC.
[%] При запуске 'telnet.exe' GUI 'замерзал' (телнет можно было видеть только в RealConsole).


Maximus5 - 2009.07.25

[%] AltTab fixed. В консоль проваливалось нажатие Alt, что могло приводить к выполнению макроса.
[%] Исправлены ошибки аттача ФАРА (запущенного не из ConEmu) к GUI. ConEmuC падал. Включался BufferHeight.
[+] Если при дропе в ком.строку удерживать модификатор (shift, alt или ctrl) в начало будет автоматически добавлен 'goto:'. Пуста ли ком.строка до выполнения дропа - не проверяется.
[+] При драге в фаре отображаются иконки и имена выделенных папок/файлов.


Maximus5 - 2009.07.23

[%] При работе в редакторе моргал заколовок окна.
[*] Немного причесан диалог настроек.


Maximus5 - 2009.07.22a

[+] При драге ИЗ проводника отображаются иконки перетаскиваемых файлов (checked in XP).


Maximus5 - 2009.07.21a

[%] В версии 2009.07.19 отвалилась передача CtrlC в FAR.
[%] При 'Force monospace' не работало 3-d state 'Fix Far borders'.
[%] Учтена баго-фича фара (например, при попытке выполнить макрос во время копирования экран 'замерзает'). Макросы, вызывающиеся из ConEmu, теперь вызываются без флага KSFLAGS_DISABLEOUTPUT.
[*] Уточнения в сообщении при выходе из ConEmuC.
[*] Если путь к ConEmuC.exe содержит пробелы (Program Files, etc.) то при установке переменной окружения ComSpec путь конвертируется в короткие имена.
[*] Макросы для FAR2 переведены на callplugin.
[*] Если при создании новой консоли удерживать Shift - появится диалог подтверждения (с флажком 'Run as administrator').
[+] Заработал флажок 'Run as administrator'. Теперь в Vista и выше  можно быстро (пере)запустить консоль с максимальными правами (UAC), а в WinXP - под другим пользователем.


Maximus5 - 2009.07.19

[!] Изменен способ передачи/обработки нажатий клавиш. Что-то могло поломаться.
[+] Табы. Если при переключении (CtrlTab) удерживать Alt - режим переключения (Recent mode) инвертируется.


Maximus5 - 2009.07.17

[%] Исправлено колесо мышки.
[%] Не работали табы и драгдроп при запуске: ConEmu.exe /cmd cmd.exe /K far.bat
[%] Исправлена отрисовка фоновой картинки.
[+] Все найденные в папке с ConEmu *.ttf файлы шрифтов временно регистрируются для использования в системе. Если в реестре настройка шрифтов остутствует - программа выбирает один из зарегистрированных шрифтов вместо стандартного 'Lucida Console'.


Maximus5 - 2009.07.16

[%] Лечим артефакты отрисовки (ClearType).
[%] Force monospace. Ширина шрифта не передергивалась при изменении флажка 'Force monospace'.
[%] Немного поправлен алгоритм определения 'темности' фона при отрисовке курсора.
[%] Событие MouseButtonUp проходило в консоль только если курсор был в клиентской области ConEmu.
[%] В ConEmu мог не отрисовываться экран (отображался только черный фон), если в реестре не были настроены умолчания для цветов консоли.
[*] DragDrop. Если папка рабочего стола отсутсвует (WinPE?) выдается осмысленное сообщение. В этом случае DragDrop должен работать, но без возможности создания ярлыков удерживанием кнопки Alt.
[+] DragDrop. Разрешен Drop в область командной строки.
[+] Пытаемся добавить флажок 'Run as administrator' в диалог подтверждения создания (пересоздания) консоли. Пока работает нестабильно - при его включении ConEmu может валиться.


Maximus5 - 2009.07.11

%) Падение ConEmu при выполнении длинных команд, содержащих амперсанды (&).
%) Исправлена отрисовка курсора на прокрутке и прогрессе в третьем состоянии флажка 'Fix far borders'.
%) При возникновении ошибки 'The requested operation requires elevation' программа запускается немодально в новой консоли, не подключенной к ConEmu.
*) По окончанию загрузки в консоли FAR (точнее, при загрузке плагина ConEmu) отключается требование 'Press Enter to close console...'.
*) Manifest.
*) Изменен алгоритм цвета курсора. При отключенном флажке 'Color' курсор белый (точнее color#15) на темном фоне и черный (color#0) на светлом фоне. При включенном флажке 'Color' курсор отрисовывается как в стандартной консоли.


Maximus5 - 2009.07.09

%) Проблемы при закрытии консолей, после открытия максимального их количества (12).
%) Поправлена активация с клавиатуры Win-F11/F12.
%) При закрытии/пересоздании консоли пропадал таб этой консоли.
%) В некоторых случаях не работало ограничение FPS.
%) Небольшие правки ресайза (Tabs, Alt-F9).
*) При невозможности создать новую консоль (их уже максимальное количество) отображается предупреждение.
*) Переменные окружения. 'ConEmuHWND' удаляется (плагином) при детаче консоли или аварийном завершении графической части. Добавлена переменная 'ConEmuDir'.
*) Возвращен 'cmd_autorun.cmd'. 'Прицепить' к GUI любую консоль можно выполнив в ней команду 'conemuc /ATTACH /NOCMD'.
+) В меню плагина добавлен пункт 'Attach to ConEmu'. Для тех случаев, когда был детач (CtrlAltTab) или FAR был запущен отдельно.


Maximus5 - 2009.07.07

%) После запуска и закрытия 16битного приложения замедлялась реакция на изменения в консоли.
%) Неправильно обрабатывалась высота консоли в 16битном режиме. Сейчас поддерживаются все стандартные высоты (25,28,43,50). Перед запуском 16битного приложения может быть принудительно установлена высота, задаваемая в настройке ("16bit Height").
*) Правки в GCC мейке.
+) Разрешена смена размера консоли самим консольным приложением (например, командой 'MODE CON: COLS=80 LINES=25').


Maximus5 - 2009.07.05

!) Эта версия полностью собрана в gcc.
%) Правки для 16битных приложений. 'Интеллектуальное' закрытие консоли. При выходе из 16бит приложения размер окна ConEmu схлопывался до 80x28.
%) Плагин не учитывал, что FAR мог быть запущен с ключом /u.
%) Исправлены проблемы ресайза при отображении/скрытии табов.
%) Win-0 ошибочно активировала 11-ю консоль, а Win-F11/F12 вообще не работали.
*) Ошибка 'ConEmu received old version packet...' отображается один раз за сеанс.
*) При ошибке запуска корневого процесса (far.exe/cmd.exe/etc.) отображается расширенная информация об ошибке.
*) При активации окна мышкой щелчок в консоль не пересылается (больше нет опасности случайно закрыть открытый диалог), а двойной щелчок (при активации) заменяется на одинарный. Флажок 'Skip activation' на вкладке 'Features'.
*) Если окно ConEmu неактивно - в консоль не посылаются события движения мыши. Флажок 'Skip moving' на вкладке 'Features'.
*) На 'Info' в заголовке группы 'Performance counters' вроде должна отображаться частота процессора.
+) На вкладке Features добавлены настройки мультиконсоли.


Maximus5 - 2009.07.01

%) В некоторых случаях (задержка запуска антивирусом) ConEmu закрывался сразу после запуска консольной программы.
%) При запуске GUI приложений их окна могли появляться под окном ConEmu. Пример: открытие папок в проводнике (ShiftEnter), диалог выбора Topic (плагин MSDN).
%) Правки в GCC мейке, убраны GCC ворнинги.
%) Консоль не отрисовывалась во время работы 16-битных приложений.
*) Расширено окно настроек.
*) В полосе прокрутки (режим буфера) вернулась поддержка тем Windows XP.
+) Перехватывается мигание (скрытой) реальной консоли (FlashWindow). Вместо нее мигает ConEmu. Если окно ConEmu неактивно - мигание продолжается до активации окна. Если ConEmu активно и мигает неактивная консоль - ConEmu мигает несколько раз.
+) К иконке Windows7 прикручен прогресс (по содержимому заголовка консоли, то есть как для фара, так и для плагинов).


Maximus5 - 2009.06.28

%) Правки в GCC мейке.
%) Кнопки тулбара иногда помещались перед табами при сужении окна. 
%) Изменения в 'Window size' (окно настроек) не применялись при нажатии 'Save settings'.
%) Выпадающие списки размеров шрифта отображали некорректную информацию, если в списке не было текущего значения.
%) Не обрабатывался прогресс плагина FTP (пример: {13.1%}).
%) При изменении размеров учитывается максимально допустимый размер консоли (для выбранного шрифта в real console).
*) PictureView автоматически скрываются/отображаются при переключении между консолями. Переключения на другие табы консоли с активным PictureView заблокировано.
*) В окне настроек изменения шрифта применяются только при потере фокуса изменяемого поля ввода (пока Tab не нажмешь - не изменяется), или при выборе значения из списка.
*) При сужении кнопки тулбара автоматически скрываются.


Maximus5 - 2009.06.27

%) После 06.18 поломалось выделение мышкой в граббере. Исправлено.
%) Табы не реагировали на изменения в редакторе во время макросов.
%) Звездочка (признак изменений редактора в табе) не появлялась после первого нажатия клавиши (и не сразу исчезала после сохранения).
%) Уточнения в ConEmuC запуска команд.
%) При быстром вводе текста могли теряться некоторые нажатия.
%) Не работал ввод символа через Alt-цифры при включенном NumLock.
+) При создании новой консоли (Win-W) или пересоздании активной (Win-~) в открывающемся диалоге подтверждения пользователь может изменить запускаемую команду (например ввести 'cmd.exe').
+) Если в активной консоли в заголовке не отображаются проценты (copy/move/...), но проценты есть в заголовках неактивных консолей, то в начале заголовка ConEmu отображается максимальное значение процентов неактивных консолей.
+) При быстром драге правой кнопкой мышки выделение файлов (папок) в панелях получалось рваным (windows не посылал мышиные события для некоторых участков). "RSelectionFix"=hex:01 (включено по умолчанию) исправляет этот недостаток, досылая необходимое количество событий в FAR.
*) В reg-файле ключ "Experimental" переименован в "FixFarBorders". При отсутствии нового имени значение будет считано из старого.
*) Изменен диапазон символов, на которые влияет "FixFarBorders". До 10 диапазонов можно указать в значении "FixFarBordersRanges".
*) Если 'корневая' программа (far, cmd, ...) проработала менее 10 секунд, то перед закрытием консоли отображается 'Press Enter to close console...'. Смысл в том, чтобы видеть ошибки запуска программы, ошибки в аргументах и т.п., если таковые были.
*) Возможность просмотра 'длинного вывода' консольной программы возможна в любом фаре консоли (например FAR 1.7x запущен из FAR 2.0).


Maximus5 - 2009.06.24

%) Правки в отрисовке.
%) Некорректно передавался список процессов, что в некоторых случаях приводило к закрытию ConEmu сразу после запуска.
%) Исправлена проблема с непопаданием фокуса ввода в контекстное меню.
*) Немного добавим красивости в таб и тулбар.


Maximus5 - 2009.06.23

%) Исправлена ошибка запуска программ, если путь к ConEmuC содержал пробел (Program Files).
%) CtrlShiftTab приводил к зависанию (в режиме "TabRecent"=hex:01).
%) Правки в отрисовке.
*) Возможность просмотра 'длинного вывода' консольной программы возможна только в первом фаре консоли. То есть если запустить фар из фара в той же консоли - длинный вывод программы, запущенной из второго фара уже не посмотришь.
*) Для удобства использования режима ("TabRecent"=hex:01) после нажатия Ctrl(Shift)Tab и удерживаемом Ctrl переключаться по вкладкам в обычном режиме можно клавишами-стрелками.
+) Вернулась возможность пользоваться плагином Update.


Maximus5 - 2009.06.22

%) Правки в отрисовке и синхронизации.
+) Переключение по табам (консолям/редакторам/вьюверам) с клавиатуры теперь соответствует истории их активации (a'la Opera & Visual Studio). Вернуть стандартное поведение можно через параметр настройки "TabRecent".


Maximus5 - 2009.06.20

%) Курсор опять мигает.
%) Немного полечил отрисовку.
*) Изменен способ уменьшения FPS при выполнении консольных команд/утилит (dir/s и пр).
+) Мигание курсора можно отключить (флажок 'Blinking' в диалоге настроек).
*) Косметика в 'Background image'. В 3-м состоянии флажка фоновый рисунок отображается только в панелях. При включении флажка проверяется значение 'Darkening' и выдается предупреждение, если там 0.
*) Косметика в диалоге настроек. Ctrl-(Shift)-Tab переключаются по вкладкам.
+) В меню плагина добавлены команды для работы с табами (показать/спрятать, переключиться, активировать выделенный).
+) Добавлен макрос CtrlShiftT.reg - показать/спрятать табы.
*) KIS при запуске консольных программ гундел "... пытается послать оконное сообщение".
*) Если для реальной консоли в реестре задан шрифт, ConEmuC проверяет его наличие. При отсутствии шрифта выбирается 'Lucida Console'.
*) Косметика диалога настроек. Уменьшена задержка открытия окна. Tooltips для ComboBox'ов.


Maximus5 - 2009.06.19

!) Макросы (reg-файлы) перемещены в папку 'ConEmu.Addons'.
+) В командной строке ConEmu.exe можно указать ключик '/single'. В этом случае команда выполнится в новой консоли ранее запущенного приложения. Если ни одного ConEmu еще не запущено - выполнение идет в обычном режиме.
+) В 'ConEmu.Addons' добавлены FarHereInstall.cmd (FarHereUninstall.cmd), добавляющий (убирающий) пункт 'Far here' в контекстное меню проводника Windows. Если ConEmu не был запущен - запускается, иначе - открывается вкладка.
*) Поправлена обработка 'RightClick for context menu'. При желании можно вместо отсылки в консоль кнопки 'Apps' явно указать макрос, вызывающий меню (см. параметр "RightClickMacro2" в Settings-ConEmu.reg).
!) Изменения в отрисовке. Вся графика обрабатывается только в главной нити.


Maximus5 - 2009.06.18

%) Двойной щелчок по слову в редакторе FAR (в некоторых случаях) ставил, но сразу снимал выделение. Лечим глюк microsoft'а.
%) Правый щелчок по вкладке выполняет (после ее активации) настраиваемый макрос (по умолчанию "F10").
%) Валился D&D с панели на панель.
*) Немного изменено общение с плагином. Зависаний при невозможности выполнить команду (переключение таба, например) больше быть не должно.
*) Немного ускорен запуск drag&drop.


Maximus5 - 2009.06.17

%) Плагин падал в FAR 2 build 995+.
%) Попытка недопустить зашкаливания FPS при выполнении команд типа 'dir /s'. Слишком частое обновление экрана приводило к 100% загрузке процессора. Теперь FPS в буферном режиме принудительно занижается.
%) Лечим отрисовку (белый прямоугольник при запуске, черные полосы при ресайзе).
%) Вернул автопоказ/скрытие табов. Теперь это работает и для создания/закрытия новой консоли.
*) В окошке 'Settings' на вкладке 'Info' добавлен счетчик FPS.


Maximus5 - 2009.06.16

+) Веса (для вычисления цвета) символов прогрессов и прокруток можно задать в реестре - PartBrushXX ('Fix Far borders' in 3-d state).
+) При дампе консоли рядом с файлом '.con' создается файл '.bmp'.
+) Весь проект теперь можно собрать в GCC.
+) Макрос 'ShiftEnter.reg' для запуска ком.строки или файла под курсором в новой вкладке ConEmu.
%) Табы плохо переключались с клавиатуры, если в одном из них менялся заголовок (прогресс копирование, и т.п.).


Maximus5 - 2009.06.14

+) Если табы скрыты и открыто больше одной консоли - в заголовке окна отображается '[консоль/всего] ...'.
%) Табы, если 'Always show menu bar'. Не переключались вообще. ConEmu падал по правому щелчку.
%) Если табы были скрыты - Ctrl-Tab не переключался между консолями.
%) В закладках не отображались '&'.
*) Добавлены тултипы в диалоге настройки для группы 'Font'.
*) При включенном 'Fix Far borders' рамки рисуются всегда без anti-aliasing.
*) Изменена логика применения изменений шрифта в диалоге настройки. Старые глюки убраны, могли появиться новые :)
*) Флажок 'Fix Far borders' теперь имеет третье состояние. В этом случае ConEmu самостоятельно отрисовывает символы прогрессов и прокруток.
*) Шрифт, переданный параметром /fontfile пытается регистриться и для консоли.


Maximus5 - 2009.06.13

+) Возможность задавать шрифт для реальной консоли (см. reg-файл).
%) Некорректно отображались табы при запуске 'far /e ...' или 'far /v ...'.
%) В сборке 2009.06.12 часть консоли могла отображатся некорректным шрифтом.
%) Продолжаем бороться с неотрисовкой.


Maximus5 - 2009.06.12

%) Пункт меню 'Paste' подвисал.
%) Изменен способ отрисовки курсора (не путать с выделением в панелях). Двух курсоров на экране больше не будет.
*) Мультиконсоль по умолчанию (в новых конфигурациях) включена.
*) При запуске ConEmu основное окно могло отрисовываться с задержкой (пока не запустился консольный процесс).


Maximus5 - 2009.06.11

+) В меню окна ConEmu добавлен пункт 'Paste'.
%) Не совсем починился фокус, при щелчке средней кнопкой по табу.
%) Чиним ресайз.
%) После Alt-F9, Alt-F9 некорректно открывалась картинка в PictureView.


Maximus5 - 2009.06.09

+) Добавлена обработка параметра -new_console. Пример:
   dir -new_console c:\windows\*.*
   запустится в новой вкладке ConEmu.
   ! Вкладка автоматически не закрывается 
   ! закрытие только после завершения выполненной команды и нажатия Enter.
*) Форматирование заголовка 'панельной' вкладки (изменено имя параметра реестра на "TabConsole").
+) В диалоге подтверждения перезапуска консоли (Win+~) кнопка 'Yes' - перезапуск, кнопка 'No' - закрытие, 'Cancel' - отказ.
%) Поправлена обработка аргументов в ConEmuC.
%) Продолжаем лечить непрорисовку.
%) Не активировалась вкладка (Ctrl-Tab) если из фара было запущено другое консольное приложение.


Maximus5 - 2009.06.08

* Значительные изменения. Консольный код вынесен в отдельный процесс. В результате многие ошибки/проблемы исчезли, но могли появиться новые.
+) Запуск нового процесса через ConEmuC.exe
+) Поддержка 'мультиконсоли' более не требует ConMan.exe, ConMan.dll или хуков. Управление стандартное (через тулбар или Win-Q/W/1..0/F11/F12). Кнопки создания/смены консоли можно переопределить в реестре. При создании новой консоли через шортках выдается подтверждение (отключаемо).
+) Полностью исключено мелькание черного консольного окна при запуске.
+) События от клавиатуры и мыши помещаются в буфер консоли напрямую, возможно это устанит 'торможение' реакции на клавиши.
+) Корректное завершение процесса по крестику.
?) Режим с BufferHeight может не работать.
%) Исправлены Ctrl+клавиша.
%) Не двигался курсор в командной строке.
%) Клавиши Ctrl, Shift и Alt 'залипали'.
!) Что-то непонятное с FARHints. Если создано несколько консолей (/multi) - хинт вслывает для всех консолей сразу.
*) Если произошла ошибка запуска приложения (far, cmd, ...) консоль отображается на экране с информацией об ошибке.
?) В каких-то случаях размер схлопывается до минимального?
+) Возможность не посылать в консоль события получения/потери фокуса (чтобы не пропадало окошко быстрого поиска в панелях). Параметр настроек "SkipFocusEvents"=hex:01.
%) Поправлена пересылка в консоль некоторых клавиш (Enter, Esc, Tab, ...).
+) В плагин добавлена экспортируемая функция IsConsoleActive().
%) Исправлен баг падения плагина при использовании Anamorphosis.
+) Добавлен отладочный ключик реестра 'DumpPackets'.
%) Вроде исправлено схлопывание окошка при запуске до минимального размера.
!) Убраны нафиг /SetParent, /SetParent2, /Windows7, /DontSetParent.
*) Sources. Создан новый класс CRealConsole, в который вынесен код из CVirtualConsole. Последний должен отвечать только за графику.
?) Не посылались Ctrl-C/Ctrl-Break.
?) Заглушка для исправления 'непрорисовки' консоли (раз в секунду данные пересылаются в GUI независимо от 'измененности').
?) Win+~ - перестартовывает текущую консоль (у пользователя запрашивается подтверждение).
*) Ключи /conman & /nocoman заменены на /multi & /nomulti.
+) Вернул режим BufferHeight.
+) При запуске консольных программ из FAR автоматически увеличивается размер буфера.
+) Чтобы FarHints не показывал хинты для всех открытых консолей одновременно - в каталоге с плагином временно лежит infis.dll (от конмана там только имя файла).
-) До лучших времен отключена возможность выделения мышкой в режиме BufferHeight.
*) ConEmuC.exe собран без использования VC-шных библиотек.
+) В первой закладке вместо 'Console/Panels' отображается заголовок консольного окна и динамически обновляется.
+) Закладки отображаются для всех консолей разом, позволяя 'прозрачно' переключаться между ними.
+) При наведении мышки на закладку с обрезанным заголовком (…) отображается тултип.
*) Общение с плагином переведено на пайпы.
%) Плагин подвисал при попытке переключения между закладками, если в панелях было активировано верхнее меню.
%) Для всех кнопок тулбара в тултипе отображался заголовок активной консоли.
%) Фокус в закладку больше не попадает, вернул закрытие закладки правой и средней кнопкой мышки.
+) GUI теперь может сам обрабатывать переключение табов (окон) с клавиатуры. Так что теперь переключение между консолями прозрачно для пользователя.
%) Фикс запуска команд.
%) Поправлена работа флажка 'Monospace' (не путать с 'Force monospace'). На некоторых моноширных шрифтах (i.e. 'Fixedsys') буквы под курсором прыгали влево.
%) При смене параметров шрифта/сглаживания в окне настройки экран не обновлялся или портился.

*) Изменен способ передачи содержимого консоли, глюк непрорисовки может исчезнуть.
+) Долгожданный просмотр вывода консольной программы. Пример макроса на CtrlO лежит в папке плагина.
%) После создания новой консоли фокус ввода мог "уходить" из ConEmu.
%) Исправлено несколько глюков ресайза.
*) В режиме с прокруткой полоса прокрутки больше не отображается постоянно и не отъедает место. Она всплывает при наведении мышки. О ее наличии сигнализирует 'нажатая' кнопка 'BufferHeight mode' на панели инструментов.
+) В консоль пересылаются нажатия XBUTTON1 & XBUTTON2 (у меня это наклон колеса мышки влево/вправо). Пример макроса в MouseWheelTilt.reg.

+) Форматирование консольного вывода (пустые строки в начале и конце в редактор/вьювер не попадают).
+) В меню плагина отображается дополнительная команда - открыть консольный вывод во вьювере.
+) При XLat в Far меняется индикатор языка в ConEmu (точнее смотрите параметр MonitorConsoleLang).
%) Продолжаем лечить непрорисовку.
%) ConEmuC падал при запуске команд cmd.
%) Лечим глюки ресайза.

* При изменении размера окна мышкой - консоль опять ресайзится сразу.
* При открытом PictureView левая и верхняя граница окна 'не таскается' мышкой.
* Исправлена реакция на изменение размера буфера из консольного приложения.
* В основной иконке ConEmu добавлен 48x48x256.
* Новая попытка исправить глюк неоткрытия окна настроек.
* Немного подправлено открытие окон каскадом.
* В формате заголовков закладок можно использовать "%i' - номер окна.
??? возможно
* Ускорено отображение изменений в консоли + ConEmu меньше использует процессор.

Maximus5 - 2009.04.24

* Поправлена отрисовка окна во время запуска приложения.
* Попытка исправить глюк неоткрытия окна настроек.
* Правим ошибки ресайза.

Maximus5 - 2009.04.23

* Правим ошибки ресайза.

Maximus5 - 2009.04.22

* В окне настройки добавлена кнопка 'Apply' для применения изменений в группе 'Window size'.
* При открытом PictureView запрещено изменение размера окна.
* После закрытия PictureView передергивался размер консоли -> было мигание.
* После двойного щелчка по заголовку (maximize) в консоль проваливался LButtonUp.
* Изменен 'умолчательный' символ активации плагина.
* Изменен набор примеров макросов в каталоге плагина:
  + AltEnter_Exec.reg  - перенаправить вывод консольной программы в редактор (выполняется содержимое командной строки).
  + AltEnter_Props.reg - отобразить стандартный диалог свойств файла (проводник Windows).

Maximus5 - 2009.04.19

* Временно убрана поддержка ConMan.
* В предыдущей версии отвалилось изменение размера окна.
* Выскакивала ошибка: Can't start 'TabBarClass::Retrieve'. Last operation 'TabBarClass::Retrieve' was not finished!
* При попытке сменить Ansi-aliasing - выскакивал 'Assertion'.
* Оптимизация отрисовки при ресайзе.

Maximus5 - 2009.04.15

* Улучшен внешний вид панели с табами и кнопками ConMan-а.
* При выделении мышкой в режиме BufferHeight выделение 'прыгало'.
* При смене заголовка неактивной консоли ConMan-а мигали табы.
* Если табы отключены - не пытаемся получить информацию о них из плагина.
* Кнопка альтернативной консоли (панель конмана) не включалась при Win-A.
* Драг теперь начинается только при клике в рабочую облась панелей (сервисные области игнорируются).

Maximus5 - 2009.04.12

* Изменен внешний стиль табов (пока просто кнопки).
* В режиме BufferHeight не работало выделение мышкой.
* Попытки поправить неудачные выставления размеров консоли.

Maximus5 - 2009.04.10

* При открытии PictureView отстанавливалась отрисовка всех остальных окон ConEmu.
* Чтение содержимого консоли вынесено в отдельную нить.
* Проблемы с отрисовкой правого и нижнего края окна.

Maximus5 - 2009.04.07

* Поправки в работе с мышью.

Maximus5 - 2009.04.06

* Изменен способ пересылки мышиных событий в консоль.
* В режиме Window size = Normal - окна могут открываться каскадом.

Maximus5 - 2009.04.02

* Бонус :-) можно настроить 'автозапуск' КонЭму при запуске cmd.exe или любого пакетного файла. Запустить один раз 'cmd_autorun.cmd /i'.
* Побеждено мелькание консольного окна при старте программы. В редких случаях, когда запуск идет с ярлыка и не разворачаивая окно на весь экран, чтобы избежать мелькания - укажите в свойствах ярлыка 'Run - Minimized'.
* Оптимизация отрисовки курсора.
* Во время загрузки приложения (i.e. 'far.exe') в заголовке окна отображается строка запуска.
* В консоль больше не пересылается WM_SYSCOMMAND с wParam>=0xF000, ибо консольное окно странно реагирует и часто перехватывает фокус.
* Добавлен параметр '/max' (а для разрабочиков '/debug' & '/debugi').

Maximus5 - 2009.04.01

* Не работал CtrlWinAltSpace при /SetParent.
* Сменилась отрисовка курсора.
* На вкладке 'Info' отображается полная строка запуска ConEmu.

Maximus5 - 2009.03.29

* Небольшие правки в dll-ках ConMan.
* После попытки драга с областей за пределами панелей постоянно выскакивала ошибка "Can't open file mapping" (проблема с таймаутом пока осталась).

Maximus5 - 2009.03.28

* Опция 'Minimize to tray'.

Maximus5 - 2009.03.27

* Копирование/перемещение (при Drop из внешних приложений) выполняется в отдельной нити, т.е. во время копирования больших файлов можно продолжать работу в FAR.

Maximus5 - 2009.03.26

* Разрешен Drag с временной панели. Запрещен Drop на плагиновые панели из внешних приложений.

Maximus5 - 2009.03.25

* При Drag-n-Drop в FAR 1.7x плагин падал.

Maximus5 - 2009.03.24

* При Drop файлов из внешних приложений срабатывал Move вместо Copy.
* После включения флажка 'ConMan', ConEmu не запускался, если отсутсвовали необходимые dll-ки.

Maximus5 - 2009.03.22

* Не срабатывал Drag.
* В диалог настройки добавлен флажок 'ConMan'. Его можно использовать вместо параметра запуска '/ConMan'.

Maximus5 - 2009.03.20

* Плагин вис в FAR 1.7x ('...Waiting for result (10 sec)').
* Лечим падение при драге в Windows Vista.
* Поддержка дропа элементов, не являющихся файлами (например из Outlook). В этом случае доступно только копирование, так что если видите 'запрещающий курсор' - жмите Ctrl.

Maximus5 - 2009.03.19

* Изменения в DragDrop.
  Drag возможен как левой так и правой кнопкой мышки (разрешаются в настройке раздельно).
  При драге, текущее действие отобржается курсором (Copy - курсор с плюсиком, Link - со стрелкой).
  Разрешено создание ярлыков (только когда выделен один файл или одна папка).
  При драге правой кнопкой мышки во ВНЕШНИЕ приложения - всплывает контекстное меню (copy/move/link).
  Для каждой кнопки мышки можно указать клавишу-модификатор (например LeftCtrl), удерживать которую необходимо при клике.
  Флажок 'Copy by default' теперь имеет только два состояния и определяет именно действие по умолчанию (остальные при этом не запрещаются).
  При перетаскивании между панелями (режим Copy/Move) обработка передается в FAR (F5/F6).
  Drop разрешен только при включенном флажке 'Allow Drop', который имеет 3 состояния.
  'Off' - Drop НЕ разрешен из ВНЕШНИХ приложений, между панелями - разрешен;
  'On' - Drop разрешен как из внешних приложений, так и между панелями;
  '3s' - то же, что и 'On', но подтверждения копирования/перемещения между панелями не производится.
  Во время драга можно использовать стандартные модификаторы для принудительного включения режима:
  'Ctrl' - копирование, 'Shift' - перемещение, 'Alt' - создание ярлыка.
  Нажатие 'Esc' - отменяет драг.
* Параметр (PID) для ключа '/Attach' необязателен. При отсутствии PID - пытаемся подхватить текущее консольное окно.
* Не активировалась мышкой вкладка 'Panels'.
* Попытка не менять размер консоли в конмане (только при переключении кнопками).
* В диалоге настройки для некоторых элементов (пока DragDrop) включены всплывающие подсказки. Есть желание написать подсказки к другим элементам - Welcome :)
* Ошибки разбора командной строки.

Maximus5 - 2009.03.11

* Попытка исправить глюк с неработающим CtrlWinAltSpace.
* Перед началом Drag'n'Drop или после его окончания выделение могло перескакивать на другой файл(папку).
* Исправлена 100% загрузка в свернутом состоянии.
* Поправил табы - в некоторых случаях могли не обновляться после смены списка окон.

Maximus5 - 2009.03.10

* Исправлен глюк с горизонтальным курсором при наличии фоновой картинки.
* На время работы 16бит. приложения для ConEmu устанавливается высокий приоритет.
* Не работала панель с кнопками конмана.

Maximus5 - 2009.03.09

* Для кнопок конмана отображаются всплывающие подсказки.
* Функции FAR API теперь выполняются в основном потоке, активация плагина через макрос F14 (создается автоматически).
! Изменен способ передачи информации о закладках (возможны глюки).
* Курсор теперь отрисовывается немного по другому, мусора от курсора вроде быть не должно.
* Возможность явного указания процессоров, на которых выполняется ConEmu ("AffinityMask").
* При запуске 16битного приложения размер окна не изменяется, а консоль (80x25) отрисовывается в центре. Передключаться конманом до выхода из 16бит приложения не рекомендуется.
* Продолжение BufferHeight. Автоматическое включение прокрутки при увеличении буфера консольным приложением.

Maximus5 - 2009.02.26

* Плагин валился при драге в FAR 2.0 build 789+.
* Для запуска ConMan рекомендуется использовать версию 2.34.4 и ключик /ConMan (вместо ConMan.exe).
* При наличии табов и ключика /ConMan появляется панель с кнопками для управления конманом.
* Вроде починил глюк отображения символа под курсором.

Maximus5 - 2009.02.26

* Изменены счетчики производительности (вкладка 'Info' окна настроек). Отображаются в миллисекундах.

Maximus5 - 2009.02.25

* Корректный Drag'n'Drop и обновление табов при смене консолей КонМана.
* В окно настроек добавлена вкладка 'Info', на которую переехали Render times и добавлена информация о консольных процессах.

Maximus5 - 2009.02.24

* Поддержка изменений API FAR2 build 789 (плагин работает в FAR2 build 757 и выше или FAR 1.7x build 2470 и выше).
* В Windows Vista и выше по умолчанию были недоступны некоторые юникодные символы (например троеточие '…', иероглифы, и др.), т.к. для реальной консоли не устанавливался TTF шрифт.
* Расширение визуализатора не работало в конмане.

Maximus5 - 2009.02.23

* При выходе из окна настроек (при включенных табах) ранее открытые табы пропадали.
* 'Background image' теперь отображается и при включенном 'Force monospace'.
* Чуть поправил закрытие окна и завершение плагина. Вроде бы проблем с ExitFAR(W) больше быть не должно.
* Потихоньку совершенствуем поддержку пропорциональных шрифтов.
* В плагин добавлена информация о версии.
* В меню добавлен пункт 'Dump...' для сохранения текущего содержимого консоли в файл.

Maximus5 - 2009.02.21

* Изменения в ресайзе окна, корректировка начального положения.
* Отображение непечатных символов в редакторе (Tab,Eol,Eof). Настраивается на закладке цветов. Необходим плагин Visualizer! Отображаемые на их месте символы можно настроить (см. Settings-ConEmu.reg).
* Расширенные цвета консоли (16..31) не сохранялись в реестр.

Maximus5 - 2009.02.20

* Диалог настроек разбит на две вкладки.
* Для тех, кому не хватает 16 цветов консоли, добавлена возможность использовать 32 цвета текста ;) за счет игнорирования одного из выбираемых цветов фона.
* Настройки цветов теперь сохраняются в ключе ConEmu, ключ консоли не трогается. Умолчания для цветов (в новой конфигурации) по прежнему берутся из свойств консоли.
* Изменения в ресайзе окна...

Maximus5 - 2009.02.18

* Размер окна FullScreen/Maximized/Normal теперь устанавливается другим способом.
* В плагине изменен способ поиска окна ConEmu (переменная среды больше не используется из-за КонМана, хотя и устанавливается).

Maximus5 - 2009.02.17

* Добавлен параметр '/Attach <PID>'. При его указании ConEmu не запускает новый процесс, а пытается подключиться (внедриться) к уже существующему консольному приложению, указываемому через код процесса (<PID>).
* При отключении FARа от консоли (Ctrl-Alt-Tab) плагин предлагает запустить новый экземпляр ConEmu, который 'подхватит' новую консоль FARа (переключалка по табам при этом к сожалению отключается).

Maximus5 - 2009.02.16

* Изменен способ разворачивания окна в FullScreen. Проблем с расширениями, внедряющимися в рамку окон (типа FileBox eXtender) больше не будет.

Maximus5 - 2009.02.15

* Изменена обработка WM_SETFOCUS:
?) Не должно быть проблем с активацией диалога настроек в Vista.
?) Наверное Win+R больше не будет появляться под ConEmu.
?) Возможно (хотя и не должны), могут появиться другие глюки, например клавиши не будут проходить в FAR.
* Поправленный reg-файл.
* Переделано общение с плагином при Drag'n'Drop. Раньше ConEmu мог подвисать.
* Теперь 'Таб' пытается закрыться и по щелчку правой кнопкой мышки (на тачпадах средней кнопки нет вообще).
* Исправлена ошибка сохранения положения минимизированного окна.
* Макрос для 'табов' создается автоматически, после подтверждения пользователем.
* В плагине вернулись lng-файлы - подверждение для создания макроса.
? Может быть перестанет валиться при выходе, если присутствует PowerShellFar.
? Ready to ConMan & FarHints.

Maximus5 - 2009.02.13

* В ConMan внесены необходимые изменения (2.34.1) для его использования без ключика '/SetParent'.
* Если обновлять ConMan не хотите - можно использовать ключик '/SetParent2' (но тогда отвалится FarHints).
* Вроде бы решена проблема непереключения раскладки при отсутсвии ConIme.
* Если в окошке предупреждения о 'LoadConIme' нажать кнопку 'Cancel' - оно больше не появится (надеюсь).
* Изменилось (вернулось) имя класса главного окна ConEmu.
* Соответственно, обновился враппер PictureView.
* Создается переменная среды 'ConEmuArgs', содержащая аргументы запуска ConEmu.
* Флажок 'Always update con.handle' включается автоматически, если в строке запуска есть conman.exe.
? Теоретически, можно организовать табы и для консолей ConMan... Высказываемся ;-)

Maximus5 - 2009.02.11

* При нажатии Alt+кнопка раздавался писк.
* Врапперу PictureView опять не нужен ConEmu.dll.
* Табы теперь отображаются с рамкой. Если хотите как раньше - только заголовки:
  [HKEY_CURRENT_USER\Software\ConEmu\.Vanilla]
  "TabFrame"=hex:00

Maximus5 - 2009.02.10

* SlideShow для PictureView мог не работать (особенно в FullScreen).
* Новый враппер для PictureView.
* В трее отображается та же иконка, что и в главном окне.
* В заголовке диалога 'About' отображается версия ConEmu.
* Если PictureView работает в режиме Ctrl-Q - не отрисовывалась видимая часть консоли.

Maximus5 - 2009.02.08

* Лечим глюки в отображении фона (картинок). Утечки, стек, проблемы с меньшими чем экран изображениями, с шириной некратной 4, некорректные дескрипторы и прочие прелести (и как это работало?).
* Иконка в окне диалога настроек.
* Автоскрытие табов при третьем положении флажка.

Maximus5 - 2009.02.07

* Отрисовка теперь идет в дочернем окне ConEmu (возможны глюки).
* Изменена логика ресайза окна.
* Возможность центрирования содержимого окна в полноэкранном и развернутом режимах.
  [HKEY_CURRENT_USER\Software\ConEmu\.Vanilla]
  "TryToCenter"=hex:01
* 'Интеллектуальное' появление/исчезновение табов.
* При использовании BufferHeight после запуска FAR отключается режим консоли 'QuickEdit' при выходе из FAR - возвращается обратно.
! Практически все функции разнесены по классам, многие события вынесены в отдельные методы.

Maximus5 - 2009.02.05

* Попытка запустить не работающий 'Force monospace'. Буковки в этом режиме теперь центрируются.
* Добавлена возможность принудительной установки ширины букв в этом режиме (в Arial, например, ширина по умолчанию получается очень большой).
* Потихоньку пишем 'FAQ-ConEmu.txt'. Есть что добавить - присылайте.
* Можно было открыть несколько диалогов настроек.

Maximus5 - 2009.02.03

* Кнопки 'OK' в настройке плагина больше нет. Кнопка 'Save settings' после сохранения закрывает окно настроек.

Maximus5 - 2009.02.03

* Плагин: Оптимизация выделения памяти и пересылки информации о табах.
* Плагин собирается в GCC.

Maximus5 - 2009.02.02

* В заголовке окна настроек отображается имя конфигурации (если при запуске ConEmu был указан ключ /Config).
* Минимальный размер окна консоли - 28x9.
* [DEBUG сборка] консоль отрисовывается в дочернем окне. сильно моргает. с чего бы это?

Maximus5 - 2009.02.01

* Глючил размер буфера консоли, если в свойствах ярлыка было указано 'Maximized'.
* Ключик /fontfile - загрузка шрифта из файла (by Mors).
* Поддержка Windows XP themes.
* Добавлен примерный файл настроек реестра Settings-ConEmu.reg.
* Форматирование заголовков табов. Умолчания можно изменить в реестре (см. TabPanels, TabEditor,...).
* Исправлена утечка памяти в юникодной части плагина.

Maximus5 - 2009.01.30

* Поддержка изменений API FAR2 build 757 (плагин работает в FAR2 build 748 и выше или FAR 1.7x build 2470 и выше).
* Оптимизация вызовов FAR API. Не освобождалась память, выделенная функциями API.
* Третье состояние флажка 'Enable Tabs' - закладки появляются при открытии редактора/вьювера. Если включен - закладки отображаются всегда.

Maximus5 - 2009.01.27

! Попытка интегрировать Drag с ФАРовским копированием пока не удалась - глючит и повисает.
* Расширенное сообщение об ошибке, если не удалось запустить процесс (far, cmd, /cmd).
* Починил Drag'n'Drop в ConMan.

Maximus5 - 2009.01.26

* Если рядом с ConEmu.exe лежит одноименная иконка - грузится именно она.
  Если файла иконки нет - загружаем встроенную в ConEmu, номер иконки (1,2,3) можно указать в реестре. Пример:
  [HKEY_CURRENT_USER\Software\ConEmu\.Vanilla]
  "IconID"=dword:00000003
* При бросании файла в корень диска (Vista) возникала ошибка.
* При Drag'n'Drop между панелями внутри одного FAR'а открывается встроенный диалог копирования/перемещения (Ctrl пока не учитывается).
* Флажок 'RightClick for context menu' имеет три состояния.
  (Отключен) - все нажатия правой кнопки мышки пересылаются в FAR без изменений;
  (Включен) - если курсор не двигался, то при отпускании правой кнопки отображается контекстное меню (на кнопке Apps должен быть соотвествующий макрос); если курсор двигался - пересылаются в FAR без изменений;
  (3 состояние) - меню отображается если кнопка мышки удерживалась более 0.3 сек. а курсор не двигался, иначе - пересылаются в FAR без изменений.


Maximus5 - 2009.01.25

* Пока автор плагина FarHints не научит его работать с новым ConEmu - версию для FAR2 можно использовать через Wrapper.
* Не отображался Help для плагина PictureView.

Maximus5 - 2009.01.24

* Установка родителя по умолчанию более не делается. Плагин PictureView использовать через Wrapper.
* В некоторых случаях в консоли появлялась горизонтальная прокурутка, проводящая к глюкам отображения.
* После изменения размеров окна ConEmu с открытым PictureView размер консоли и самой картинки не менялся.
* При листании картинок в PictureView на экране могли появляться глюки.
* Добавлен режим SlideShow для PictureView. Включается кнопкой Pause. Задержку можно увеличивать/уменьшать кнопками -/= (между '0' и BackSpace на основной клавиатуре). Отключется режим нажатием любой другой кнопки, или Pause.
  Задержка задается в реестре в миллисекундах, пример:
  [HKEY_CURRENT_USER\Software\ConEmu\.Vanilla]
  "SlideShowElapse"=dword:00001000

Maximus5 - 2009.01.23

* Неизвестно почему - отвалилась установка шрифта в консоли. По какой-то причине OpenProcess в setconsoleinfo.cpp возвращал NULL (если кто хочет - поковыряйтесь). Если сие так - используем (-1)
* Вернулась версия для FAR Ansi. Плагин conemu.dll может использоваться как в FAR 1.71 build 2470 (и выше), так и в FAR 2.0 build 748 (и выше).
* Вроде починил изменение размера окна при появлении табов.
* Табы не работали, если не устанавливался родитель для окна консоли.
* Могли падать при включенных табах если полный путь к файлу в редакторе был длинным.
* Если случилось несчастье и ConEmu упал - отображается соответствующее сообщение и (после OK) процесс FAR.exe прибивается (раньше оставался висеть), консоли все-равно уже нету.
* Для запускаемого из-под ConEmu процесса устанавливается переменная окружения ConEmuHWND (пример: ConEmuHWND=0x000b0a9c). Может кому понадобится...

! Вроде бы курсор во Viewer мигает при появлении табов?
! Глюки с буферами, сдвигами экрана, черным фоном под частично прорисованными панелями и т.п лезут если консоль физически не влезает в экран. Чтобы этого не было - выберите шрифт поменьше через меню 'Console properties'

Maximus5 - 2009.01.21

* Иногда после Shell'овского drop на пассивную панель отрабатывал drop в самом FAR (хотя может и не до конца вылечилось?)
* Shell'овский drop мог отрабатывать два и более раз подряд
* Убран двойной слеш при перетаскивании с корня диска
* Плагин мог валиться, если путь перетаскиваемого превышал MAX_PATH, или текущий путь превышал MAX_PATH при бросании (ежели такое может быть в FAR'е)
! К сожалению, FCTL_GETPANELSHORTINFO не заполняет lpwszCurDir
* Флажок 'Copy by default' теперь имеет три состояние.
  Если выключен - элемент ВСЕГДА перемещается, в том числе и в другие приложения.
  Если включен - ВСЕГДА копируется, в том числе и в другие приложения.
  При третьем состоянии - копируется при Drop в панель FAR, а при Drop в другое приложения - определяется приложением-приемником (для проводника это копированием между дисками и перемещение в пределах одного диска).
  Для облегчения понимания действий в предыдущих строках не упоминается модификатор - нажимая Ctrl можно переключать действие как при Drag (если только флажок не в третьем состоянии) так и при Drop.
* Добавлены ключики /SetParent и /DontSetParent (aka /Windows7). В Windows7 и выше по умолчанию родитель консольного окна не меняется, отрицательное значение /BufferHeight более не влияет. Установка родителя требуется для некоторых плагинов: PictureView, Conman, ...

Maximus5 - 2009.01.20

* Убраны задержки при таскании диалогов
* Всплывающее меню теперь всплывает при задержке и отпускании правой кнопки, и его можно убрать клавишей Esc
* При включенном 'RightClick for context menu' теперь можно выделять файлы двигая мышкой с зажатой правой кнопкой
* При попытке выделить блок через Alt+Ins - включался Drag'n'Drop
* WM_MOUSEMOVE беспрерывно посылался в консоль, даже если курсор мышки не двигался (хм? может так и надо было?)
* ConEmu рушился, если длина заголовка консоли превышала MAX_PATH символов
* Убрана ошибка изменения размера окна после появления 'табов'

Maximus5 - 2009.01.19

* Уменьшен по высоте диалог настроек
* Добавлен пункт меню 'Console properties'
* Добавлена обработка параметра /BufferHeight (сборка NightRoman)






alex_itd - 2009.01.18

* вроде поправил глюк с AltEnter
* частично переписал общение с плагином через пайпы
* детект закрытия фара как советовал DrKnS (проверяйте Updater)
* отключил XP темы у прогресс баров (темами не пользуюсь, проверить не могу) (чуть попозже сделаю подстройку цвета под палитру)
	
* Drag'n'Drop теперь работает только на файловых панелях 
* крыжик в настройках Drag'n'Drop 'Copy by default'
* фикс переключения раскладки от Maximus5 
* фикс мелких шрифтов от NightRoman
	  


= 2009.01.18 === (NightRoman changelog below) ===

*) Решена проблема отрисовки больших окон с мелкими шрифтами, иными словами
большого буфера данных, на котором функции ReadConsoleOutput*() не работают.
Идея построчного чтения буфера заимствована из FAR исходников, но этот режим
включаем только при сбоях, а не при превышении фиксированного лимита, как там.

*) Добавлены конфигурации, что позволяет иметь разные наборы настроек для
разных программ или тех же программ, но в разных окнах. Конфигурация задается
только в командной строке параметром /Config ConfigName, в реестре создается
подключ ConEmu\ConfigName, где и хранятся индивидуальные настройки. Пример:

 ConEmu /Config ScrollMode /BufferHeight 9999 /Cmd PowerShell.exe

использует существующую (или создает новую, если будет сохранение опций)
конфигурацию 'ScrollMode'. Там в диалоге настроек заточим окно под вкусы
консоли с прокрукой, а не Фара: настройки порой хочется иметь разные.

*) Добавлен файл About-ConEmu.txt - микро хелп с официальной и технической
информацией, а то техническая нигде толком и не упомянута кроме форума.

*) В прошлой неупомянутой тут версии для режима с высотой буфера устранены
скачки выделения мышью. Это сделано вычурно, но работает, и другие пути не
найдены - невидимое настоящее окно консоли динамически двигается вместе с мышью
так, чтобы относительные координаты мыши в нем соответствовали текущим в
видимой виртуальной консоли - так удается перехитрить неизвестно что, но от
чего выделение могло прыгать.


= Experimental BufferHeight and some fixes 2008.07.03 =

ЗАПУСК С УСТАНОВКОЙ ВЫСОТЫ БУФЕРА КОНСОЛИ (РЕЖИМ ПРОКРУТКИ)

Дополнительный ключ: /BufferHeight <высота буфера>. Примеры:
conemu /BufferHeight 9999 /cmd cmd.exe
conemu /bufferheight 1000 /cmd powershell.exe -noexit myscript.ps1

Если команда /cmd не задана, берется сохраненная команда из реестра, если есть,
а если нет, то в режиме прокрутки запускается 'cmd', а в стандартном режиме
сначала пытаемся запустить 'far', потом 'cmd'.

Проверка на слишком маленькую или слишком большую заданную высоту буфера не
делается, рекомендуется выбирать ее так, что она заведомо больше высоты окна (в
строках), но не больше 9999, что является магическим ограничением высоты буфера
в виндовом диалоге настроек консоли.

Режим прокрутки предназначен в первую очередь для интерактивных сессий в
оболочках типа Cmd или PowerShell и не предназначен для программ типа FAR.
FAR, как и раньше следует запускать без всяких /BufferHeight - при этом
установка родителя окна консоли ДЕЛАЕТСЯ, то есть плагины, которые этого
ожидают, это и получают.

ПРИМЕЧАНИЕ: если величина /BufferHeight отрицательная, то это является
указанием принудительно установить родителя консольного окна. Это может быть
нужно, например, для нормальной работы приложений или плагинов FAR, которые
ожидают, что у консоли родительское окно - это окно ConEmu. В таком режиме в
процессе выделения мышью выделение может скакнуть в левый верхний угол - как
бороться - пока неясно, но если продолжать выделение, оно 'восстанавливается'.
Фиксится это пока не будет, ибо по нормальному приложения должны находить окно
ConEmu более универсальным способом (от hoopoe, см. форум по ConEmu).

ОПИСАНИЕ РЕЖИМА ПРОКРУТКИ

*) Окно имеет стандартную вертикальную полосу прокрутки.
*) Управление прокруткой с клавиатуры:
- CtrlPgUp, CtrlPgDn листают страницы вверх-вниз
- CtrlUp, CtrlDn прокручивают вверх-вниз построчно
*) Работа с выделением только мышью: выделение - левой кнопкой с перемещением,
копирование и вставка - правой кнопкой.

ПРОЧИЕ ИЗМЕНЕНИЯ

*) Исправлен мелкий дефект в отрисовке курсора: он мог ошибочно оставаться
отрисованным в поле ввода после перехода с поля ввода на кнопку или другой
элемент диалога, при активации которого курсор должен скрываться.

ТЕХНИЧЕСКИЕ ПОДРОБНОСТИ

*) Реализована отрисовка выделения (работает только в режиме прокрутки).
*) В режиме прокрутки положение окна консоли подгоняется под положение мыши -
это нужно для корректной работы выделения в оригинальной консоли.
*) В режиме прокрутки при старте устанавливаем QuickEdit режим, это нужно для
возможности выделения мышью в оригинальной консоли.
*) Установка параметров окна консоли в буфер режиме (предложено hoopoe): при
первом вызове устанавливаем высоту буфера /BufferHeight, при последующих смотрим
на наличие вертикальной прокрутки: если есть, то сохраняем текущую высоту буфера
(она может быть уже и не равна /BufferHeight), иначе подгоняем под высоту окна.
*) WM_MOUSEWHEEL теперь обрабатывается как событие мыши, нужно для прокрутки.
*) WM_RBUTTONUP НЕ обрабатывается (как и было раньше), чтобы избежать
нежелательного появления консольного меню в некоторых ситуациях. Добавлен
комментарий в коде.
*) WM_RBUTTONDBLCLK преобразовывается в WM_RBUTTONDOWN (как и было раньше). По
задумке Zoin это помогает быстро быделить и тут же развыделить элемент панели
Фара двойным правым кликом (не знаю зачем, но считаем, что автору видней).
Добавлен комментарий в коде.



= Version 2008.03.26 =

ПОНЕНЦИАЛЬНАЯ ПРОБЛЕМА ПЕРВОЙ ОТРИСОВКИ

При размерах окна равных дефолтным размерам консоли теоретически была возможна
неправильная первая отрисовка некоторых случайных символов (баг оптимизации).
Исправлено.

ИЗМЕНЕНИЯ В ЛОГИКЕ ОТРИСОВКИ КУРСОРА

При потере фокуса окна курсор оставался видимым или невидимым в зависимости от
его текущего состояния. Стандартное же поведение для неактивного окна - гасить
курсор. Сделано по стандартному.

Символ под курсором и некоторые идущие за ним иногда рисовались даже если это не
нужно; исправлено. Прирост скорости небольшой, но все ж так лучше.

ИСПРАВЛЕНА НАСТРОЙКА ШРИФТА BOLD

Настройка сохранялась, но считывалась неверно - исправлено.

ТЕХИНФО: АЛЬТЕРНАТИВНЫЙ ШРИФТ РАМОК

[HKEY_CURRENT_USER\Software\ConEmu\.Vanilla]
"FontName2"="Courier New"
"FontSizeX2"=hex:0b,00,00,00

FontName2 задает альтернативный шрифт рамок, 'Lucida Console' по умолчанию.
Однако, при основном шрифте, например, 'Consolas' спец. символы оказываются
шире, чем надо, и тогда 'Courier New' выглядит неплохой заменой.

В зависимости от разных параметров одного указания шрифта рамок может быть
недостаточно, и для точной настройки надо еще подогнать его ширину, то есть
параметр FontSizeX2. Демо: основной шрифт 'Consolas' 16 x 10, тогда для
рамочного 'Courier New' его ширина почему-то должна быть 11 (0xB).

ПРОЧИЕ КОСМЕТИЧЕСКИЕ ИЗМЕНЕНИЯ

Меню: текст &Settings заменен на S&ettings, чтобы избежать конфликта с хоткеем
пункта &Size в режиме обычного окна.

Слегка упрощена отрисовка с фоновой картинкой, когда происходит только
перемещение курсора, в комстроке, например.

Кое-где устранены лишние вспомогательные вызовы установки размера буфера консоли
(по-моему, лишние, но если у Zoin были на это виды - решать ему).



= Version 2008.02.23 =

ИЗМЕНЕНА ЛОГИКА ЗАПУСКА ПРИЛОЖЕНИЯ

Было так: если команда пустая, то сначала запускается она, и в случае сбоя (а он
всегда) запускается Far или Cmd. Итого всегда лишняя попытка запустить пустую
команду. Если команда не пустая, но не запускается, то вместо сообщения о сбое
запускается Far или Cmd; это и нелогично, и может создать иллюзию, что команда
отработала, например, если конечной целью и был запуск Фара, но сначала должно
было выполниться что-то еще, что не отработало. Предлагается так: если команда
пуста, то запускаем Far или Cmd, если не пуста - запускаем ее, а в случае сбоя -
сообщаем об ошибке и выходим.

ТЕХИНФО: АЛЬТЕРНАТИВНЫЙ ШРИФТ ДЛЯ ИСПРАВЛЕНИЯ РАМОК

[HKEY_CURRENT_USER\Software\ConEmu\.Vanilla]
"FontName2"="courier new"

Задает альтернативный шрифт для исправления рамок; по умолчанию используется
шрифт 'lucida console', который неплох для самих рамок, но жирноват для прочих
специальных символов, отчего они слегка наезжают на соседей по ширине. 'courier
new' выглядит неплохой заменой, например, если основной шрифт 'consolas'.



= Version 2008.02.21 =

УВЕЛИЧЕНА СКОРОСТЬ ОТРИСОВКИ

В VirtualConsole::Update не перерисовываем символы, которые не изменились,
при этом делаем не только глобальную проверку в самом начале, но проверяем
каждый символ и атрибуты в самом процессе в цикле по строке. Это позволяет
избежать изрядного числа перерисовок. Особо проверяем и перерисовываем
символ под старой позицией курсора. Однако, если уже начали рисовать, то
рисуем максимум подходящих символов включая и неизменные (проверено, так
быстрее, чем несколько раз отрисовывать разрозненные цепочки).

Render time (округлено на глазок, в худшую для новой версии сторону):
*) В панелях старый вариант - 1000000 на любой операции, новый вариант -
набор в ком. строке - 2300, навигация вверх-вниз по файлам без прокрутки -
2500, с прокруткой - 150000.
*) В редакторе старый вариант - 850000 при любой операции, в новой версии -
перемещение без прокрутки - обычно не более 3000, с прокруткой зависит от
длины строк, ширины экрана и расцветки, на типичном файле с исходным кодом с
не очень длинными строками и с колорером ускорение в 3-4 раза.
*) Оптимизирована и форсированная перерисовка (весь экран, например, при
смене опций в диалоге), но разница в производительности не так заметна,
конечно.

Еще устранены несколько вероятно лишних перерисовок при запуске (один вызов,
когда окно еще не окончательное и один или два лишних прохода из-за курсора)

ИСПРАВЛЕН СИМВОЛ ПОД КУРСОРОМ В РЕЖИМЕ РАМОК

Наблюдался нежелательный эффект - символ под курсором в режиме исправления
рамок иногда рисовался юникодным фонтом (видимо, последним выбранным до
этого для рамок). Исправлено.



= Author =

Roman Kuzmin (aka NightRoman)
http://code.google.com/p/farnet/
PowerShell and .NET in FAR Manager
